unit Protobro;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Itable, Fvcbrows, Itabbrow, ExtCtrls, Buttons, Itblctrl,
  StdCtrls, ITabDat, ITABExcl, Itabdbas;

type
  TProtoBroForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ExitBttn: TSpeedButton;
    ITable1: TITable;
    IsamDataSource1: TIsamDataSource;
    SpeedButton1: TSpeedButton;
    IsamHeader1: TIsamHeader;
    ITabBrowser1: TITabBrowser;
    IsamNavigator1: TItabNavigator;
    ISAMText1: tisamText;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ISAMKeyCtrl1: TISAMKeyCtrl;
    ITable2: TITable;
    IsamDataSource2: TIsamDataSource;
    ITabBrowser2: TITabBrowser;
    IsamHeader2: TIsamHeader;
    ITable3: TITable;
    IsamDataSource3: TIsamDataSource;
    IsamHeader3: TIsamHeader;
    ITabBrowser3: TITabBrowser;
    Panel3: TPanel;
    IsamNavigator2: TItabNavigator;
    ISAMKeyCtrl2: TISAMKeyCtrl;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Panel4: TPanel;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    IsamNavigator3: TItabNavigator;
    ISAMKeyCtrl3: TISAMKeyCtrl;
    ExcelExport: TSpeedButton;
    ExcelExportCtrl1: ExcelExportCtrl;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    ISAMText2: tisamText;
    DBaseExportCtrl1: DBaseExportCtrl;
    procedure ExitBttnClick(Sender: TObject);
    procedure ITabBrowser1DblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure ITabBrowser2DblClick(Sender: TObject);
    procedure ITabBrowser3DblClick(Sender: TObject);
    procedure ExcelExportClick(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

Const
  BrowserOnly : Boolean = False;
var
  ProtoBroForm: TProtoBroForm;

implementation

{$R *.DFM}

Uses ProtoEdi, Protoed2, Protoed3, ITabTool, Filer;

{$I KUNDEN.TYP}
Function KUNDENRECORDKeyProc(Var Daten; KeyNr:Word): IsamKeyStr; far;
var s : StriNg;
begin
  s:= '';
  With KUNDENRECORD(Daten) do begin
    case KeyNr of
      1: S:=F(KUNDENNUMMER,6);
      2: S:=F(UPSTR(SORTIERBEGRIFF),12);
      3: S:=F(UPSTR(NAME1),10)+F(UPSTR(NAME2),10)+F(Datestr(Letztes_RDatum),10);
      4: S:=F(UPSTR(STRASSE),30);
      5: S:=F(TELEFON,15);
    end;
  end;
  KUNDENRECORDKEYPROC:= S;
end;



procedure TProtoBroForm.ExitBttnClick(Sender: TObject);
begin
  Close;
end;



procedure TProtoBroForm.FormCreate(Sender: TObject);
begin
  ITable1.Active:= True;
  {
  Soll die externe Keyproc genommen werden:
  ITable1.KEY_PROC:= KundenRecordKeyProc;
  }
  ITable2.Active:= True;
  ITable3.Active:= True;
end;

procedure TProtoBroForm.FormDestroy(Sender: TObject);
begin
  ITable1.Active:= False;
  ITable2.Active:= False;
  ITable3.Active:= False;

end;

procedure TProtoBroForm.SpeedButton2Click(Sender: TObject);
begin
 ITable1.Rebuild;
end;

procedure TProtoBroForm.SpeedButton3Click(Sender: TObject);
begin
 ITable1.KEY_PROC:= KundenRecordKeyProc;
  ITable1.IID[1]. allowDupk := False; ITable1.IID[1].Keyl := 6;
  ITable1.IID[2]. allowDupk := True;  ITable1.IID[2].Keyl := 12;
  ITable1.IID[3]. allowDupk := True;  ITable1.IID[3].Keyl := 30;
  ITable1.IID[4]. allowDupk := True;  ITable1.IID[4].Keyl := 30;
  ITable1.IID[5]. allowDupk := True;  ITable1.IID[5].Keyl := 15;
  ITable1.Rebuild;
end;

procedure TProtoBroForm.SpeedButton1Click(Sender: TObject);
var
 ss : String;
begin
  {ss:= InputBox('Filename - Eingabe', 'Geben Sie den Tabellennamen ein:', ITable1.TableName);}
  Itable1.NewIsamTable(True);
end;

procedure TProtoBroForm.SpeedButton5Click(Sender: TObject);
begin
 ITable2.Rebuild;
end;

procedure TProtoBroForm.SpeedButton4Click(Sender: TObject);
begin
  Itable2.NewIsamTable(True);
end;

procedure TProtoBroForm.SpeedButton7Click(Sender: TObject);
begin
  ITable3.Rebuild;
end;

procedure TProtoBroForm.SpeedButton6Click(Sender: TObject);
begin
  Itable3.NewIsamTable(True);
end;

procedure TProtoBroForm.ITabBrowser1DblClick(Sender: TObject);
begin
  If not BrowserOnly then
  begin
    ProtoEdiForm := TProtoEdiForm.Create(self);
    Try
      ProtoEdiForm.ITable4 := Itable1;
      ProtoEdiForm.IsamDatasource4.Dataset := Itable1;
      ProtoEdiForm.ShowModal;
    Finally
      ProtoEdiForm.Free;
    end;
  end else ModalResult := mrOk;
end;

procedure TProtoBroForm.ITabBrowser2DblClick(Sender: TObject);
begin
  If not BrowserOnly then
  begin
    ProtoEdi2Form := TProtoEdi2Form.Create(self);
    Try
      ProtoEdi2Form.ITable5 := Itable2;
      ProtoEdi2Form.IsamDatasource5.Dataset := Itable2;
      ProtoEdi2Form.ShowModal;
    Finally
      ProtoEdi2Form.Free;
    end;
  end else ModalResult := mrOk;
end;

procedure TProtoBroForm.ITabBrowser3DblClick(Sender: TObject);
begin
  If not BrowserOnly then
  begin
    ProtoEdi3Form := TProtoEdi3Form.Create(self);
    Try
      ProtoEdi3Form.ITable6 := Itable3;
      ProtoEdi3Form.IsamDatasource6.Dataset := Itable3;
      ProtoEdi3Form.ShowModal;
    Finally
      ProtoEdi3Form.Free;
    end;
  end else ModalResult := mrOk;

end;

procedure TProtoBroForm.ExcelExportClick(Sender: TObject);
begin
  ExcelExportCtrl1.Execute;
end;

procedure TProtoBroForm.SpeedButton8Click(Sender: TObject);
Var I : Integer;
begin
   I := 1;
   ITable3.First;
   While not ITable3.AtEof do
   Begin
     ITable3.Edit;
     ITable3.FieldByName('Preis').AsFloat := 17.11;
     ITable3.FieldByName('Preis').AsFloat := 17.11;
     ITable3.FieldByName('Menge').AsFloat := i;
     ITable3.FieldByName('GPreis').AsFloat:= 17.11*I;
     ITable3.Post;
     Itable3.Next;
     inc(i);
   end;
   ITable3.BFirst; {Browser auf die 1. Position setzen}
end;

procedure TProtoBroForm.SpeedButton9Click(Sender: TObject);
begin
  DBaseExportCtrl1.Execute;
end;

end.



