unit Itab2dbf;

interface

uses Forms, Itable, Controls,
  StdCtrls, Buttons, Gauges, Classes, ExtCtrls, Dialogs, Itab_Usr;

type

  TDBFTransferDlg = class(TForm)
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Gauge1: TGauge;
    StartBttn: TBitBtn;
    ITable1: TITable;
    IsamDataSource1: TIsamDataSource;
    SaveDialog1: TSaveDialog;
    Label1: TLabel;
    procedure CancelBtnClick(Sender: TObject);
    procedure StartBttnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
    Data,Dup    : Pointer;
    HTable1 	: dbfobj;
    Constructor Create(AOwner: TComponent; ITab1: TITable);
  end;

var
  DBFTransferDlg: TDBFTransferDlg;

implementation

Uses Filer, ITabTool, ITblCons, ItabDat, SysUtils;
{$R *.DFM}

Constructor TDBFTransferDlg.Create(AOwner: TComponent; ITab1: TITable);
begin
  Inherited Create(aOwner);
  ITable1:= ITab1;
  IsamDataSource1.DataSet:= ITable1;
end;

procedure TDBFTransferDlg.CancelBtnClick(Sender: TObject);
begin
  ModalResult:= MrCancel;
end;

procedure TDBFTransferDlg.StartBttnClick(Sender: TObject);
var x,r: Longint;
    AltProgress,NeuProgress,ii: Integer;
    S  : ShortString;
    Fld: TIsamField;
    i : Integer;
    FeldTyp : Char;
begin
  if DBFTransferDlg.HTable1^.DBName = '' then exit;
  begin
    x:= 0;
    AltProgress:= 0;
    R := BtUsedRecs(ITable1.IFBPtr);
    ITable1.First;
    if (R > 0) and (ITable1.KeyStr >= ITable1.Von)
    and (ITable1.KeyStr <= ITable1.Bis) then
    begin
      While (x < R) and (IsamOk) and (not(ITable1.AtEof)) do begin
        inc(x);
        ITable1.Get;
        HTable1^.AppendBlank;
        For ii:= 1 to ITable1.Felder.Count-1 do
        begin
          Fld:= TIsamField(ITable1.Felder.Items[ii]);
          S:= Fld.AsString;
          if (Fld.Typ = ftBoolean) then  HTable1^.ReplFld(ii,'T')
          else begin
            if ((Fld.Typ = ftDate) or (Fld.Typ = ftWordDate)) and (Pos('?',S) > 0) then S:= '';
            if S <> '' then HTable1^.ReplFld(ii,S);
          end;
        end;
        ITable1.Next;
        if (Itable1.Von = '') and (ITable1.Bis = #255) then
        begin
          NeuProgress:= Round((x/R)*100);
          if AltProgress <> NeuProgress then begin
            AltProgress:= NeuProgress;
            Gauge1.Progress:= NeuProgress;
          end;
        end else WaitWindow(IntStr(x),'');
      end;
    end;
  end;
  CloseWait;
  Gauge1.Progress:= 100;
end;

procedure TDBFTransferDlg.FormCreate(Sender: TObject);
begin
  SaveDialog1.InitialDir := __Laufwerk;
end;

procedure TDBFTransferDlg.FormDestroy(Sender: TObject);
begin
  CloseDB(HTable1);
end;

end.
