Unit Itabbrow;
{copyright 1995,1996, 1997 by Stellberg Computer GmbH}
Interface
{$D+}
Uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls,
  LowBrows, Fvcbrows, Filer, ITable;

Type
{$IFNDEF VER90}
  ShortString     = String;
{$ENDIF}

  TIsamHeader = Class(Theader)
    Private
    Function GetNextName(const Value: Shortstring):Shortstring;
    Published
    Property OnDblClick;
  End;


  TITabBrowser = Class(TFvcBrowser)
  Private
    FHeader         : TIsamHeader;  {a normal header for your browser}
    FCtrlLink       : TITblCtrlLink;
    FColumn         : TStringList;  {a list of TUEBERSCHRIFTOBJECTS .. see ITABBRST.INT}
    FDataSource     : TIsamDataSource;   {the isamtable, that will be browsed}
    FKeySection     : Integer; { * Which header section are we searching on }
    FSeparatorChar  : Char;    { * Default '^'  }
    FAllowIncss     : Boolean; { * }
    FIncSSColor     : TColor;  { * }
    FIncSSTxtColor  : TColor;  { * }
    FInit           : Boolean;
    KeyFlag         : Boolean;
    FAutoShow       : Boolean;
    Procedure SetDataSource(Const Value: TIsamDataSource);
    Procedure SetColumn(Const Value: TStringList);
    Function GetRow(Sender: TObject; Var RR: RowRec): Integer;
    Procedure WMSize(Var Message: TWMSize);  Message WM_SIZE;
    Procedure WMMove(Var Message: TWMMove); Message WM_MOVE;
    Property BrowserInit : Boolean Read  FInit Write FInit Default False;
    Procedure FirstUsrInit(Sender: TObject);
  Protected
    procedure ApplyFHeader;
    Procedure KeyDown(Var Key: Word; Shift: TShiftState); Override;
    Procedure KeyUp(Var Key: Word; Shift: TShiftState); Override;
    Procedure KeyPress(Var Key: Char); Override;
    Function  WriteStringOut(Var S      : BRLRowEltString;
                                 LineNr : Word;
                                 XOfs   : Integer): Word; Override;
    Procedure ShowErrorOccured(EClass: Integer); Override;
    Function GetHighKey: GenKeyStr;
    Function GetLowKey: GenKeyStr;
    Procedure SetHighKey(Value: GenKeyStr);
    Procedure SetLowKey(Value: GenKeyStr);
    Procedure BrwRowChanged(Sender: TObject);
  Public
    BaseLKey    : IsamKeyStr;
    BaseHKey    : IsamKeyStr;
    IncSS       : IsamKeyStr;{Incremental search string }
    FTextMargin : TRect;
    Procedure DoTakeAction(Action: IsamEvent; Info: Longint);
    Procedure ResizeHeader;  {
                              muSt be called after you changed the
                              field widths by drag and drop in your
                              browser
                             }
    Function ReadIni: Integer;
                             {
                              will read browser-settings from an ini-file,
                              muSt be called after creating the form and
                              before showing the browser-form.
                             }
    Procedure SetupBrowser(aParent: TForm);
                             {
                              will show the browser-setup-dialog,
                              see ISBRINST.INT
                             }
    Function GetLowBrowser: PLowWinBrowser;
    Property HighKey: GenKeyStr Read GetHighKey Write SetHighKey;
    Property LowKey: GenKeyStr Read GetLowKey Write SetLowKey;
    Procedure HeaderSized(Sender: TObject; ASection, AWidth: Integer);
    Procedure HeaderClick(Sender: TObject);
  Published
    { Published declarations }
    Constructor Create(AOwner: TComponent); Override;
    Destructor Destroy; Override;
    Procedure SetHeader(Value: TIsamHeader);
    Procedure Same_Record(R: LongInt);
    Property AutoShow       : Boolean Read FAutoShow Write FAutoShow Default True; 
    Property Header         : TIsamHeader Read FHeader Write SetHeader;
    Property Column         : TStringList Read FColumn Write SetColumn;
    Property DataSource     : TIsamDataSource Read FDataSource Write SetDataSource;
    Property KeySection     : Integer Read FKeySection Write FKeySection;
    Property SeparatorChar  : Char Read FSeparatorChar Write FSeparatorChar;
    Property AllowIncSS     : Boolean Read FAllowIncSS Write FAllowIncSS;
    Property IncSSColor     : TColor Read FIncSSColor Write FIncSSColor;
    Property IncSSTxtColor  : TColor Read FIncSSTxtColor Write FIncSSTxtColor;
    Procedure ClearIncss;
    Property OnBuildRow: TBuildRowEvent Read FOnBuildRow Write FOnBuildRow;
  End;

Function GetAppName: Shortstring;  {procedure, to get the name of your application during runtime}

Implementation

Uses IniFiles, StdCtrls, ITblCons, ITabBrSt, ITabTool;

Var AppName, ss: Shortstring;
    KN : Byte;
    SKeyStr         : Shortstring;
    RRecNo          : Longint;

Const JustLeftChar   = #243;
      JustCenterChar = #242;
      JustRightChar  = #241;

Function GetAppName: Shortstring;
Var G: Shortstring;
    xPos: Integer;
Begin
  G:= Application.ExeName;
  xPos:= Pos('\',G);
  While xPos > 0 do Begin
    Delete(G,1,xPos);
    xPos:= Pos('\',G);
  End;
  xPos:= Pos('.',G);
  if xPos > 0 then G:= Copy(G,1,xPos-1);
  AppName:= G;
  GetAppName:= G;
End;


Function TIsamHeader.GetNextName(const Value: Shortstring):Shortstring;
var
 L1: integer;
 a: string[4];
begin
  Result := copy(Value,2,255);
  a := '1';
  L1 := 1;
  while true do
  if owner.findcomponent(Result+a)=nil then
  begin
    Result := Result+a;
    break;
  end
  else
  begin
    inc(L1);
    a := inttostr(L1);
  end;
end;

procedure TITabBrowser.ApplyFHeader;
var L1:Integer;
begin
  for L1 := 0 to owner.ComponentCount-1 do
  begin
    if Owner.Components[L1] is TIsamHeader then
    begin
      FHeader := TIsamHeader(Owner.Components[L1]);
      SetHeader(FHeader);
      break;
    end;
  end;
end;


Constructor TItabBrowser.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FCtrlLink := TITblCtrlLink.Create(Self);
  FCtrlLink.FOnAnyEvent := DoTakeAction;
  FAllowIncSS := True;
  FAutoShow:= True;
  KeyFlag:= False;
  IncSS := '';
  SeparatorChar := '^';
  TabStop:= True;
  BaseLKey := LowKey;
  BaseHKey := HighKey;
  FIncSSColor := clRed;
  FIncssTxtColor := clWhite;
  FColumn:= TStringList.Create;
  OnbuildRow:= GetRow;
  OnFirstUserInit:= FirstUsrInit;
  OnRowChanged:= BrwRowChanged;
  BrowserInit	:= False;
  RRecNo:= 0;
  SKeyStr := '';
  FHeader := Nil;
  KeyNumber := 1;
  if AOwner.Name = '' then exit;
  if csDesigning in ComponentState then begin
    {ApplyFHeader;
    if FHeader = Nil then begin
      FHeader := TIsamHeader.create(Owner);
      with FHeader do begin
        Name := GetNextName(ClassName);
        Top := 41;
        Height := 25;
        Left := 0;
        Width := TWinControl(Owner).Width-8;
        Parent := TWinControl(Owner);
      end;
    end;}
  end;
End;

procedure TITabBrowser.FirstUsrInit(Sender: TObject);
begin
  ReadIni;
  if DataSource <> NIL then begin
    if DataSource.DataSet <> NIL then begin
      SetAndUpdateBrowserScreen(SKeyStr,RRecNo);
    end;
  end;
end;

Function TItabBrowser.GetLowBrowser: PLowWinBrowser;
Begin
  Result:= BrowserPtr;
End;

Destructor TItabBrowser.Destroy;
var AktDir: Shortstring;
    BrwIni: TIniFile;
    K     : Integer;
Begin
  AktDir:= ExtractFilePath(Application.ExeName);
  BrwIni:= TIniFile.Create(AktDir + GetAppname+'.INI');
  K:= 1;
  if FDataSource <> Nil then begin
    if DataSource.DataSet <> NIL then begin
      K:= DataSource.DataSet.KeyNo;
    end;
  end;
  BrwIni.WriteInteger(Name+'Key','KeyNo',K);
  BrwIni.Free;
  SetDatasource(Nil);
  FCtrlLink.Free;
  FCtrlLink := Nil;
  FColumn.Free;
  BrowserInit := False;
  RRecNo := 0;
  SKeyStr := '';
  if CSDesigning in ComponentState then begin
    {if Assigned(FHeader) then begin
      Header:= NIL;
    end;}
  end;
  Inherited Destroy;
End;

Procedure TItabBrowser.SetHeader(value: TIsamHeader);
Begin
  FHeader:= Value;
  if Assigned(FHeader) then Begin
    FHeader.Font.Name:= Font.Name;
    FHeader.Font.Size:= Font.Size;
    FHeader.Width := Self.Width;
    FHeader.Left  := Self.Left;
    FHeader.Top   := Self.Top-25;
    FHeader.Height:= 25;
    FHeader.OnSized:= HeaderSized;
    FHeader.OnDblClick  := HeaderClick;
    FHeader.Visible := True;
  End;
End;


Procedure TITabBrowser.HeaderSized(Sender: TObject; ASection, AWidth: Integer);
Begin
  ResizeHeader;
  SetAndUpdateBrowserScreen('',0);
End;

Procedure TITabBrowser.BrwRowChanged(Sender: TObject);
Begin
  if Assigned(FDatasource) then Begin
    if FDataSource.DataSet <> NIL then begin
      if KeyFlag = False then begin
        Datasource.DataSet.RecNo:= GetCurrentDatRef;
        FDatasource.DataSet.Get;
        FDataSource.DataSet.EventNotify(deDataChange,5);
      end;
    end;
  End;
End;

Procedure TITabBrowser.HeaderClick(Sender: TObject);
Begin
  SetupBrowser(Application.MainForm);
  SetAndUpdateBrowserScreen('',0);
End;

Function TItabBrowser.ReadIni: Integer;
Var BrwListe,SListe: TStringList;
    BrwIni: TIniFile;
    K,i,idx,Code: Integer;
    {$IFDEF VER90}
    Nam,AktDir,LStr: ShortString;
    {$ELSE}
    Nam,AktDir,LStr: Shortstring;
    {$ENDIF}
    x,Len: Longint;
    aVis : Boolean;
    Fld  : TIsamField;
Begin
  AktDir:= ExtractFilePath(Application.ExeName);
  {if not exist(AktDir + GetAppName+'.INI') then
  Begin
    SetupBrowser(Application.MainForm);
  End;}
  K:= 1;
  BrwIni:= TIniFile.Create(AktDir + GetAppName+'.INI');
  BrwListe:= TStringList.Create;
  SListe:= TStringList.Create;
  idx:= 0;
  K:= BrwIni.ReadInteger(Name+'Key','KeyNo',1);
  BrwIni.ReadSection(Name,BrwListe);
  if BrwListe.Count > 0 then Begin
    for i:= 0 to BrwListe.Count-1 do Begin
      LStr:= BrwIni.ReadString(Name,BrwListe[i],'');
      aVis:= True;
      if Pos(',',LStr) > 0 then Begin
        Val(Copy(LStr,1,Pos(',',LStr)-1),Len,Code);
        Delete(LStr,1,Pos(',',LStr));
        if Pos(',',LStr) > 0 then begin
          Val(Copy(LStr,1,Pos(',',LStr)-1),Idx,Code);
          Delete(LStr,1,Pos(',',LStr));
          if Copy(LStr,1,1) = '0' then aVis:= False;
        end
        else Val(LStr,Idx,Code);
      End
      Else Begin
        Idx:= i+1;
        Val(LStr,Len,Code);
      End;
      SListe.AddObject(BrwListe[i],TUeberschriftObject.Init(BrwListe[i],Idx,Len,aVis));
    End;
    Column:= SListe;
  End
  else begin
    if DataSource <> NIL then begin
      if DataSource.DataSet <> NIL then begin
        if DataSource.DataSet.Felder.Count > 0 then begin
          Idx:= 1;
          for i:= 1 to DataSource.DataSet.Felder.Count-1 do begin
            Fld:= DataSource.DataSet.Felder.Items[i];
            Inc(idx);
            SListe.AddObject(Fld.Name,TUeberschriftObject.Init(Fld.DisplayLabel,Idx,Fld.DisplayWidth,Fld.Visible));
          end;
          Column:= SListe;
          FDataSource.DataSet.MyInit := True;
        end;
      end;
    end;
  end;
  SListe.Free;
  BrwListe.Free;
  BrwIni.Free;
  if Assigned(FDataSource) then begin
    if Datasource.DataSet <> NIL then
    begin
      if K <> KeyNumber then begin
        if CanCallLowBrowser then begin
          if not FDataSource.DataSet.MyInit then
          Begin
            KeyNumber:= K;
            Datasource.DataSet.KeyNo:= K;
            {KeyNumber:= K;}
            SetAndUpdateBrowserScreen(FDataSource.DataSet.KeyStr,FDataSource.DataSet.RecNo);
            FDataSource.DataSet.MyInit := True;
          End;
        end;
      end;
    end;
  end;
  Result:= K;
  if FDataSource.DataSet.MyInit then KeyNumber := Datasource.DataSet.KeyNo;
End;

Procedure TITabBrowser.Same_Record(R: LongInt);
Begin
  if Assigned(FDatasource) then
  Begin
    if R <> FDatasource.DataSet.RecNo then
    SetAndUpdateBrowserScreen('',R);
  End;
End;

Procedure TITabBrowser.DoTakeAction(Action: IsamEvent; Info: Longint);
var BrwIni: TIniFile;
    AktDir  : Shortstring;
    K       : Integer;
    Von,Bis : IsamKeyStr;
    Mymsg   : TNotifyEvent;
    b       : Boolean;
    form    : TForm;
    ActiveWindow : Hwnd;
Begin
    Case Action of
      deTableChange,
      deDataSetChange : Begin
                          if info = 1 then
                          If not BrowserInit then Begin
                            if Assigned(FDatasource) then Begin
                              if FDataSource.DataSet <> Nil then Begin
                                if FDataSource.DataSet.IFBPTR <> NIL then begin
                                  RRecno  := FDataSource.DataSet.RecNo;
                                  SKeyStr := FDataSource.DataSet.KeyStr;
                                  Von:= FDataSource.DataSet.Von;
                                  Bis:= FDataSource.DataSet.Bis;
                                  ConnectLowBrowser(New(PLowWinBrowser, Init(True, FDataSource.DataSet.IFBPTR,
                                  1, 50, 1, Von, Bis, FDataSource.DataSet.Data^, False )));
                                  if not assigned(FHeader) then Errorwindow(GetMess(67),'');
                                  {SetAndUpdateBrowserScreen(SKeyStr,RRecNo);}
                                  BrowserInit := True;
                                  FDataSource.DataSet.First;
                                end;
                              End;
                            End;
                          End;
                          if Assigned(FDatasource) then Begin
                            if FDataSource.DataSet <> Nil then Begin
                              if KeyNumber <> FDataSource.DataSet.KeyNo then begin
                                KeyNumber:= FDatasource.DataSet.KeyNo;
                              end;
                            end;
                          end;
                          serrorwindow('detableChange',sKeyStr);
                        End;
      deRangeChanged  : begin
                          if Assigned(FDataSource) then begin
                            if DataSource.DataSet <> NIL then begin
                              Von:= DataSource.DataSet.Von;
                              Bis:= DataSource.DataSet.Bis;
                              if LowKey <> Von then LowKey:= Von;
                              if HighKey <> Bis then HighKey:= Bis;
                            end;
                          end;
                        end;
      deRecordChange  : Begin
                          if Assigned(FDataSource) then FDataSource.DataSet.RecNo:= GetCurrentDatRef;
                          serrorwindow('RecordChange','');
                        End;
      deDestroy  :      Begin
                          Serrorwindow('Destroy','');
                          SetAndUpdateBrowserScreen(MyKeyStr,MyRecNo);
                        End;
      deUpdateState   : Begin
                          if Assigned(FDataSource) then
                          if FDataSource <> Nil then
                          begin
                            if (FDataSource.DataSet.State = dsAppend) or
                            (IsamState(Info) = dsAppend) then
                          end;
                          Serrorwindow('updateChange','');
                        End;
      deNavigate     : Begin
                         if GetParentForm(Self) = Screen.ActiveForm then begin
                          if Info = 0 then
                          SetAndUpdateBrowserScreen(FDataSource.DataSet.KeyStr,FDataSource.DataSet.RecNo);
                          if Info = 1 then
                          SetAndUpdateBrowserScreen('',0);
                          Serrorwindow('navigate','');
                         end;
                        End;
      deUpdateRecord  : Begin
                          serrorwindow('UpdateRecord','');
                        End;
      deOrderChange   : Begin
                          if Assigned(FDataSource) then Begin
                            if Datasource.Dataset <> NIL then begin
                              if KeyNumber <> DataSource.DataSet.KeyNo then begin
                                AktDir:= ExtractFilePath(Application.ExeName);
                                KeyNumber:= DataSource.DataSet.KeyNo;
                                ClearIncSS;
                                SetAndUpdateBrowserScreen(FDataSource.DataSet.KeyStr,FDataSource.DataSet.RecNo);
                                BrwIni:= TIniFile.Create(AktDir + GetAppname+'.INI');
                                K:= DataSource.DataSet.KeyNo;
                                BrwIni.WriteInteger(Name+'Key','KeyNo',K);
                                BrwIni.Free;
                              end;
                            end;
                          End;
                          Serrorwindow('OrderChange','');
                        End;
      deFieldChange   : Begin
                          serrorwindow('FieldCange','');
                        End;
      deDataSetScroll : Begin
                          if (GetParentForm(Self) = Screen.ActiveForm)
                          or (Autoshow = True) then begin
                            Case Info of
                              0: FirstPage;
                              1: LineUp;
                              2: LineDown;
                              3: LastPage;
                              4:
                            end; {of Case}
                          end;
                        End;
      deMasterSource  : if (GetParentForm(Self) = Screen.ActiveForm) or (Screen.ActiveForm = NIL) then begin
                         if Datasource <> NIL then begin
                          if Datasource.DataSet <> NIL then begin
                            if DataSource.DataSet.IFBPTR <> NIL then begin
                              Von := DataSource.DataSet.Masterkey;
                              if (Von <> Lowkey) then begin
                                ClearIncSS;
                                LowKey := von;
                                Bis:= von + #255;
                                HighKey := Bis;
                                SetandUpDateBrowserScreen(von,0);
                                lwUpdateVertScrollBar;
                                if (Datasource.Dataset.Von <> Von) or (DataSource.DataSet.Bis <> Bis) then begin
                                  DataSource.DataSet.MsgHandler:= False;
                                  DataSource.DataSet.Von:= Von;
                                  DataSource.DataSet.Bis:= Bis;
                                  DataSource.DataSet.MsgHandler:= True;
                                  {SetandUpdateBrowserScreen(von,0);}
                                end;
                              end
                              else SErrorwindow('mastersource','Von = LowKey');
                            end
                            else SErrorwindow(Name,'kein IFBPTR');
                          end
                          else SErrorwindow(Name,'Kein dataset');
                         end
                         else SErrorwindow(Name,'kein Datasource');
                        end;
    End;
End;

Procedure TItabBrowser.SetupBrowser(aParent: TForm);
Begin
  if FDatasource <> NIL then begin
    if FDataSource.DataSet <> NIL then begin
      IsamBrowserSetup(aParent,GetAppName,Name,FDataSource.DataSet);
      ReadIni;
      SetAndUpDateBrowserScreen('',0);
    end
    else Errorwindow('Setupbrowser','DataSet = NIL');
  end
  else Errorwindow('SetupBrowser','Datasource = NIL');
End;

Function TITabBrowser.GetRow(Sender: TObject; Var RR: RowRec): Integer;
Var S       : Shortstring;
    i,Fld,L : Integer;
    ss      : Shortstring;
    U       : TUeberschriftObject;
    JustChar: Char;
    R       : Real;
Begin
  Result := NoError;
  S := '';
  if Assigned(FDataSource) then Begin
    if FDataSource.DataSet.Active then Begin
      for i:= 0 to Column.Count -1 do Begin
        U:= TUeberschriftObject(Column.Objects[i]);
        if U.Visible then begin
          Fld:= U.idx;
          L:= U.Breite;
          if (Fld >= 0) and (Fld <= FDatasource.DataSet.Felder.Count) then begin
            if FDataSource.DataSet.FieldType(Fld) = ftReal then begin
              R:= FDataSource.DataSet.RealGetN(Fld);
              SS:= SimpleFormDezStr(R,FDataSource.DataSet.FieldLen(Fld),FDataSource.DataSet.FieldDec(Fld));
              {if Pos(',',SS) > 0 then SS[Pos(',',SS)]:= '.';}
            end
            else if FDataSource.DataSet.FieldType(Fld) = ftBoolean then begin
              SS:= F(FDataSource.DataSet.GetDat(Fld),L);
            end
            else ss:= F(FDataSource.DataSet.GetDat(Fld),L);
            S:= S + ss;
            JustChar:= JustLeftChar;
            if TIsamField(FDataSource.DataSet.Felder.Items[Fld-1]).Alignment = taRightJustify then JustChar:= JustRightChar
            else if TIsamField(FDataSource.DataSet.Felder[Fld-1]).Alignment = taCenter then JustChar:= JustCenterChar;
            S:= S + JustChar + SeparatorChar;
          end;
        end;
      End;
      if RR.Status <> NoError then Begin
        RR.Row := F('****  ' + RR.IKS, MaxCols);
      End Else Begin
        RR.Row:= ' '+S+#13;
      End;
    End;
  End;
End;

Procedure TItabBrowser.SetDataSource(Const Value: TIsamDataSource);
Begin
  BrowserInit := False;
  if FDataSource = Value then Exit;
  FCtrlLink.DataSource := Value;
  FDataSource:= Value;
  if FDatasource <> NIL then begin
    if FDataSource.DataSet <> Nil then DoTakeAction(deTableChange,2);
  End;
End;

Procedure TItabBrowser.SetColumn(Const Value: TStringList);
Var N,i,xLen,Code: Integer;
    SStr,TStr: Shortstring;
Begin
  FColumn.Assign(Value);
  if Assigned(FHeader) then FHeader.Sections.Clear;
  if Value <> Nil then Begin
    if FColumn.Count > 0 then Begin
      n:= 0;
      for i:= 0 to FColumn.Count-1 do Begin
        if FColumn.Objects[i] <> Nil then Begin
          With TUeberschriftObject(FColumn.Objects[i]) do Begin
            SStr:= Txt;
            xLen:= Breite;
            if (TUeberschriftObject(FColumn.Objects[i]).Visible) and (xLen > 0) then Begin
              FHeader.Sections.Insert(N,SStr);
              FHeader.SectionWidth[N]:= (xLen * 6)+5{8};
              inc(N);
            End;
          End;
        End;
      End;
    End;
  End;
End;

Procedure TItabBrowser.ResizeHeader;
Var idx,I,K,Len,x: Integer;
    AktDir,SStr: Shortstring;
    SListe: TStringList;
    BrwIni: TIniFile;
    U     : TUeberschriftObject;
    aVis  : Boolean;
Begin
  AktDir:= ExtractFilePath(Application.ExeName);
  if Assigned(FHeader) then Begin
    if FHeader.Sections.Count > 0 then Begin
      SListe:= TStringList.Create;
      BrwIni:= TIniFile.Create(AktDir + GetAppname+'.INI');
      K:= 1;
      if FDataSource <> Nil then begin
        if DataSource.DataSet <> NIL then begin
          K:= DataSource.DataSet.KeyNo;
        end;
      end;
      BrwIni.WriteInteger(Name+'Key','KeyNo',K);
      if Column.Count > 0 then Begin
        for i:= 0 to Column.Count-1 do Begin
          if Column.Objects[i] <> Nil then Begin
            U:= TUeberschriftObject(Column.Objects[i]);
            aVis:= U.Visible;
            x:= FHeader.Sections.Indexof(Column[i]);
            if x > -1 then Begin
              Len:= Round((FHeader.SectionWidth[x]-5{8})/6);
              if Len < 0 then Len:= 0;
              SStr:= FHeader.Sections[x];
              Idx:= U.Idx;
              SListe.AddObject(SStr, TUeberschriftObject.Init(SStr,idx,Len,aVis));
              SStr:= DezStr(Len)+','+DezStr(idx);
              if aVis then SStr:= SStr + ',1' else
              SStr:= SStr + ',0';
              if Len > 0 then BrwIni.WriteString(Name,FHeader.Sections[x],SStr);
            End
            Else Begin
              SStr:= U.Txt;
              Len:= U.Breite;
              Idx:= U.idx;
              SListe.AddObject(SStr,TueberschriftObject.Init(SStr,idx,Len,aVis));
            End;
          End
          Else Errorwindow(GetMess(68),Column[i]);
        End;
      End
      Else Errorwindow(GetMess(69),'');
      Column:= SListe;
      SListe.Free;
      BrwIni.Free;
    End;
  End;
  ReadIni;
  SetAndUpdateBrowserScreen('', 0);
End;

Procedure TItabBrowser.WMSize(Var Message: TWMSize);
Var W, H: Integer;
Begin
   Inherited;
   if FHeader <> NIL then begin
     FHeader.Top:= Self.Top-FHeader.Height;
     FHeader.Left:= Self.Left;
     FHeader.Width:= Self.Width;
   end;
   Message.Result := 0;
End;

Procedure TItabBrowser.WMMove(Var Message: TWMMove);
Var W, H: Integer;
Begin
   Inherited;
   if FHeader <> NIL then begin
     FHeader.Top:= Self.Top-FHeader.Height;
     FHeader.Left:= Self.Left;
     FHeader.Width:= Self.Width;
   end;
   Message.Result := 0;
End;

Procedure TItabBrowser.ShowErrorOccured(EClass: Integer);
Begin
  if EClass > 1 then Inherited showErrorOccured(EClass);
End;

Procedure TItabBrowser.ClearIncSS;
Begin
  { Make sure to call this before going to a new key number }
  IncSS := '';
  LowKey := BaseLKey;
  HighKey := BaseHKey;
End;

Function TItabBrowser.WriteStringOut(Var S : BRLRowEltString;
                                         LineNr : Word;
                                         XOfs : Integer) : Word;
Var
    SegmentString  : Shortstring;
    Just,i,j    : Integer;
    Rect   : TRect;
    x   : Integer;
    SegNum : Integer;
    SaveFontColor,
    SaveColor : TColor;

    Function StUpCase(St : Shortstring) : Shortstring;
    Var i : Integer;
    Begin
      Result := st;
      for i := 1 to length(st) do Result[i] := upcase(Result[i]);
    End;

Begin
  Result := GetTextOutPosY(LineNr);

  Rect.Left := 0{1};
  Rect.Top := Result;
  Rect.Bottom := Result + TotalCharHeight;

  if Assigned(FHeader) then
    Rect.Right := FHeader.Width
  Else
    Rect.Right := Width;

  Canvas.FillRect(Rect);

  SegmentString := '';
  SegNum := 0;

  if Assigned(FHeader) then Begin
     FHeader.Left := xOfs + Left;
     FHeader.Width := Width - xOfs;
  End;

  Just := DT_Left;
  for i := 1 to length(S) do Begin
    if (S[i] = JustLeftChar) then Just := DT_left else
    if (S[i] = JustCenterChar) then Just := DT_Center else
    if (S[i] = JustRightChar) then Just := DT_Right else
    if (S[i] = SeparatorChar) or (i = length(S)) then begin
      if i = length(S) then SegmentString := SegmentString + S[i];
      { SegmentString now contains the segment }
      Rect.Top := Result;
      Rect.Bottom := Result + TotalCharHeight;
      x := 1;
      if Assigned(FHeader) then Begin
         for j := 0 to SegNum-1 do
          x := x + FHeader.SectionWidth[j];
         Rect.Left := XOfs + FTextMargin.Left + x + 2;
         if SegNum = FHeader.Sections.Count-1 then
           Rect.Right := Rect.Left + FHeader.SectionWidth[SegNum]-20
         Else
           Rect.Right := Rect.Left + FHeader.SectionWidth[SegNum]-4;
      End Else Begin
         Rect.Left := XOfs + FTextMargin.Left + 2;
         Rect.Right := XOfs + FtextMargin.Left + Width - 2;
      End;

      { Draw the text }
      DrawText(Canvas.Handle,@SegmentString[1],length(SegmentString),Rect,Just+DT_NoPrefix);

      { Process the incremental search string }
      if (IncSS <> '') and (SegNum = KeySection) and (Just = DT_Left) and
        (copy(StUpCase(SegmentString),1,Length(IncSS)) = IncSS) then
        Begin
          { Do incremental search string highlight }
          SaveColor := Canvas.Brush.Color;
          SaveFontColor := Canvas.Font.Color;
          Canvas.Font.Color := IncSSTxtColor;
          Canvas.Brush.Color := IncSSColor;
          DrawText(Canvas.Handle,@SegmentString[1],length(IncSS),Rect,DT_Left+Dt_NoPrefix);
          Canvas.Font.Color := SaveFontColor;
          Canvas.Brush.Color := SaveColor;
      End;
      { Draw vertical lines }
      Canvas.Pen.Color := clGray;
      Rect.Right := ReCt.Right + 2;
      Canvas.MoveTo(Rect.Right-2,Rect.Top);
      Canvas.LineTo(Rect.Right-2,Rect.Bottom);
      Canvas.Pen.Color := clWhite;
      Canvas.MoveTo(Rect.Right-1,Rect.Top);
      Canvas.LineTo(Rect.Right-1,Rect.Bottom);
      inc(SegNum);
      SegmentString := '';
    End Else Begin
      SegmentString := SegmentString + S[i];
    End;
  End;
End;

Function TItabBrowser.GetHighKey: GenKeyStr;
Begin
  Result := '';
  if not CanCallLowBrowser then Exit;
  Result := BrowserPtr^.HighKey;
End;

Function TItabBrowser.GetLowKey: GenKeyStr;
Begin
  Result := '';
  if not CanCallLowBrowser then Exit;
  Result := BrowserPtr^.LowKey;
End;

Procedure TItabBrowser.SetHighKey(Value: GenKeyStr);
Begin
  if not CanCallLowBrowser then Exit;
  if Assigned(FDataSource) then Value:= String_Ansi2Oem(Datasource.DataSet.AnsiConvert,Value);
  BrowserPtr^.HighKey:= Value;
  EraseRowAreaRect;
  SetAndUpdateBrowserScreen((Value), 0);
End;

Procedure TItabBrowser.SetLowKey(Value: GenKeyStr);
Begin
  if not CanCallLowBrowser then Exit;
  if Assigned(FDataSource) then Value:= String_Ansi2Oem(DataSource.DataSet.AnsiConvert,Value);
  BrowserPtr^.LowKey:= Value;
  EraseRowAreaRect;
  SetAndUpdateBrowserScreen((Value), 0);
End;

Procedure TItabBrowser.KeyUp(Var Key: Word; Shift: TShiftState);
begin
  if Key in [vk_Delete,vk_Insert,vk_Home,vk_End,
             vk_Down,vk_Up,vk_Next,vk_Prior]
  then begin
    KeyFlag:= False;
    BrwRowChanged(Self);
  end;
  inherited KeyUp(Key,Shift);
end;

Procedure TItabBrowser.KeyDown(Var Key: Word; Shift: TShiftState);
Begin
  if Key in [vk_Delete,vk_Insert,vk_Home,vk_End,
             vk_Down,vk_Up,vk_Next,vk_Prior]
  then KeyFlag:= True;
  Inherited KeyDown(Key, Shift);
  if CanCallLowBrowser then Begin
    Case Key of
      vk_Delete: if FDataSource.DataSet <> Nil then Begin
                   DataSource.DataSet.RecNo:= GetCurrentDatRef;
                   DataSource.DataSet.Get;
                   DataSource.DataSet.Delete;
                   SetAndUpdateBrowserScreen('',DataSource.DataSet.RecNo);
                 End;
      vk_Insert: OnDblClick(Self);
      vk_Return: OnDblClick(Self);
    End;
  End;
  KeyFlag:= False;
End;

Procedure TItabBrowser.KeyPress(Var Key : Char);
Const AllowedKeys = [' '..'z','','','','','',''];
Var SaveIncSS, SaveLowKey, SaveHighKey : IsamKeyStr;
Begin
  if not AllowIncss then Exit;
  SaveIncSS := IncSS;
  if Key = #27 then ClearIncSS Else
  if Key = #8 then Begin { Backspace }
    if IncSS <> '' then Delete(IncSS,Length(IncSS),1);
  End Else Begin
    if Key in AllowedKeys then Begin
      if (Key = '') or (Key = '') then Key:= '';
      if (Key = '') or (Key = '') then Key:= '';
      if (Key = '') or (Key = '') then Key:= '';
      IncSS := IncSS + UpCase(Key);
    End
    Else Begin
      Messagebeep(0);
      Exit;
    End;
  End;
  if not CanCallLowBrowser then Exit;
  { Changing either the low or the high key can cause use to not have any
    records left to show, so if either fails, we need to undo the changes. }
  Try
    SaveLowKey := LowKey;
    LowKey := BaseLKey + IncSS;
    Try
       SaveHighKey := HighKey;
       HighKey := BaseHKey + IncSS;
    Except
       HighKey := SaveHighKey;
       LowKey := SaveLowKey;
       IncSS := SaveIncSS;
       MessageBeep(0);
    End;
  Except
    LowKey := SaveLowKey;
    IncSS := SaveIncSS;
    MessageBeep(0);
  End;
End;

End.



