unit Itabbrst;
interface
{copyright 1995,1996,1997 by Stellberg Computer GmbH}
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, Buttons, StdCtrls, ExtCtrls,
  ITable, ITabBrow;

type

  TUeberschriftObject = class(TObject)
    Txt: Shortstring;
    Idx: Integer;
    Breite: Integer;
    Visible: Boolean;
    Constructor Init(aTxt: Shortstring; aIdx: Integer; aBreite: Integer; aVisible: Boolean);
  end;

  TIsamBrowserSetupDlg = class(TForm)
    UpBttn: TSpeedButton;
    DownBttn: TSpeedButton;
    OkBttn: TBitBtn;
    CancelBttn: TBitBtn;
    ListBox1: TListBox;
    Label1: TLabel;
    NamEdit: TEdit;
    Label2: TLabel;
    LablEdit: TEdit;
    Label3: TLabel;
    WidthEdit: TEdit;
    Label4: TLabel;
    VisCheck: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure UpBttnClick(Sender: TObject);
    procedure DownBttnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OkBttnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelBttnClick(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure LablEditExit(Sender: TObject);
    procedure WidthEditExit(Sender: TObject);
    procedure VisCheckClick(Sender: TObject);
  private
    SortList: TStringList;
    BrowserName: Shortstring;
    IniName    : Shortstring;
    Table      : TIDataSet;
    SelIdx     : Integer;
    Clicked    : Boolean;
    Procedure CheckListe;
    Procedure CheckButtons;
  public
    { Public-Deklarationen }
  end;

var
  IsamBrowserSetupDlg: TIsamBrowserSetupDlg;

Procedure IsamBrowserSetup(aParent: TForm; AppName,BrwName: Shortstring;
                       Table: TIDataSet);
Procedure GetArray({$IFDEF VER90}
                   AStr: ShortString;
                   {$ELSE}
                   AStr: Shortstring;
                   {$ENDIF}
                   var Arr1,Arr2: Integer);

implementation

Uses IniFiles, ITabTool;

{$R *.DFM}


Constructor TUeberschriftObject.Init(aTxt: Shortstring; aIdx: Integer; aBreite: Integer; aVisible: Boolean);
begin
  Txt:= aTxt;
  Idx:= aIdx;
  Breite:= aBreite;
  Visible:= aVisible;
end;

procedure TIsamBrowserSetupDlg.FormCreate(Sender: TObject);
var AktDir: Shortstring;
begin
  SortList:= TStringList.Create;
  BrowserName:= 'ISAMBROWSER1';
  IniName:= 'ISAMTEST.INI';
  AktDir:= ExtractFilePath(Application.ExeName);
  IniName:= AktDir + ININame;
  if Sprache = 1 then Caption:= 'Browser-Setup';
  SelIdx:= -1;
  Clicked:= False;
end;

Procedure TIsamBrowserSetupDlg.CheckButtons;
begin
  if SelIdx = 0 then UpBttn.Enabled:= False
  else UpBttn.Enabled:= True;
  if SelIdx = Listbox1.Items.Count-1 then DownBttn.Enabled:= False
  else DownBttn.Enabled:= True;
end;

procedure TIsamBrowserSetupDlg.UpBttnClick(Sender: TObject);
begin
  if SelIdx < 1 then Messagebeep(0)
  else begin
    SortList.Move(SelIdx,SelIdx-1);
    Listbox1.Items.Move(SelIdx,SelIdx-1);
    Listbox1.ItemIndex:= SelIdx - 1;
    Dec(SelIdx);
    CheckButtons;
  end;
end;

procedure TIsamBrowserSetupDlg.DownBttnClick(Sender: TObject);
begin
  if (SelIdx > -1) and (SelIdx >= Listbox1.Items.Count) then Messagebeep(0)
  else begin
    SortList.Move(SelIdx,SelIdx+1);
    Listbox1.Items.Move(SelIdx,SelIdx+1);
    Listbox1.ItemIndex:= SelIdx + 1;
    Inc(SelIdx);
    CheckButtons;
  end;
end;

procedure TIsamBrowserSetupDlg.FormDestroy(Sender: TObject);
begin
  SortList.Free;
end;

procedure TIsamBrowserSetupDlg.OkBttnClick(Sender: TObject);
var IniFile: TIniFile;
    i: Integer;
    Ueberschr: TUeberschriftObject;
    SStr     : Shortstring;
begin
  CheckListe;
  IniFile:= TIniFile.Create(ININAME);
  IniFile.EraseSection(BrowserName);
  For i:= 0 to Listbox1.Items.Count-1 do begin
    Ueberschr:= TUeberschriftObject(SortList.Objects[i]);
    if Ueberschr <> NIL then begin
      SStr:= DezStr(UeberSchr.Breite)+','+DezStr(Ueberschr.Idx);
      if UeberSchr.Visible then SStr:= SStr + ',1'
      else SStr:= SStr + ',0';
      IniFile.WriteString(BrowserName,Listbox1.Items[i],SStr);
    end;
  end;
  IniFile.Free;
  ModalResult:= mrOk;
end;

Procedure GetArray({$IFDEF VER90}
                    AStr: ShortString;
                   {$ELSE}
                    AStr: Shortstring;
                   {$ENDIF}
                    var Arr1,Arr2: Integer);
var A1,A2,Code: Integer;
    {$IFDEF VER90}
    A1Str: ShortString;
    {$ELSE}
    A1Str: Shortstring;
    {$ENDIF}
begin
  AStr:= UpperCase(AStr);
  Arr1:= 1;
  Arr2:= 1;
  if (Pos('ARRAY[',AStr) > 0) and (Pos('CHAR',Astr) = 0) then begin
    Delete(AStr,1,Pos('ARRAY[',AStr)+5);
    if Pos(']',AStr) > 0 then begin
      AStr:= Copy(AStr,1,Pos(']',AStr)-1);
      if Pos('.',AStr) > 0 then begin
        A1Str:= Copy(AStr,1,Pos('.',AStr)-1);
        While (Pos('.',AStr) > 0) do Delete(AStr,1,Pos('.',AStr));
        Strip(a1Str); Strip(AStr);
        Val(A1Str,A1,Code);
        Val(AStr,A2,Code);
        if (A1 > 0) and (A2 > 0) then begin
          Arr1:= A1;
          Arr2:= A2;
          if Arr1 > Arr2 then begin
            A1:= Arr2;
            Arr2:= Arr1;
            Arr1:= A1;
          end;
        end;
      end;
    end;
  end;
end;

procedure TIsamBrowserSetupDlg.FormShow(Sender: TObject);
var IniFile: TIniFile;
    Liste: TStringList;
    aVis : Boolean;
    Feld,Arr1,Arr2,FNr,Idx,i,Len,Code: Integer;
    {$IFDEF VER90}
    X,SStr,FeldName,LenStr: ShortString;
    {$ELSE}
    X,SStr,FeldName,LenStr: Shortstring;
    {$ENDIF}
begin
  if (IniName = '') or (BrowserName = '') then begin
    if Sprache = 1 then Errorwindow('Ini-Filename or BrowserName not assigned','')
    else Errorwindow('INI-Dateiname oder Browsername nicht angegeben','');
  end
  else begin
    IniFile:= TIniFile.Create(IniName);
    Liste:= TStringList.Create;
    IniFile.ReadSection(BrowserName,Liste);
    if Liste.Count > 0 then begin
      For i:= 0 to Liste.Count-1 do begin
        X:= IniFile.ReadString(BrowserName,Liste[i],'');
        aVis:= true;
        if Pos(',',X) > 0 then begin
          Val(Copy(X,1,Pos(',',X)-1),Len,Code);
          Delete(X,1,Pos(',',X));
          if Pos(',',X) > 0 then begin
            Val(Copy(X,1,Pos(',',X)-1),Idx,Code);
            Delete(X,1,Pos(',',X));
            if Copy(X,1,1) = '0' then aVis:= False;
          end
          else Val(X,Idx,Code);
        end
        else begin
          Idx:= i+1;
          Val(X,Len,Code);
        end;
        SortList.AddObject(Liste[i],TUeberschriftObject.Init(Liste[i],Idx,Len,aVis));
        Listbox1.Items.Add(Liste[i]);
      end;
    end
    else begin
      if Table.FldCnt > 0 then begin
        FNr:= 0;
        For i:= 1 to Table.FldCnt do begin
          FeldName:= TIsamField(Table.Felder.Items[i-1]).DisplayLabel;
          Inc(Fnr);
          Len:= TIsamField(Table.Felder.Items[i-1]).DisplayWidth;
          aVis:= TIsamField(Table.Felder.Items[i-1]).Visible;
          SortList.AddObject(FeldName,TUeberschriftObject.Init(FeldName,FNr,Len,aVis));
          Listbox1.Items.Add(FeldName);
        end;
      end;
    end;
    Liste.Free;
    IniFile.Free;
  end;
  if Listbox1.Items.Count > 0 then begin
    Listbox1.ItemIndex:= 0;
    SelIdx:= 0;
    CheckButtons;
    Listbox1Click(Self);
  end;
end;

procedure TIsamBrowserSetupDlg.CancelBttnClick(Sender: TObject);
begin
  ModalResult:= mrCancel;
end;

Procedure IsamBrowserSetup(aParent: TForm; AppName,BrwName: Shortstring;
                       Table: TIDataSet);
var AktDir: Shortstring;
begin
  AktDir:= ExtractFilePath(Application.ExeName);
  IsamBrowserSetupDlg:= TIsamBrowserSetupDlg.Create(aParent);
  Try
    if Pos('.',AppName) > 0 then AppName:= Copy(AppName,1,Pos('.',AppName)-1);
    While Pos('\',AppName) > 0 do Delete(AppName,1,Pos('\',AppName));
    IsamBrowserSetupDlg.IniName:= AktDir + Appname+'.INI';
    IsamBrowserSetupDlg.Browsername:= BrwName;
    IsamBrowserSetupDlg.Table:= Table;
    IsamBrowserSetupDlg.ShowModal;
  Finally
    IsamBrowserSetupDlg.Free;
  end;
end;

procedure TIsamBrowserSetupDlg.ListBox1Click(Sender: TObject);
var u: TUeberschriftObject;
begin
  Clicked:= True;
  if Listbox1.ItemIndex > -1 then begin
    SelIdx:= Listbox1.ItemIndex;
    if SortList.Objects[Listbox1.ItemIndex] <> NIL then begin
      U:= TUeberschriftObject(SortList.Objects[Listbox1.ItemIndex]);
      LablEdit.Text:= U.Txt;
      WidthEdit.Text:= DezStr(U.Breite);
      VisCheck.Checked:= U.Visible;
      NamEdit.Text:= TIsamField(Table.Felder.Items[U.Idx-1]).Name;
    end;
  end;
  CheckButtons;
  Clicked:= False;
end;

Procedure TIsamBrowserSetupDlg.CheckListe;
var U: TUeberschriftObject;
begin
  if SelIdx > -1 then begin
    if SortList.Objects[SelIdx] <> NIL then begin
      U:= TUeberschriftObject(SortList.Objects[SelIdx]);
      U.Txt:= LablEdit.Text;
      U.Breite:= StrInt(WidthEdit.Text);
      U.Visible:= VisCheck.Checked;
      Listbox1.Items[SelIdx]:= LablEdit.Text;
    end;
  end;
end;

procedure TIsamBrowserSetupDlg.LablEditExit(Sender: TObject);
begin
  if LablEdit.Modified then CheckListe;
end;

procedure TIsamBrowserSetupDlg.WidthEditExit(Sender: TObject);
begin
  if WidthEdit.Modified then CheckListe;
end;

procedure TIsamBrowserSetupDlg.VisCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckListe;
end;

end.
