unit Itabdbas;

interface

Uses SysUtils, WinTypes, WinProcs, Messages, Classes, Controls, Forms,
     Graphics, Menus, StdCtrls, ExtCtrls, Buttons, Dialogs,
     ITblCons, ITable, Filer, Itab2Dbf;

Type
{$IfNdef Ver90}
ShortString = String;
{$Endif}

DBaseExportCtrl = Class(TComponent)
  FCtrlLink: TITblCtrlLink;
  FDataSource: TIsamDataSource;
Private
  FVon, FBis: IsamKeyStr;
  FDbaseName: ShortString;
  Procedure SetDataSource(Value: TIsamDataSource);
  Function GetDataSource: TIsamDatasource;
  Procedure SetBis(Value: IsamKeyStr);
  Procedure SetDateiName(Value: ShortString);
Public
  SaveDialogAbfrage : Boolean;
  dbDateiName: TFileName;
  Abfrage : Boolean;
  Constructor Create(AOwner: TComponent); Override;
  Destructor Destroy; Override;
  Procedure Execute;
  Procedure CExecute(FileName: TFileName);
Published
  Property Datasource: TIsamDatasource Read GetDatasource Write SetDatasource;
  Property Dateiname: ShortString Read FDBaseName Write SetDateiName;
  Property Von: IsamKeyStr Read FVon Write FVon;
  Property Bis: IsamKeyStr Read FBis Write SetBis;
end;

implementation

Uses ItabTool, Itab_usr, ItabDat;


Constructor DBaseExportCtrl.Create(AOwner: TComponent);
begin
  Inherited Create(AOwner);
  FCtrlLink:= TITblCtrlLink.Create(self);
  FDBaseName:= '';
  FDataSource:= NIL;
  DbDateiName := '';
  SaveDialogAbfrage := True;
  FVon := '';
  FBis := #255;
end;

Destructor DBaseExportCtrl.Destroy;
Begin
  SetDataSource(Nil);
  FCtrlLink.Free;
  SaveDialogAbfrage := False;
  Inherited Destroy;
End;

Procedure DBaseExportCtrl.SetBis(Value: IsamKeyStr);
begin
  if Pos(#255,Value) = 0 then Value:= Value + #255;
  if Value <> FBis then FBis:= Value;
end;

Procedure DBaseExportCtrl.SetDataSource(Value: TIsamDataSource);
Begin
  FCtrlLink.DataSource:= Value;
  FDataSource := FCtrlLink.DataSource;
End;


Function DBaseExportCtrl.GetDatasource: TIsamDatasource;
begin
  Result:= FCtrlLink.Datasource;
end;

Procedure DBaseExportCtrl.CExecute(FileName: TFileName);
Begin
  DbDateiName := FileName;
  fDBaseName:= FileName;
  SaveDialogAbfrage := False;
  Execute;
  SaveDialogAbfrage := True;
end;

Procedure DBaseExportCtrl.SetDateiName(Value: ShortString);
begin
  if Pos('.',Value) > 0 then Value:= Copy(Value,1,Pos('.',Value)-1);
  if Value <> FDbaseName then FDBaseName:= Value;
end;

Procedure DBaseExportCtrl.Execute;
Var
    II,fx     : Integer;
    Fld       : TIsamField;
    FName,FNam: ShortString;
    FListe    : TStringList;
    MerkVon,MerkBis: IsamKeyStr;
    i         : Byte;
begin
  if Datasource <> Nil then
  if Datasource.Dataset <> Nil then
  if Datasource.Dataset.IfbPtr <> Nil then
  if Datasource.Dataset.Active then begin
    FListe:= TStringList.Create;
    MerkVon:= DataSource.DataSet.Von;
    MerkBis:= DataSource.DataSet.Bis;
    Abfrage := SaveDialogAbfrage;
    DBFTransferDlg:= TDBFTransferDlg.Create(Owner, TITable(DataSource.DataSet));
    Try
      DBFTransferDlg.ITable1.Von:= Von;
      DBFTransferDlg.ITable1.Bis:= Bis;
      if FDBaseName <> '' then dbDateiname:= fDBaseName;
      if Abfrage then
      begin
        DBFTransferDlg.SaveDialog1.FileName := fDBaseName;
        DBFTransferDlg.SaveDialog1.DefaultExt := 'dbf' ;
        DBFTransferDlg.SaveDialog1.Execute;
        dbDateiname := DBFTransferDlg.Savedialog1.FileName;
      end;
      if DbDateiName = '' then DBDateiName:= __Laufwerk+Datasource.Dataset.TableName;
      i := Pos('.DBF',upStr(DBDateiName));
      if i > 0 then Delete(DBDateiName,i,4);
      DBDateiname := DBDateiName+'.DBF';
      with DBFTransferDlg do begin
        DBFTransferDlg.Label1.Caption := DBDateiName;
        CreateDB(HTable1,DBDateiName);
        if Datasource.Dataset.Felder.Count > 0 then begin
          For ii := 1 to Datasource.Dataset.Felder.Count -1 do begin
            Fld:= TIsamField(Datasource.Dataset.Felder.Items[ii]);
            FName:= Fld.Name;
            FNam:= FName;
            if Length(FName) > 8 then FNam:= Copy(FNam,1,8);
            fx:= 1;
            While FListe.IndexOf(FNam) <> -1 do begin
              FNam:= Copy(FName,1,6)+DezStr(fx);
              inc(fx);
            end;
            FListe.Add(FNam);
            if Fld.Typ = ITblCons.ftInteger       then HTable1^.NewField(FNam,'N',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftString   then HTable1^.NewField(FNam,'C',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftBoolean  then HTable1^.NewField(FNam,'L',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftChar     then HTable1^.NewField(FNam,'C',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftWord     then HTable1^.NewField(FNam,'N',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftLongint  then HTable1^.NewField(FNam,'N',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftReal     then HTable1^.NewField(FNam,'N',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftDate     then HTable1^.NewField(FNam,'D',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftMemo     then HTable1^.NewField(FNam,'M',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftWordDate then HTable1^.NewField(FNam,'D',Fld.Size,Fld.Decimals)
            else if Fld.Typ = ITblCons.ftByte     then HTable1^.NewField(FNam,'N',Fld.Size,Fld.Decimals);
          end;
        end;
      end;
      if SaveDialogAbfrage then DBFTransferDlg.ShowModal
      else DBFTransferDlg.StartBttnClick(Self);
    Finally
      DBFTransferDlg.Free;
    end;
    FListe.Free;
    DataSource.DataSet.Von:= MerkVon;
    DataSource.DataSet.Bis:= MerkBis;
  end;
end;


end.


