unit ITABExcl;

interface

Uses SysUtils, WinTypes, WinProcs, Messages, Classes, Controls, Forms,
     Graphics, Menus, StdCtrls, ExtCtrls, Buttons, Dialogs,
     ITblCons, ITable, Itab2XLS, Filer;
    
Type
{$IfNdef Ver90}
ShortString = String;
{$Endif}

ExcelExportCtrl = Class(TComponent)
  FCtrlLink: TITblCtrlLink;
  FDataSource: TIsamDataSource;
Private
  FName : ShortString;
  FVon,FBis  : IsamKeyStr;
  FExcelName : ShortString;
  Procedure SetDataSource(Value: TIsamDataSource);
  Function GetDataSource: TIsamDatasource;
  Procedure SetBis(Value: IsamKeyStr);
  Procedure SetDateiName(Value: ShortString);
Public
  Constructor Create(AOwner: TComponent); Override;
  Destructor Destroy; Override;
  Procedure GetXLDaten(Zeile:Integer);
  Procedure Execute;
Published
  Property Datasource: TIsamDatasource Read GetDatasource Write SetDatasource;
  Property Dateiname: ShortString Read FExcelName Write SetDateiName;
  Property VON: IsamKeyStr Read FVon Write FVon;
  Property BIS: IsamKeyStr Read FBis Write SetBis;
end;


implementation


Uses ITab_Usr, ItabTool, ItabDat;


Var
  Zeile   : integer;
  DateiName: TFileName;

Constructor ExcelExportCtrl.Create(AOwner: TComponent);
begin
  Inherited Create(AOwner);
  FCtrlLink:= TITblCtrlLink.Create(self);
  FDataSource:= NIL;
  FVon:= '';
  FBis:= #255;
end;

Destructor ExcelExportCtrl.Destroy;
Begin
  SetDataSource(Nil);
  FCtrlLink.Free;
  Inherited Destroy;
End;

Procedure ExcelExportCtrl.SetBis(Value: IsamKeyStr);
begin
  if Pos(#255,Value) = 0 then Value:= Value + #255;
  if Value <> FBis then FBis:= Value;
end;

Procedure ExcelExportCtrl.SetDateiName(Value: ShortString);
begin
  if Pos('.',Value) > 0 then Value:= Copy(Value,1,Pos('.',Value)-1);
  if Value <> FExcelName then FExcelName:= Value;
end;

Procedure ExcelExportCtrl.SetDataSource(Value: TIsamDataSource);
Begin
  FCtrlLink.DataSource:= Value;
  FDataSource := FCtrlLink.DataSource;
End;

Function ExcelExportCtrl.GetDatasource: TIsamDatasource;
begin
  Result:= FCtrlLink.Datasource;
end;

Procedure ExcelExportCtrl.GetXLDaten(Zeile:Integer);
var S: ShortString;
    I: Integer;
    B: Boolean;
    D: Double;
    Spalte: Integer;
    aLabel: Array[0..255] of Char;
    ii : Integer;
    Fld: TIsamField;
    Typ: IFieldType;
begin
  if Zeile < 0 then begin
    Spalte:= 0;
    Zeile:= 0;
    if Datasource.Dataset.Felder.Count > 0 then
    For ii := 1 to Datasource.Dataset.Felder.Count -1 do  {Dummy nicht bergeben}
    begin
      {Zellenberschrift}
      Fld:= TIsamField(Datasource.Dataset.Felder.Items[ii]);
      S:= Fld.Name;
      StrPCopy(aLabel,S);
      PSaveFile^.WriteData(CellLabel,Zeile,Spalte,@ALabel);
      inc(Spalte);
    end;
  end
  else
  begin
    Spalte:= 0;
    if Datasource.Dataset.Felder.Count > 0 then
    For ii := 1 to Datasource.Dataset.Felder.Count -1 do {Dummy nicht bergeben}
    begin
      Fld:= TIsamField(Datasource.Dataset.Felder.Items[ii]);
      Typ:= Fld.Typ;
      {ZellenInhalt}
      Case Typ of

      ftInteger,
      ftLongint,
      ftWord  : begin
        	  I:= Datasource.Dataset.FieldByName(Fld.Name).AsInteger;
        	  PSaveFile^.WriteData(CellInteger,Zeile,Spalte,@I);
        	  inc(Spalte);
                end;
      ftReal  : begin
        	  D:= Datasource.Dataset.FieldByName(Fld.Name).AsFloat;
        	  PSaveFile^.WriteData(CellDouble,Zeile,Spalte,@D);
        	  inc(Spalte);
                end;
      ftBoolean:begin
        	  B:= Datasource.Dataset.FieldByName(Fld.Name).AsBoolean;
        	  PSaveFile^.WriteData(CellBoolean,Zeile,Spalte,@B);
        	  inc(Spalte);
                end;
      else
                begin
                  S:= String_oem2ansi(Datasource.Dataset.AnsiConvert,
                                      Datasource.Dataset.FieldByName(Fld.Name).AsString);
                  StrPCopy(aLabel,S);
                  PSaveFile^.WriteData(CellLabel,Zeile,Spalte,@ALabel);
                  inc(Spalte);
                end;
      end; {of Case}
    end;
  end;
end;

Procedure ExcelExportCtrl.Execute;
Var RecNo : LongInt;
    MerkVon,MerkBis : IsamKeyStr;
begin
  if Datasource <> Nil then
  if Datasource.Dataset <> Nil then
  if Datasource.Dataset.IfbPtr <> Nil then
  if Datasource.Dataset.Active then begin
    MerkVon:= DataSource.DataSet.Von;
    MerkBis:= DataSource.DataSet.Bis;
    DataSource.DataSet.Von:= Von;
    DataSource.DataSet.Bis:= Bis;
    ITabExcelDlg:= TITabExcelDlg.Create(Self);
    Try
      ITabExcelDlg.ShowModal;
      If ITabExcelDlg.Modalresult = mrOk then
      begin
        With ITabExcelDlg do
        begin
          if FExcelName > '' then DateiName:= FExcelName;
          if Radiobutton5.Checked then SaveDialog1.DefaultExt := 'txt'
          else if Radiobutton6.Checked then SaveDialog1.DefaultExt := 'txt' else
          if DateiName <> '' then SaveDialog1.FileName:= DateiName
          else SaveDialog1.FileName := __Laufwerk+Datasource.Dataset.Tablename+'.xls';
          SaveDialog1.DefaultExt := 'xls' ;
          Savedialog1.Execute;
          Dateiname := Savedialog1.FileName;
          if Dateiname = '' then exit;
          if RadioButton1.Checked then PSavefile := New(PBIFF2,Init(DateiName));
          if RadioButton2.Checked then PSavefile := New(PBIFF3,Init(DateiName));
          if RadioButton3.Checked then PSavefile := New(PBIFF4,Init(DateiName));
          if RadioButton4.Checked then PSavefile := New(PBIFF5,Init(DateiName));
          if RadioButton5.Checked then PSavefile := New(PASCII,Init(DateiName));
          if RadioButton6.Checked then PSavefile := New(PExcelTab,Init(DateiName));
          Zeile := -1;
          {TitelZeile / Feldberschriften holen: ZEILE:= -1}
          GetXlDaten(Zeile);
          Zeile:= 1;
          Datasource.Dataset.First;
          if (DataSource.DataSet.KeyStr >= DataSource.DataSet.Von)
          and (DataSource.DataSet.KeyStr <= DataSource.DataSet.Bis) then begin
            Repeat
              if (isamok) and (not(DataSource.DataSet.AtEof)) then
              begin
                {DATEN HOLEN: Zeile > 0}
                GetXlDaten(Zeile);
                Inc(Zeile);
                WaitWindow('Zeile: ',FloatToStr(Zeile));
                Datasource.Dataset.Next;
              end;
            Until (not ISAMOK) or (DataSource.DataSet.AtEof);
            CloseWait;
          end;
          Errorwindow('fertig...','');
          dispose(PSaveFile,done);
        end;
      end;
    Finally
      ITabExcelDlg.Free;
    end;
    DataSource.DataSet.Von:= MerkVon;
    DataSource.DataSet.Bis:= MerkBis;
  end;
end;


end.


