Unit ITabReo;                                        
{copyright 1995,1996,1997 by Stellberg Computer GmbH}
Interface

Uses
  ITable, ItabTool, Filer, VRec, BufRecIO;

  Procedure ReorgIndex      (      FBlName        : IsamFileBlockName;
                                   Table	  : TIDataSet;
                                   NumberOfKeys   : Word;
                                   IID            : IsamIndDescr;
                                   VarRec         : Boolean;
                                   DelRecDupKey   : Boolean;
                               Var MsgFileCreated : Boolean;
                                   CharConvProc   : ProcBTCharConvert;
                                   CCHookPtr      : Pointer );

Implementation


  Type
    IsamSmallInfoRec = packed Record
      Gener : Array [1..5] Of LongInt;
      ADK   : Boolean;
    End;

  Procedure ReorgIndex (           FBlName        : IsamFileBlockName;
                                   Table	  : TIDataSet;
                                   NumberOfKeys   : Word;
                                   IID            : IsamIndDescr;
                                   VarRec         : Boolean;
                                   DelRecDupKey   : Boolean;
                               Var MsgFileCreated : Boolean;
                                   CharConvProc   : ProcBTCharConvert;
                                   CCHookPtr      : Pointer );

  Var
    FNameTemp,
    FNameD,
    FNameI      : IsamFileBlockName;
    BufLen      : Word;
    MsgFile     : Text;
    DataRecLen  : LongInt;
    IORes       : Integer;


    Procedure CheckDatF ( Var DatSLen : LongInt );

    Var
      F       : IsamFile;
      Header  : IsamSmallInfoRec;
      DosSize : LongInt;
      NumRec  : LongInt;
      FFree   : LongInt;


      Procedure UnDo ( Err : Integer );

      Begin
        IsamClose ( F );
        IsamOK := Err <> 0;
        IsamError := Err;
        If not IsamOk then Errorwindow('Isamerror:',DezStr(Isamerror));
      End;


    Begin
      DatSLen := 0;
      IsamAssign ( F, IsamForceExtension ( FNameD, DatExtension ) );
      IsamReset ( F, False, False );
      If Not IsamOK Then Exit;

      IsamLongSeekEOF ( F, DosSize );
      If Not IsamOK Then Begin
        UnDo ( IsamError );
        Exit;
      End;

      IsamGetBlock ( F, 0, SizeOf (Header), Header );
      If Not IsamOK Then Begin
        UnDo ( IsamError );
        Exit;
      End;

      If Header.Gener [4] {LenRec} = 0 Then Begin
        UnDo ( 10215 );
        Exit;
      End;

      NumRec := DosSize Div Header.Gener [4] {LenRec};
      If NumRec * Header.Gener [4] {LenRec} <> DosSize Then Begin
        UnDo ( 10215 );
        Exit;
      End;
      DatSLen := Header.Gener [4] {LenRec};

      If Pred (NumRec) <> Header.Gener [3] {NumRec} Then Begin
        UnDo ( 10215 );
        Exit;
      End;

      If Header.Gener [1] {FirstFree} <> -1 Then Begin
        If Header.Gener [1] {FirstFree} > 0 Then Begin
          IsamGetBlock ( F, Header.Gener [1] {FirstFree},
              SizeOf (FFree), FFree );
          If Not IsamOK Then Begin
            UnDo ( IsamError );
            Exit;
          End;
        End Else Begin
          FFree := 0;
        End;
        If FFree = 0 Then Begin
          UnDo ( 10215 );
          Exit;
        End;
      End;

      DatSLen := Header.Gener [4] {LenRec};
      IsamClose ( F );
    End;


    Procedure CreateNewIndexFile;

    Var
      F       : IsamFile;
      SaveExt : String [3];

    Begin
      SaveExt := DatExtension;
      DatExtension := MsgExtension;

    {--Create a fileblock with a data file name equal to message file name;
       so we do not (!) overwrite the data file}
      BTCreateFileBlock ( FNameD + ';' + FNameI, DataRecLen, NumberOfKeys,
          IID );
      DatExtension := SaveExt;
      If Not IsamOK Then Exit;

      IsamAssign ( F, IsamForceExtension ( FNameD, MsgExtension ) );
      IsamDelete ( F );
    End;


    Procedure SetNewHeader;

    Var
      F      : IsamFile;
      Header : IsamSmallInfoRec;


      Procedure UnDo ( Err : Integer );

      Begin
        IsamClose ( F );
        IsamOK := Err <> 0;
        IsamError := Err;
        If not IsamOk then Errorwindow('Isamerror:',DezStr(Isamerror));
      End;


    Begin
    {--Open the data file to read the headerd}
      IsamAssign ( F, IsamForceExtension ( FNameD, DatExtension ) );
      IsamReset ( F, False, False );
      If Not IsamOK Then Exit;

      IsamGetBlock ( F, 0, SizeOf (Header), Header );
      If Not IsamOK Then Begin
        UnDo ( IsamError );
        Exit;
      End;

    {--Set the (potentially different) number of keys in the header}
      Header.Gener [5] := NumberOfKeys;

    {--Clear the data buffered flag}
      Header.ADK := False;

    {--Write the header back to the data file and close it}
      IsamPutBlock ( F, 0, SizeOf (Header), Header );
      If Not IsamOK Then Begin
        UnDo ( IsamError );
        Exit;
      End;
      IsamClose ( F );
    End;


    Procedure UnDo ( Level : Word; Error : Integer );

    Begin

      If MsgFileCreated Then Close ( MsgFile );

      If Level >= 2 Then Begin
        DoneRecBuffers;
      End;

      If Level >= 1 Then Begin
        BTCloseFileBlock ( Table.IFBPtr );
      End;

      IsamOK := False;
      IsamError := Error;
      If not IsamOk then Errorwindow('Isamerror:',DezStr(Isamerror));
    End;



    Procedure DumpToMessageFile ( Nr   : Word;
                                  Ref : LongInt;
                                  IKS : IsamKeyStr );

    Var
      PC : ^Char;
      W  : Word;

    Begin
      If Not MsgFileCreated Then Begin
        Assign ( MsgFile, IsamForceExtension ( FNameD, MsgExtension ) );
        Rewrite ( MsgFile );
        IORes := IOResult;
        If IORes <> 0 Then Exit;
        MsgFileCreated := True;
      End;

      Writeln ( MsgFile, 'Key:<', IKS, '>', ' KeyNr: ', Nr, ' Ref: ', Ref,
        ' not added' );
      IORes := IOResult;
      If IORes <> 0 Then Exit;

      If DelRecDupKey Then Begin
        WriteLn ( MsgFile, 'Data record deleted - Dump follows');
        PC := @Table.Data^;
        For W := 1 To DataRecLen Do Begin
          Write ( MsgFile, PC^);
          Inc (LongInt (PC));
        End;
        Writeln ( MsgFile, ^M^J);
        IORes := IOResult;
      End;
    End;


  Var
    I, J,
    MaxSize,
    CurRecLen    : Word;
    Stop,
    RetryRead,
    WasRead      : Boolean;
    CurrentRef,
    DatSRead,
    DatSWritten  : LongInt;
    IKS          : IsamKeyStr;

  Begin
    DataReclen := Table.Recsize;
    if Table.Active then Table.Close;
    IsamClearOK;

  {--Set buffer pointers to Nil and reference return value to no}
    MsgFileCreated := False;

  {--Get file names for data and index file}
    IsamExtractFileNames ( FBlName, FNameD, FNameTemp );
    IsamExtractFileNames ( FNameTemp, FNameI, FNameTemp {dummy} );
  {--Check data file and return record length}
    CheckDatF ( DataRecLen );
    DataReclen := Table.Recsize;
    If Not IsamOK Then Exit;
  {--Check record lengths}
    MaxSize := $FFFF;
    If DataRecLen > MaxSize Then Begin
      UnDo ( 0, 10412 );
      Exit;
    End;

  {--Create a new and empty index file}
    CreateNewIndexFile;
    If Not IsamOK Then Begin
      UnDo ( 0, IsamError );
      Exit;
    End;
   
  {--Modify the header of the data file}
    SetNewHeader;
    If Not IsamOK Then Begin
      UnDo ( 0, IsamError );
      Exit;
    End;
  {--The fileblock is now prepared to be opened; so open the fileblock}

    Table.Open;
    Table.LockFile;

    If Not IsamOK Then Begin
      UnDo ( 0, IsamError );
      Exit;
    End;

  {--Get buffer for data read (no write)}
    CreateRecBuffers ( DataRecLen, Nil );

  {--Reindexing loop}
    For I := 1 To NumberOfKeys Do Begin
      RewindReadBuffer;
    {--Initialize status and control data}
      CurRecLen := DataRecLen;
      CurrentRef := 0;
      DatSRead := 0;
      DatSWritten := 0;
      Stop := False;
      Repeat
      {--Read record}
        Begin
          Repeat
            Inc (CurrentRef);
            BufGetBlock ( Table.IFBPtr^.DatF, CurrentRef * DataRecLen, DataRecLen,
                Table.Data^ );
            If Not IsamOk Then Begin
              If IsamError = 10070 Then Begin
                IsamClearOK;
                Stop := True;
              End Else Begin
                UnDo ( 4, IsamError );
                Exit;
              End;
            End;
          Until Stop Or (LongInt (Table.Data^) = 0);
        End;

        If Not Stop Then Begin
          Inc (DatSRead);
          CharConvProc ( Table.Data, CurRecLen, True, CCHookPtr );
          if @Table.Key_Proc = NIL then IKS := Table.KeyP(True,I)
          else IKS := Table.Key_Proc(Table.DATA^,I);
          If Not IsamOK Then Begin
            UnDo ( 2, 10470 );
            Exit;
          End;
          If AddNullKeys Or (IKS <> '') Then Begin
            BTAddKey ( Table.IFBPtr, I, CurrentRef, IKS );
            If Not IsamOK Then Begin
              If IsamError = 10230 Then Begin
                DumpToMessageFile ( I, CurrentRef, IKS );
                IsamClearOK;
                If IORes <> 0 Then Begin
                  UnDo ( 2, 9500 + IORes );
                  Exit;
                End;
                If DelRecDupKey Then Begin
                  For J := 1 To Pred (I) Do Begin
                  if @Table.Key_Proc = NIL then
                  BTDeleteKey ( Table.IFBPtr, J, CurrentRef,
                                Table.KeyP(True, J ) )
                  else
                  BTDeleteKey ( Table.IFBPtr, J, CurrentRef,
                               Table.Key_Proc(Table.Data^, J ) );
                  End;
                  BTDeleteRec ( Table.IFBPtr, CurrentRef );
                  MarkReadBufRecDeleted ( CurrentRef );
                End;
              End Else Begin
                UnDo ( 2, IsamError );
                Exit;
              End;
            End Else Begin
              Inc (DatSWritten);
            End;
          End;
          If Assigned(IsamReXUserProcPtr) Then Begin
            IsamReXUserProcPtr(I, DatSRead, DatSWritten, Table.Data^, CurRecLen );
            If Not IsamOK Then Begin
              UnDo ( 2, 10460 );
              Exit;
            End;
          End;
        End;
      Until Stop;
    End;

    DoneRecBuffers;
    {-Cannot result in an error}
    If MsgFileCreated Then Close ( MsgFile );
    I := IOResult;
      {-Not really an error, if it may not be clossed correctly}
    Table.UnLockFile;
    Table.Close;
  End;


End.
