unit Itabstrk;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls,
  StdCtrls, DBTables, DB, Buttons, ItabTool, Dialogs;


Type
{$IFNDEF VER90}
  ShortString = String;
{$ENDIF}

  TStruktDialog = class(TForm)
    DatabaseListbox: TListBox;
    TableListbox: TListBox;
    FieldListbox: TListBox;
    IndexListbox: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Table: TTable;
    Label5: TLabel;
    TypListbox: TListBox;
    Label6: TLabel;
    LenListbox: TListBox;
    CreateTypBttn: TBitBtn;
    EndeBttn: TBitBtn;
    SaveDialog1: TSaveDialog;
    TypOrgListbox: TListBox;
    OpenDialog1: TOpenDialog;
    OpenDateiBttn: TBitBtn;
    OpenAliasBttn: TBitBtn;
    Memo1: TMemo;
    OpenTypBttn: TBitBtn;
    OpenDialog2: TOpenDialog;
    SaveTypBttn: TBitBtn;
    procedure TableListboxClick(Sender: TObject);
    procedure DatabaseListboxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FieldListboxClick(Sender: TObject);
    procedure TypListboxClick(Sender: TObject);
    procedure LenListboxClick(Sender: TObject);
    procedure CreateTypBttnClick(Sender: TObject);
    procedure OpenDateiBttnClick(Sender: TObject);
    procedure OpenAliasBttnClick(Sender: TObject);
    procedure EndeBttnClick(Sender: TObject);
    procedure OpenTypBttnClick(Sender: TObject);
    procedure SaveTypBttnClick(Sender: TObject);
  end;

var
  StruktDialog: TStruktDialog;
  Datei : ShortString;

implementation

{$R *.DFM}

Uses SysUtils, ITblCons;

const

{$IFNDEF VER90}
  FieldTypes: array[TFieldType] of ShortString = (
    'Unbekannt',         { ftUnknown }
    'StringField',       { ftString }
    'SmallintField',     { ftSmallint }
    'IntegerField',      { ftInteger }
    'WordField',         { ftWord }
    'BooleanField',      { ftBoolean }
    'FloatField',        { ftFloat }
    'CurrencyField',     { ftCurrency }
    'BCDField',          { ftBCD }
    'DateField',         { ftDate }
    'TimeField',         { ftTime }
    'DateTimeField',     { ftDateTime }
    'ByteField',         { ftBytes }
    'VarByteField',      { ftVarBytes }
    'BlobField',         { ftBlob }
    'MemoField',         { ftMemo }
    'GraphicField');     { ftGraphic }

MyFieldTypes: array[TFieldType] of ShortString = (
    'U',      { ftUnknown }
    'S',       { ftString }
    'I',     { ftSmallint }
    'I',      { ftInteger }
    'W',         { ftWord }
    'B',      { ftBoolean }
    'R',        { ftFloat }
    'R',     { ftCurrency }
    'R',          { ftBCD }
    'D',         { ftDate }
    'D',         { ftTime }
    'D',     { ftDateTime }
    'C',         { ftBytes }
    'C',      { ftVarBytes }
    'M',         { ftBlob }
    'M',         { ftMemo }
    'G');     { ftGraphic }
{$Endif}
{$IFDEF VER90}
  FieldTypes: array[TFieldType] of ShortString = (
    'Unknown or undetermined',                        {ftUnkown}
    'Character or string field',                      {ftString}
    '16-bit integer field',                           {ftSmallint}
    '32-bit integer field',                           {ftInteger}
    '16-bit unsigned integer field',                  {ftWord}
    'Boolean field',                                  {ftBoolean}
    'Floating-point numeric field',                   {ftFloat}
    'Money field',                                    {ftCurrency}
    'Binary-Coded Decimal field',                     {ftBCD}
    'Date field',                                     {ftDate}
    'Time field',                                     {ftTime}
    'Date and time field',                            {ftDateTime}
    'Fixed number of bytes (binary storage)',         {ftBytes}
    'Variable number of bytes (binary storage)',      {ftVarBytes}
    'Auto-incrementing 32-bit integer counter field', {ftAutoInc}
    'Binary Large OBject field',                      {ftBlob}
    'Text memo field',                                {ftMemo}
    'Bitmap field',                                   {ftGraphic}
    'Formatted text memo field',                      {ftFmtMemo}
    'Paradox OLE field',                              {ftParadoxOle}
    'dBASE OLE field',                                {ftDBaseOle}
    'Typed binary field');                            {ftTypedBinary}

MyFieldTypes: array[TFieldType] of ShortString = (
    'U',      { ftUnknown }       
    'S',       { ftString }       
    'I',     { ftSmallint }
    'I',      { ftInteger }
    'W',         { ftWord }
    'B',      { ftBoolean }
    'R',        { ftFloat }
    'R',     { ftCurrency }
    'R',          { ftBCD }
    'D',         { ftDate }
    'D',         { ftTime }
    'D',     { ftDateTime }
    'C',         { ftBytes}
    'C',      { ftVarBytes}
    'L',        {ftAutoInc}
    'M',         { ftBlob }
    'M',         { ftMemo }
    'G',      { ftGraphic }
    'M',        {ftFmtMemo}
    '?',     {ftParadoxOle}
    '?',       {ftDBaseOle}
    'C');   {ftTypedBinary}





{$Endif}

procedure TStruktDialog.TableListboxClick(Sender: TObject);
var x: Integer;
    F: TField;
    SStr: ShortString;
begin
  FieldListbox.Clear;
  IndexListbox.Clear;
  TypListbox.Clear;
  LenListbox.Clear;
  TypOrgListbox.Clear;
  if DatabaseListbox.ItemIndex >= 0 then Table.DatabaseName := DatabaseListbox.Items[DatabaseListbox.ItemIndex];
  Table.TableName := TableListbox.Items[TableListbox.ItemIndex];
  Table.GetFieldNames(FieldListbox.Items);
  Table.GetIndexNames(IndexListbox.Items);
  Table.Open;
  if Table.FieldCount > 0 then begin
    x:= 0;
    Repeat
      F:= Table.Fields[x];
      TypListbox.Items.Add(MyFieldTypes[F.DataType]);
      TypOrgListbox.Items.Add(FieldTypes[F.DataType]);
      Str(F.Size,SStr);
      LenListbox.Items.Add(SStr);
      inc(x);
    Until (x = Table.FieldCount);
  end;
  Table.Close;
end;

procedure TStruktDialog.DatabaseListboxClick(Sender: TObject);
begin
  TableListbox.Clear;
  Session.GetTableNames(DatabaseListbox.Items[DatabaseListbox.ItemIndex],
  '*.*',True,False,TableListbox.Items);
end;

procedure TStruktDialog.FormCreate(Sender: TObject);
begin
  Session.GetDatabaseNames(DatabaseListbox.Items);
  Datei := '';
  OpenAliasBttn.Caption:= GetMess(128);
  OpenDateiBttn.Caption:= GetMess(100);
  EndeBttn.Caption:= GetMess(129);
  CreateTypBttn.Caption:= GetMess(130);
  SaveTypBttn.Caption:= GetMess(168);
end;

procedure TStruktDialog.FieldListboxClick(Sender: TObject);
var idx: Integer;
begin
  idx:= FieldListbox.ItemIndex;
  if TypListbox.ItemIndex <> idx then TypListbox.ItemIndex:= idx;
  if LenListbox.ItemIndex <> Idx then LenListbox.ItemIndex:= idx;
end;

procedure TStruktDialog.TypListboxClick(Sender: TObject);
var idx: Integer;
begin
  idx:= TypListbox.ItemIndex;
  if FieldListbox.ItemIndex <> idx then FieldListbox.ItemIndex:= idx;
  if LenListbox.ItemIndex <> Idx then LenListbox.ItemIndex:= idx;
end;

procedure TStruktDialog.LenListboxClick(Sender: TObject);
var idx: Integer;
begin
  idx:= LenListbox.ItemIndex;
  if FieldListbox.ItemIndex <> idx then FieldListbox.ItemIndex:= idx;
  if TypListbox.ItemIndex <> Idx then TypListbox.ItemIndex:= idx;
end;


procedure TStruktDialog.CreateTypBttnClick(Sender: TObject);
Var
  I : Longint;
  txt : System.text;
  Len,Typ : ShortString;
  S : ShortString;
  begin
    SaveDialog1.FileName := Copy(Table.TableName,1,Pos('.',Table.TableName))+'TYP';
    if SaveDialog1.Execute then s := SaveDialog1.FileName;
    Datei := S;
    System.Assign(txt,S);
    if pos('.',S) <> 0 then Delete(S,Pos('.',s),4);
    System.rewrite(txt);
    S := ExtractFileName(S);
    System.Writeln(txt,'{Automatically created by ITable}');
    System.Writeln(txt,'{(c) by Stellberg Computer GmbH }');
    System.Writeln(txt,'{TableName = ',Table.TableName,'}');
    System.Writeln(txt,'{AliasName = ',Table.DatabaseName,'}');
    System.Writeln(txt,'Type');
    System.Writeln(txt,S+'Record = Record');
    System.Writeln(txt,'  Dummy : Longint; {DUMMY}');
    for I := 0 to Fieldlistbox.Items.count-1 do
    begin
      begin
        Len := LenListbox.Items[I];
        Typ := TypListbox.Items[i];
        Case Upcase(Typ[1]) of
        'U' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : String[1]; {Unbekannt}');
        'S' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : String[',Len,'];');
        'B' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Boolean;');
        'R' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Real; {Nachk0}');
{$IfnDef Ver90}
        'I' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Longint;');
{$Else}
        'I' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Integer;');
{$Endif}
        'L' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : LongInt;');
        'C' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Char;');
        'W' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Word;');
        'D' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : Longint; {Datum}');
        'G' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : String[255]; {Memo}');
        'M' :System.writeln(txt,'  '+Fieldlistbox.Items[i]+' : String[255]; {Memo}');
        end;{of Case}
      end;
    end;
    System.Writeln(txt,'end;');
    System.writeln(txt,'(*{KEY BEGIN}');
    for I := 0 to Indexlistbox.Items.count-1 do
    begin
      System.writeln(txt,'  S:=F(UPSTR(',Indexlistbox.Items[i],',6));{KEYNO=',I+1,'}{KEYLEN=6}{DUPKEY=TRUE}');
    end;
    System.writeln(txt,'{KEY END}*)');
    system.close(txt);
    {Errorwindow(GetMess(132),'');}
    Memo1.Lines.LoadFromFile(Datei);
    MEMO1.SELSTART:= 0;

end;

procedure TStruktDialog.OpenDateiBttnClick(Sender: TObject);
var x: Integer;
    F: TField;
    SStr: ShortString;
begin
  if Opendialog1.Execute then begin
    FieldListbox.Clear;
    IndexListbox.Clear;
    TypListbox.Clear;
    LenListbox.Clear;
    TypOrgListbox.Clear;
    DatabaseListbox.Clear;
    TableListBox.Clear;
    TypOrgListbox.Clear;
    Table.TableName := OpenDialog1.FileName;
    TableListbox.Items.add(Table.TableName);
    Table.GetFieldNames(FieldListbox.Items);
    Table.GetIndexNames(IndexListbox.Items);
    Table.Open;
    if Table.FieldCount > 0 then begin
      x:= 0;
      Repeat
        F:= Table.Fields[x];
        TypListbox.Items.Add(MyFieldTypes[F.DataType]);
        TypOrgListbox.Items.Add(FieldTypes[F.DataType]);
        Str(F.Size,SStr);
        LenListbox.Items.Add(SStr);
        inc(x);
      Until (x = Table.FieldCount);
    end;
    Table.Close;
  end;
end;

procedure TStruktDialog.OpenAliasBttnClick(Sender: TObject);
begin
  Session.GetDatabaseNames(DatabaseListbox.Items);
  TableListbox.Clear;
  FieldListbox.Clear;
  IndexListbox.Clear;
  TypListbox.Clear;
  LenListbox.Clear;
  TypOrgListbox.Clear;
end;

procedure TStruktDialog.EndeBttnClick(Sender: TObject);
begin
  if (Datei <> '') and (Memo1.Modified) then Memo1.Lines.SaveToFile(Datei);
  ModalResult:= mrCancel;
end;

procedure TStruktDialog.OpenTypBttnClick(Sender: TObject);
begin
  if OpenDialog2.Execute then begin
    Datei:= OpenDialog2.FileName;
    Memo1.Lines.Loadfromfile(Datei);
    Memo1.SelStart:= 0;
  end;
end;

procedure TStruktDialog.SaveTypBttnClick(Sender: TObject);
begin
  if Memo1.Lines.Count > 0 then begin
    if SaveDialog1.Execute then begin
      Datei := SaveDialog1.FileName;
      if Datei <> '' then Memo1.Lines.SaveToFile(Datei);
    end;
  end
  else Errorwindow(GetMess(169),'');
end;

end.



Declaration

ftUnknown,
ftString,
ftSmallint,
ftInteger,
ftWord,
ftBoolean,
ftFloat,
ftCurrency,
ftBCD,
ftDate,
ftTime,
ftDateTime,
ftBytes,
ftVarBytes,
ftAutoInc,
ftBlob,
ftMemo,
ftGraphic,
ftFmtMemo,
ftParadoxOle,
ftDBaseOle,
ftTypedBinary;

Description

The TFieldType type is the set of values of the DataType property of a TField component or TFieldDef component. The following table describes each value:

Value	Description

'Unknown or undetermined',                               {ftUnkown}
'Character or string field',                             {ftString}
'16-bit integer field',                                  {ftSmallint}
'32-bit integer field',                                  {ftInteger}
'16-bit unsigned integer field',                         {ftWord}
'Boolean field',                                         {ftBoolean}
'Floating-point numeric field',                          {ftFloat}
'Money field',                                           {ftCurrency}
'Binary-Coded Decimal field',                            {ftBCD}
'Date field',                                            {ftDate}
'Time field',                                            {ftTime}
'Date and time field',                                   {ftDateTime}
'Fixed number of bytes (binary storage)',                {ftBytes}
'Variable number of bytes (binary storage)',             {ftVarBytes}
'Auto-incrementing 32-bit integer counter field',        {ftAutoInc}
'Binary Large OBject field',                             {ftBlob}
'Text memo field',                                       {ftMemo}
'Bitmap field',                                          {ftGraphic}
'Formatted text memo field',                             {ftFmtMemo}
'Paradox OLE field',                                     {ftParadoxOle}
'dBASE OLE field',                                       {ftDBaseOle}
'Typed binary field');                                   {ftTypedBinary}
