unit Itab_Def;
{copyright 1995,1996,1997 by Stellberg Computer GmbH}
interface

uses 
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms,
  {$IFDEF VER90}
  ComCtrls,
  {$ENDIF}
  Grids, Dialogs, StdCtrls, ExtCtrls, Tabnotbk, Buttons;

{$IFNDEF VER90}
Type
  ShortString     = String;
{$ENDIF}
type
  TITabDefDlg = class(TForm)
    Panel1: TPanel;
    LoadBttn: TSpeedButton;
    SaveBttn: TSpeedButton;
    OkBttn: TSpeedButton;
    OpenDialog1: TOpenDialog;
    TabbedNotebook1: TTabbedNotebook;
    ListBox1: TListBox;
    UpBttn: TSpeedButton;
    DwnBttn: TSpeedButton;
    Label1: TLabel;
    FldNamEdit: TEdit;
    TypCombo: TComboBox;
    Label2: TLabel;
    Label5: TLabel;
    SizeEdit: TEdit;
    DezEdit: TEdit;
    Label7: TLabel;
    Label3: TLabel;
    LabEdit: TEdit;
    WidthEdit: TEdit;
    Label4: TLabel;
    Label6: TLabel;
    VisCheck: TCheckBox;
    AligRadio: TRadioGroup;
    ListBox2: TListBox;
    Label8: TLabel;
    Label9: TLabel;
    KeyNamEdit: TEdit;
    Label10: TLabel;
    IdxCountEdit: TEdit;
    Label11: TLabel;
    DupKeyCheck: TCheckBox;
    Label14: TLabel;
    KeyNrEdit: TEdit;
    SpeedButton1: TSpeedButton;
    GroupBox1: TGroupBox;
    FCheck: TCheckBox;
    RCheck: TCheckBox;
    DCheck: TCheckBox;
    SCheck: TCheckBox;
    UCheck: TCheckBox;
    KeyFldList: TListBox;
    Label12: TLabel;
    Label13: TLabel;
    KeyLenEdit: TEdit;
    Label15: TLabel;
    FldLenEdit: TEdit;
    AddFldBttn: TSpeedButton;
    DelFldBttn: TSpeedButton;
    AddIdxBttn: TSpeedButton;
    DelIdxBttn: TSpeedButton;
    SaveDialog1: TSaveDialog;
    AddIdxFldBttn: TSpeedButton;
    DelIdxFldBttn: TSpeedButton;
    IdxUpBttn: TSpeedButton;
    IdxDwnBttn: TSpeedButton;
    procedure LoadBttnClick(Sender: TObject);
    procedure SaveBttnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OkBttnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FldNamEditExit(Sender: TObject);
    procedure TypComboClick(Sender: TObject);
    procedure SizeEditExit(Sender: TObject);
    procedure DezEditExit(Sender: TObject);
    procedure LabEditExit(Sender: TObject);
    procedure WidthEditExit(Sender: TObject);
    procedure AligRadioClick(Sender: TObject);
    procedure UpBttnClick(Sender: TObject);
    procedure DwnBttnClick(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure KeyNamEditExit(Sender: TObject);
    procedure KeyLenEditExit(Sender: TObject);
    procedure DupKeyCheckClick(Sender: TObject);
    procedure VisCheckClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FCheckClick(Sender: TObject);
    procedure RCheckClick(Sender: TObject);
    procedure DCheckClick(Sender: TObject);
    procedure SCheckClick(Sender: TObject);
    procedure UCheckClick(Sender: TObject);
    procedure KeyFldListClick(Sender: TObject);
    procedure FldLenEditExit(Sender: TObject);
    procedure AddFldBttnClick(Sender: TObject);
    procedure DelFldBttnClick(Sender: TObject);
    procedure AddIdxBttnClick(Sender: TObject);
    procedure DelIdxBttnClick(Sender: TObject);
    procedure AddIdxFldBttnClick(Sender: TObject);
    procedure DelIdxFldBttnClick(Sender: TObject);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure IdxUpBttnClick(Sender: TObject);
    procedure IdxDwnBttnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    Dir,Ext,Fil: ShortString;
    xListe     : TStringList;
    FldIdxListe: TStringList;
    xPos,iPos  : Integer;
    LBox2Select: Integer;
    Clicked    : Boolean;
    Procedure CheckButtons;
    Procedure TypAuswerten(Src: TStrings);
    Procedure Auswerten(Feld: ShortString);
    Procedure NewDefinition;
    Procedure CheckIndex;
    Procedure CheckFormStr(C: Char; A: Boolean);
    Procedure CheckLenStr;
  public
    DateiName: ShortString;
    TblName  : ShortString;
    Procedure Lade(D: ShortString);
  end;

  Procedure KeyStr_Auswerten(IStr: ShortString;
                             var FeldName: ShortString;
                             FeldIndexListe: TStringList;
                             var KeyLen   : Integer;
                             var DupKey   : Boolean);
  Procedure GetKeyPart(Liste: TStringList;
                       N: integer;
                       var Fld: Integer;
                       var Len: Integer;
                       var FStr: ShortString);

var
  ITabDefDlg: TITabDefDlg;

implementation

Uses ItabDat, ITable, ITblCons, ITabTool, Itab_Fld;
{$R *.DFM}

Procedure GetKeyPart(Liste: TStringList;
                     N: integer;
                     var Fld: Integer;
                     var Len: Integer;
                     var FStr: ShortString);
var IStr: ShortString;
begin
  Fld:= 0;
  Len:= 0;
  FStr:= '';
  if (N < 0) or (N >= Liste.Count) then Errorwindow('Invalid IndexList','GetKeypart')
  else begin
    IStr:= Liste[N];
    Fld:= StrInt(IStr);
    if Pos(',',IStr) > 0 then Delete(IStr,1,Pos(',',IStr));
    Len:= StrInt(IStr);
    if Pos(',',IStr) > 0 then Delete(IStr,1,Pos(',',IStr));
    if Pos(';',IStr) > 0 then FStr:= Copy(IStr,1,Pos(';',IStr)-1)
    else FStr:= IStr;
  end;
end;

Procedure KeyStr_Auswerten(IStr: ShortString;
     var FeldName: ShortString;
     FeldIndexListe: TStringList;
     var KeyLen   : Integer;
     var DupKey   : Boolean);
var ZStr,FormStr : ShortString;
    FeldIndex,Len: Integer;
begin
  FeldName:= '';
  FeldIndexListe.Clear;
  KeyLen:= 0;
  DupKey:= False;
  if Pos('=',iStr) > 0 then Delete(iStr,1,Pos('=',iStr));
  Repeat
    FeldIndex:= 0;
    Len:= 0;
    FormStr:= '';
    if Pos(',',iStr) > 0 then begin
      zStr:= Copy(iStr,1,Pos(',',iStr)-1);
      FeldIndex:= Strint(zStr);
      Delete(iStr,1,Pos(',',iStr));
    end;
    if Pos(',',iStr) > 0 then begin
      zStr:= Copy(IStr,1,Pos(',',iStr)-1);
      Len:= StrInt(ZStr);
      Delete(iStr,1,Pos(',',IStr));
    end;
    if Pos(';',iStr) > 0 then begin
      FormStr:= Copy(IStr,1,Pos(';',IStr)-1);
      Delete(iStr,1,Pos(';',IStr));
    end;
    if FeldIndex > 0 then begin
      FeldIndexListe.Add(DezStr(FeldIndex)+','+DezStr(Len)+','+FormStr);
      KeyLen:= KeyLen + Len;
    end;
  Until (Pos(';',iStr) = 0);
  if Pos('(',iStr) > 0 then begin
    Delete(iStr,1,Pos('(',iStr));
    if Pos(')',IStr) > 0 then begin
      ZStr:= Copy(IStr,1,Pos(')',IStr)-1);
      DupKey:= (zStr <> '0');
      Delete(IStr,1,Pos(')',IStr));
    end;
  end;
end;

Procedure TITabDefDlg.CheckButtons;
begin
  SaveBttn.Enabled:= (Listbox1.Items.Count > 0);
  DelFLdBttn.Enabled:= (Listbox1.Items.Count > 0);
  AddIdxBttn.Enabled:= (Listbox1.Items.Count > 0);
  DelIdxBttn.Enabled:= (Listbox2.Items.Count > 0);
  AddIdxFldBttn.Enabled:= (Listbox2.Items.Count > 0);
  DelIdxFldBttn.Enabled:= (KeyFldList.Items.Count > 0);
end;

Procedure TITabDefDlg.Lade(D: ShortString);
var i: Integer;
    xStr: ShortString;
    Einfuegen: Boolean;
    SK,SS: Boolean;
begin
  SS:= False;
  SK:= False;
  if FileExists(D) then xListe.LoadFromFile(D)
  else begin
    D:= Copy(D,1,Pos('.',D)-1) + '.TYP';
    if FileExists(D) then xListe.LoadFromFile(D);
  end;
  DateiName:= D;
  Dir:= ExtractFilePath(DateiName);
  Ext:= UpperCase(ExtractFileExt(DateiName));
  if Pos('.',Ext) > 0 then Delete(Ext,1,Pos('.',Ext));
  Fil:= ExtractFileName(DateiName);
  if TblName = '' then begin
    TblName:= DateiName;
    While Pos('\',TblName) > 0 do Delete(TblName,1,Pos('\',TblName));
    if Pos('.',TblName) > 0 then TblName:= Copy(TblName,1,Pos('.',TblName)-1);
  end;
  Listbox1.Items.Clear;
  Einfuegen:= True;
  if Ext = 'TYP' then TypAuswerten(xListe)
  else begin
    if xListe.Count > 0 then begin
      For i:= 0 to xListe.Count-1 do begin
        xStr:= xListe[i];
        if Pos('=',xStr) > 0 then xStr:= Copy(xStr,1,Pos('=',xStr)-1);
        if Pos('[STRUCTURE]',xStr) > 0 then SS:= True;
        if Pos('[KEYS]',xStr) > 0 then SK:= True;
        if pos('[KEYS]',xStr) > 0 then Einfuegen:= False;
        if (Pos('[STRUCTURE]',xStr) = 0) and (Pos('[KEYS]',xStr) = 0) then begin
          if Einfuegen then Listbox1.Items.Add(xStr)
          else Listbox2.Items.Add(xStr);
        end;
      end;
      if SS = False then xListe.Insert(0,'[STRUCTURE]');
      if SK = False then xListe.Add('[KEYS]');
    end;
  end;
  IdxCountEdit.Text:= DezStr(Listbox2.Items.Count);
  if Listbox1.Items.Count > 0 then begin
    Listbox1.ItemIndex:= 0;
    Listbox1Click(Self);
  end
  else begin
    if xListe.Count = 0 then begin
      xListe.Add('[STRUCTURE]');
      xListe.Add('Dummy=L;0;8;2;Dummy');
      xListe.Add('[KEYS]');
    end;
    Listbox1.Items.Add('Dummy');
  end;
  CheckButtons;
end;

procedure TITabDefDlg.LoadBttnClick(Sender: TObject);
begin
  OpenDialog1.InitialDir:= __LaufWerk;
  if OpenDialog1.Execute then begin
    DateiName:= OpenDialog1.FileName;
    Lade(DateiName);
  end;
end;

procedure TITabDefDlg.SaveBttnClick(Sender: TObject);
var DateiName2,Fil2,Dir2,Ext2: ShortString;
    Klar: Boolean;
begin
  if TblName = '' then begin
    if SaveDialog1.Execute = False then Exit
    else begin
      TblName:= SaveDialog1.FileName;
      While Pos('\',Tblname) > 0 do Delete(TblName,1,Pos('\',Tblname));
      if Pos('.',Tblname) > 0 then TblName:= Copy(TblName,1,Pos('.',Tblname)-1);
    end;
  end;
  if (__Laufwerk <> '') and (Copy(__Laufwerk,Length(__Laufwerk),1) <> '\') then
  __Laufwerk:= __Laufwerk + '\';
  DateiName2:= __Laufwerk + TblName + '.DEF';
  if FileExists(DateiName2) then begin
    Klar:= (MessageDlg('??'+GetMess(73)+' '+GetMess(74),mtConfirmation, [mbYes, mbNo], 0) = mrYes);
  end
  else Klar:= True;
  if Klar then begin
    if KeyNamEdit.Modified then CheckIndex;
    if FldNamEdit.Modified then NewDefinition;
    xListe.SaveToFile(DateiName2);
    DateiName:= DateiName2;
    Dir:= ExtractFilePath(DateiName);
    Ext:= UpperCase(ExtractFileExt(DateiName));
    if Pos('.',Ext) > 0 then Delete(Ext,1,Pos('.',Ext));
    Fil:= ExtractFileName(DateiName);
  end;
end;

Procedure GetArray(AStr: ShortString;
                   var Arr1,Arr2: Integer);
var A1Str: ShortString;
    A1,A2,Code: Integer;
begin
  Arr1:= 1;
  Arr2:= 1;
  if (Pos('ARRAY[',AStr) > 0) and (Pos('CHAR',Astr) = 0) then begin
    Delete(AStr,1,Pos('ARRAY[',AStr)+5);
    if Pos(']',AStr) > 0 then begin
      AStr:= Copy(AStr,1,Pos(']',AStr)-1);
      if Pos('.',AStr) > 0 then begin
        A1Str:= Copy(AStr,1,Pos('.',AStr)-1);
        While (Pos('.',AStr) > 0) do Delete(AStr,1,Pos('.',AStr));
        Strip(a1Str); Strip(AStr);
        Val(A1Str,A1,Code);
        Val(AStr,A2,Code);
        if (A1 > 0) and (A2 > 0) then begin
          Arr1:= A1;
          Arr2:= A2;
          if Arr1 > Arr2 then begin
            A1:= Arr2;
            Arr2:= Arr1;
            Arr1:= A1;
          end;
        end;
      end;
    end;
  end;
end;

Procedure TITabDefDlg.TypAuswerten(Src: TStrings);
var i,ixx,a,arr1,arr2,Len,Units1,Units2: Integer;
    ix,DPos,DezX,Code: Integer;
    Dest,Keys,Flds,KeyNames: TStringList;
    Einfuegen,RecEinlesen,KeyEinlesen,Fertig: Boolean;
    TText,TypText: ShortString;
    FldNam, FStr, FeldName, Typ, DzStr, KeyTxt: ShortString;
    VisStr,xStr,AligStr,KeyNam,MerkTxt: ShortString;
begin
  if Src.Count > 0 then begin
    Dest:= TStringList.Create;
    Keys:= TStringList.Create;
    Flds:= TStringList.Create;
    KeyNames:= TStringList.Create;
    Dest.Add('[STRUCTURE]');
    RecEinlesen:= False;
    KeyEinlesen:= False;
    For i:= 0 to Src.Count - 1 do begin
      TText:= UpperCase(Src[i]);
      Strip(TText);
      TyPText:= '';
      if (Pos('TYPE',TText) > 0) or (Pos('=RECORD',TText) > 0) then RecEinlesen:= True;
      if (Pos('KEYBEGIN',TText) > 0) then KeyEinlesen:= True;
      if (RecEinlesen) then begin
        if (Pos(':',TText) > 0) then begin
          GetArray(TText,Arr1,Arr2);
          FldNam:= Copy(TText,1,Pos(':',TText)-1);
          Strip(FldNam);
          FldNam:= LCase(FldNam);
          FeldName:= FldNam;
          MerkTxt:= TText;
          {if Length(FldNam) > 8 then FldNam:= Copy(FldNam,1,8);}
          For a:= Arr1 to Arr2 do begin
            TText:= MerkTxt; {TText zurcksetzen wegen Array}
            if (Pos('DUMMY',TText) > 0) or (Pos('IGNORE',TText) > 0) then VisStr:= '0'
            else VisStr:= '1';
            AligStr:= '0';
            if Arr1 <> Arr2 then FldNam:= FeldName + DezStr(a);
            Flds.Add(FldNam);
            Len:= 4;
            Units1:= 1;
            Units2:= 0;
            if Pos('WORD',TText) > 0 then
            begin
              if (Pos('DATUM',TText) > 0) or (Pos('DATE',TText) > 0) then
              begin
                Typ:= 'X';
                Len:= 8;
              end
              else Typ:= 'W';
              Units1:= Len;
              AligStr:= '2';
            end
            else if Pos('INTEGER',TText) > 0 then begin
              Typ:= 'I';
              Units1:= 6;
              AligStr:= '2';
            end
            else if Pos('BYTE',TText) > 0 then begin
              Typ:= 'Y';
              Units1:= 1;
              AligStr:= '2';
            end
            else if Pos('BOOLEAN',TText) > 0 then begin
              Typ:= 'B';
              Units1:= 2;
            end
            else if Pos('LONGINT',TText) > 0 then begin
              if (Pos('DATUM',TText) > 0) or (Pos('DATE',TText) > 0) then begin
                Typ:= 'D';
                Len:= 8;
              end
              else Typ:= 'L';
              Units1:= 8;
              AligStr:= '2';
            end
            else if Pos('REAL',TText) > 0 then begin
              Typ:= 'R';
              Len:= 12;
              Units1:= 12;
              Units2:= 2;
              AligStr:= '2';
              DzStr:= TText;
              Strip(DzStr);
              DPos:= Pos('{NACHK',DzStr);
              if DPos > 0 then begin
                if Pos('OMMASTELLEN',DzStr) > 0 then Delete(DzStr,Pos('OMMASTELLEN',DzStr),11);
                if Pos('=',DzStr) > 0 then Delete(DzStr,Pos('=',DzStr),1);
                Delete(DzStr,1,DPos+17);
                DPos:= Pos('}',DzStr);
                if DPos > 0 then begin
                  DzStr:= Copy(DzStr,1,DPos-1);
                  Strip(DzStr);
                  Val(DzStr,Dezx,Code);
                  if Dezx > 0 then Units2:= Dezx;
                end;
              end
              else begin
                DPos:= Pos('{DECIMALS=',DzStr);
                if DPos > 0 then begin
                  Delete(DzStr,1,DPos+9);
                  DPos:= Pos('}',DzStr);
                  if DPos > 0 then begin
                    DzStr:= Copy(DzStr,1,DPos-1);
                    Strip(DzStr);
                    Val(DzStr,Dezx,Code);
                    if Dezx > 0 then Units2:= Dezx;
                  end;
                end;
              end;
              Typ:= 'R'+DezStr(Units2);
            end
            else if Pos('MEMO',TText) > 0 then begin
              Typ:= 'M';
            end
            else begin
              Typ:= 'S';
              Units1:= 255;
              Len:= 256;
              if Pos('ARRAY[',TText) > 0 then begin
                Delete(TText,1,Pos('ARRAY[',TText));
                Delete(TText,1,Pos(']',TText));
              end
              else if Pos('CHAR',TText) > 0 then begin
                Typ:= 'C';
                Len:= 2;
                Units1:= 1;
              end;
              if Pos('STRING',TText) > 0 then begin
                if Pos('[',TText) > 0 then begin
                  Delete(TText,1,Pos('[',TText));
                  TText:= Copy(TText,1,Pos(']',TText)-1);
                  Val(TText,Len,Code);
                end
                else Len:= 255;
                Units1:= Len;
                Len:= Units1 + 1;
              end;
              if Typ = 'S' then Typ:= 'S'+DezStr(Units1);
            end;
            TypText:= FldNam+'='+Typ+';'+VisStr+';'+DezStr(Units1)+';'+AligStr+';'+FldNam;
            if TypText <> '' then Dest.Add(TypText);
          end; {for}
        end; { if : }
      end;
      if KeyEinlesen then begin
        TypText:= '';
        KeyNam:= '';
        if Pos('KEYNO',TText) > 0 then begin
          KeyTxt:= TText;
          FStr:= '';
          if Pos('UPCASE(',TText) > 0 then FStr:= FStr + 'U';
          if Pos('DATESTR(',TText) > 0 then FStr:= FStr + 'S';
          if Pos('DEZSTR(',TText) > 0 then FStr:= FStr + 'D';
          if Pos('RIGHTNULL(',TText) > 0 then FStr:= FStr + 'R';
          if Pos('F(',TText) > 0 then FStr:= FStr + 'F';
          KeyNam:= TText;
          if Pos('{KEYNAME',TText) > 0 then begin
            Delete(TText,1,Pos('{KEYNAME',TText));
            if Pos('=',TText) > 0 then Delete(TText,1,Pos('=',TText));
            if Pos('}',TText) > 0 then TText:= Copy(TText,1,Pos('}',TText)-1);
            KeyNam:= TText;
          end
          else if Pos('(',TText) > 0 then begin
            if Pos(')',TText) > 0 then TText:= Copy(TText,1,Pos(')',TText)-1);
            if Pos(',',TText) > 0 then TText:= Copy(TText,1,Pos(',',TText)-1);
            While (Pos('(',TText) > 0) do Delete(TText,1,Pos('(',TText));
            KeyNam:= TText;
            if KeyNam = '' then KeyNam:= 'Index';
          end;
          if KeyNames.Count > 0 then begin
            ixx:= 0;
            While KeyNames.IndexOf(KeyNam) > -1 do begin
              inc(ixx);
              KeyNam:= TText + DezStr(ixx);
            end;
          end;
          KeyNames.Add(KeyNam);
          TypText:= LCase(KeyNam)+'=';
          Fertig:= False;
          Repeat
            While (Pos('(',KeyTxt) > 0) and (Pos('(',KeyTxt) < Pos(')',KeyTxt)) do begin
              Delete(KeyTxt,1,Pos('(',KeyTxt));
            end;
            if Pos(')',KeyTxt) > 0 then begin
              FldNam:= Copy(KeyTxt,1,Pos(')',KeyTxt)-1);
              if Pos(',',FldNam) > 0 then FldNam:= Copy(FldNam,1,Pos(',',FldNam)-1);
              FldNam:= Lcase(FldNam);
              ix:= Flds.Indexof(FldNam);
              if ix > -1 then begin
                Len:= 30;
                if Pos(',',KeyTxt) > 0 then begin
                  if (Pos('(',KeyTxt) = 0) or (Pos('(',KeyTxt) > Pos(',',KeyTxt)) then begin
                    Delete(KeyTxt,1,Pos(',',KeyTxt));
                    if Pos(')',KeyTxt) > 0 then begin
                      DzStr:= Copy(KeyTxt,1,Pos(')',KeyTxt)-1);
                      Val(DzStr,Len,Code);
                    end;
                  end;
                end;
                TypText:= TypText + DezStr(ix+1) + ',' + DezStr(Len) + ',' + FStr +';';
              end;
            end;
            if Pos('+',KeyTxt) > 0 then begin
              Delete(KeyTxt,1,Pos('+',KeyTxt))
            end
            else Fertig:= True;
          Until Fertig;
        end;
        if TypText <> '' then Keys.Add(TypText);
      end;
      if Pos('END;',TText) > 0 then RecEinlesen:= False;
      if Pos('KEYEND',TText) > 0 then KeyEinlesen:= False;
    end;
    Listbox2.Items.Clear;
    Dest.Add('[KEYS]');
    if Keys.Count > 0 then begin
      For i:= 0 to Keys.Count-1 do begin
        xStr:= Keys[i];
        Dest.Add(xStr);
        if Pos('=',xStr) > 0 then xStr:= Copy(xStr,1,Pos('=',xStr)-1);
        Listbox2.Items.Add(xStr);
      end;
    end;
    Listbox1.Items.Clear;
    if Dest.Count > 0 then begin
      Einfuegen:= True;
      for i:= 0 to Dest.Count - 1 do begin
        xStr:= Dest[i];
        if Pos('=',xStr) > 0 then xStr:= Copy(xStr,1,Pos('=',xStr)-1);
        if Pos('[KEYS]',xStr) > 0 then Einfuegen:= False;
        if (Einfuegen) and (Pos('[STRUCTURE]',xStr) = 0) then Listbox1.Items.Add(xStr);
      end;
    end;
    Flds.Free;
    Keys.Free;
    Src.Assign(Dest);
    Dest.Free;
    KeyNames.Free;
  end;
end;

procedure TITabDefDlg.FormCreate(Sender: TObject);
begin
  Caption:= GetMess(88);
  Label1.Caption:= GetMess(89);
  Label2.Caption:= GetMess(90);
  Label3.Caption:= GetMess(93);
  Label4.Caption:= GetMess(94);
  Label5.Caption:= GetMess(91);
  Label6.Caption:= GetMess(95);
  Label7.Caption:= GetMess(92);
  AligRadio.Caption:= GetMess(96);
  AligRadio.Items.Clear;
  AligRadio.Items.Add(GetMess(97));
  AligRadio.Items.Add(GetMess(98));
  AligRadio.Items.Add(GetMess(99));
  LoadBttn.Hint:= GetMess(100);
  SaveBttn.Hint:= GetMess(101);
  SpeedButton1.Hint:= GetMess(102);
  Label10.Caption:= GetMess(103);
  AddIdxBttn.Hint:= GetMess(104);
  DelIdxBttn.Hint:= GetMess(105);
  IdxUpBttn.Hint:= GetMess(106);
  IdxDwnBttn.Hint:= GetMess(106);
  AddIdxFldBttn.Hint:= GetMess(107);
  DelIdxFldBttn.Hint:= GetMess(108);

  xListe:= TStringList.Create;
  FldIdxListe:= TStringList.Create;
  DateiName:= '';
  TblName:= '';
  xPos:= -1;
  iPos:= -1;
  LBox2Select:= -1;
  Clicked:= False;
end;

procedure TITabDefDlg.OkBttnClick(Sender: TObject);
begin
  SaveBttnClick(Sender);
  ModalResult:= idOk;
end;

procedure TITabDefDlg.FormDestroy(Sender: TObject);
begin
  FldIdxListe.Free;
  xListe.Free;
end;

Procedure TITabDefDlg.Auswerten(Feld: ShortString);
var x, Code: Integer;
    Gefunden, aVisible: Boolean;
    xStr,aDispLabel,vStr: ShortString;
    ASiz,ADez,ADispWidth: Integer;
    AAlign: TAlignment;
    ATyp: IFieldType;
begin
  x:= 0;
  xPos:= -1;
  Gefunden:= False;
  Repeat
    xStr:= xListe[x];
    if Pos('=',xStr) > 0 then xStr:= Copy(xStr,1,Pos('=',xStr)-1);
    if UpStr(xStr) = UpStr(Feld) then Gefunden:= True
    else inc(x);
  Until (Gefunden) or (x = xListe.Count);
  if Gefunden then begin
    xPos:= x;
    xStr:= xListe[x];
    if Pos('=',xStr) > 0 then Delete(xStr,1,Pos('=',xStr));
    ASiz := 0;
    ADez := 0;
    ADispLabel:= Feld;
    ADispWidth:= 0;
    AAlign:= taLeftJustify;
    AVisible:= True;
    Case xStr[1] of
      ' ',',' : ;
      'B' : Begin ASiz := 1; TypCombo.ItemIndex:= 6; End; {Boolean}
      'Y' : Begin ASiz := 1; TypCombo.ItemIndex:= 9; End; {Byte}
      'C' : Begin ASiz := 1; TypCombo.ItemIndex:= 7; End; {Char}
      'I' : Begin
              {$IFDEF VER90}
              ASiz := 2; TypCombo.ItemIndex:= 1; End; {Integer}
              {Unterscheidung Integer - ShortInt fehlt noch,
               weil Property COMPATIBLE = 16Bit hier nicht ankommt}
              {$ELSE}
              ASiz := 2; TypCombo.ItemIndex:= 1; End; {Integer}
              {$ENDIF}
      'W' : Begin ASiz := 2; TypCombo.ItemIndex:= 2; End; {Word}
      'L' : Begin ASiz := 4; TypCombo.ItemIndex:= 4; End; {Longint}
      'D' : Begin ASiz := 4; TypCombo.ItemIndex:= 5; End; {Longint}
      'X' : Begin ASiz := 2; TypCombo.ItemIndex:= 8; End; {Word}
      'R' : Begin
              ASiz := 6;
              TypCombo.ItemIndex := 3;
              Delete(xStr,1,1);
              ADez:= StrInt(xStr);
            End; {Real}
      'S' : Begin                                    {String}
              delete(xStr,1,1);
              ASiz := StrInt(xStr)+1;
              delete(xStr,1,Pos(';',xStr)-1);
              TypCombo.ItemIndex := 0;
            End; {of Case}
            Else Begin
              TypCombo.ItemIndex := -1;
              errorwindow (GetMess(57),'RecDef: '+xStr);
              Exit;
            End;
    End; {case}
    delete(xStr,1,Pos(';',xStr));
    aDispLabel:= Feld;
    aDispWidth:= Asiz;
    if Pos(';',xStr) > 0 then begin {visible auslesen}
      VStr:= Copy(xStr,1,Pos(';',xStr)-1);
      Strip(VStr);
      if VStr = '0' then aVisible:= False;
      Delete(xStr,1,Pos(';',xStr));
    End;
    if Pos(';',xStr) > 0 then Begin {displaywidth auslesen}
      VStr:= Copy(xStr,1,Pos(';',xStr)-1);
      Val(VStr,aDispWidth,Code);
      Delete(xStr,1,Pos(';',xStr));
    End;
    if Pos(';',xStr) > 0 then Begin {alignment auslesen}
      vStr:= Copy(xStr,1,Pos(';',xStr)-1);
      Val(VStr,X,Code);
      Case x of
        1: aAlign:= taCenter;
        2: aAlign:= taRightJustify;
        Else aAlign:= taLeftJustify;
      End;
      Delete(xStr,1,Pos(';',xStr));
    End;
    Strip(xStr);
    if xStr <> '' then aDispLabel:= xStr;
    if TypCombo.ItemIndex = 0 then SizeEdit.Text:= DezStr(aSiz-1)
    else SizeEdit.Text:= DezStr(aSiz);
    DezEdit.Text:= DezStr(aDez);
    LabEdit.Text:= aDispLabel;
    WidthEdit.Text:= DezStr(aDispWidth);
    VisCheck.Checked:= aVisible;
    if aAlign = taCenter then AligRadio.ItemIndex:= 1
    else if aAlign = taRightJustify then AligRadio.ItemIndex:= 2
    else AligRadio.ItemIndex:= 0;
  end
  else Errorwindow(Feld,GetMess(127));
end;

procedure TITabDefDlg.ListBox1Click(Sender: TObject);
var idx: Integer;
    xNam: ShortString;
begin
  Clicked:= True;
  idx:= Listbox1.ItemIndex;
  if Idx >= 0 then begin
    xNam:= Listbox1.Items[idx];
    FldNamEdit.Text:= xNam;
    Auswerten(xNam);
  end;
  CheckButtons;
  if Idx = Listbox1.Items.Count-1 then DwnBttn.Enabled:= False
  else DwnBttn.Enabled:= True;
  if Idx < 2 then UpBttn.Enabled:= False
  else UpBttn.Enabled:= True;
  Clicked:= False;
end;

Procedure TITabDefDlg.NewDefinition;
var xStr,T  : ShortString;
    ASiz,idx: Integer;
begin
  if FldNamEdit.Text = '' then Errorwindow('Invalid fieldname','')
  else if Listbox1.Items.Count = 0 then Errorwindow('To add field please press button ADD FIELD','')
  else begin
    xStr:= FldNamEdit.Text + '=';
    case TypCombo.ItemIndex of
      0: begin
           T:= 'S'+DezStr(StrInt(SizeEdit.Text));
           ASiz:= StrInt(SizeEdit.Text)+1;
         end;
      1: begin
           T:= 'I';
           ASiz:= 2;
         end;
      2: begin
           T:= 'W';
           ASiz:= 2;
         end;
      3: begin
           T:= 'R'+DezStr(StrInt(DezEdit.Text));
           ASiz:= 6;
         end;
      4: begin
           T:= 'L';
           ASiz:= 4;
         end;
      5: begin
           T:= 'D';
           ASiz:= 4;
         end;
      6: begin
           T:= 'B';
           ASiz:= 1;
         end;
      7: begin
           T:= 'C';
           ASiz:= 1;
         end;
      8: begin
           T:= 'X';
           ASiz:= 2;
         end;
      9: begin
           T:= 'Y';
           ASiz:= 1;
         end;
    end;
    xStr:= xStr + T +';';
    if VisCheck.Checked then xStr:= xStr + '1;'
    else xStr:= xStr + '0;';
    xStr:= xStr + DezStr(StrInt(WidthEdit.Text))+';';
    xStr:= xStr + DezStr(AligRadio.ItemIndex)+';';
    xStr:= xStr + LabEdit.Text;
    xListe[xPos]:= xStr;
    idx:= Listbox1.ItemIndex;
    if Idx > -1 then begin
      if (uppercase(Listbox1.Items[Idx]) = 'DUMMY') and
         (uppercase(FldNamEdit.Text) <> 'DUMMY') then begin
        Errorwindow(GetMess(124),'');
        FldNamEdit.Text:= 'Dummy';
      end
      else Listbox1.Items[Idx]:= FldNamEdit.Text;
    end;
  end;
end;

procedure TITabDefDlg.FldNamEditExit(Sender: TObject);
var Txt: String;
begin
  if FldNamEdit.Modified then begin
    Txt:= LabEdit.Text;
    if (Pos('UNKNOWN',uppercase(Txt)) > 0) or (Txt = '') then LabEdit.Text:= FldNamEdit.Text;
    NewDefinition;
  end;
end;

procedure TITabDefDlg.TypComboClick(Sender: TObject);
begin
  if Clicked = False then NewDefInition;
end;

procedure TITabDefDlg.SizeEditExit(Sender: TObject);
begin
  if SizeEdit.Modified then begin
    if (WidthEdit.Text = '') or (WidthEdit.Text = '0') then WidthEdit.Text:= SizeEdit.Text;
    NewDefinition;
  end;
end;

procedure TITabDefDlg.DezEditExit(Sender: TObject);
begin
  if DezEdit.Modified then NewDefinition;
end;

procedure TITabDefDlg.LabEditExit(Sender: TObject);
begin
  if LabEdit.Modified then NewDefinition;
end;

procedure TITabDefDlg.WidthEditExit(Sender: TObject);
begin
  if WidthEdit.Modified then NewDefinition;
end;

procedure TITabDefDlg.AligRadioClick(Sender: TObject);
begin
  if Clicked = False then NewDefinition;
end;

procedure TITabDefDlg.UpBttnClick(Sender: TObject);
var Idx: Integer;
begin
  idx:= Listbox1.ItemIndex;
  if Idx > 1 then begin
    Listbox1.Items.Move(Idx,Idx-1);
    Listbox1.ItemIndex:= Idx - 1;
    xListe.Move(Idx,Idx-1);
    if Idx-1 < 2 then UpBttn.Enabled:= False
    else UpBttn.Enabled:= True;
    DwnBttn.Enabled:= True;
  end;
end;

procedure TITabDefDlg.DwnBttnClick(Sender: TObject);
var Idx: Integer;
begin
  idx:= Listbox1.ItemIndex;
  if Idx = 0 then errorwindow(GetMess(126),'')
  else if Idx < Listbox1.Items.Count-1 then begin
    Listbox1.Items.Move(Idx,Idx+1);
    Listbox1.ItemIndex:= Idx + 1;
    xListe.Move(Idx,Idx+1);
    if Idx+1 >= Listbox1.Items.Count - 1 then DwnBttn.Enabled:= False
    else DwnBttn.Enabled:= True;
    UpBttn.Enabled:= True;
  end;
end;

procedure TITabDefDlg.ListBox2Click(Sender: TObject);
var idx,i,f,fIdx : Integer;
    Txt,ZStr,iStr: ShortString;
    FeldName         : ShortString;
    FeldIndex,KeyLen : Integer;
    Gefunden,KeyLesen: Boolean;
    DupKey           : Boolean;
begin
  Clicked:= True;
  FldIdxListe.Clear;
  idx:= Listbox2.ItemIndex;
  LBox2Select:= idx;
  if Idx >= 0 then begin
    Txt:= Listbox2.Items[idx];
    KeyNamEdit.Text:= Txt;
    i:= 0;
    iPos:= -1;
    Gefunden:= False;
    KeyLesen:= False;
    Repeat
      iStr:= xListe[i];
      if Pos('[KEYS]',iStr) > 0 then KeyLesen:= True;
      if Pos('=',iStr) > 0 then iStr:= Copy(iStr,1,Pos('=',iStr)-1);
      if (UpStr(iStr) = UpStr(Txt)) and (KeyLesen) then Gefunden:= True
      else inc(i);
    Until (Gefunden) or (i = xListe.Count);
    if Gefunden then begin
      iPos:= i;
      iStr:= xListe[i];
      KeyStr_Auswerten(istr,FeldName,FldIdxListe,KeyLen,DupKey);
      KeyFldList.Clear;
      if FldIdxListe.Count > 0 then begin
        For f:= 0 to FldIdxListe.Count-1 do begin
          FIdx:= StrInt(FldIdxListe[F]);
          if (FIdx > 0) and (FIdx <= Listbox1.Items.Count)
          then KeyFldList.Items.Add(Listbox1.Items[FIdx-1]);
        end;
        KeyFldList.ItemIndex:= 0;
        KeyFldListClick(Sender);
      end;
      KeyLenEdit.Text:= DezStr(KeyLen);
      Clicked:= True;
      DupKeyCheck.Checked:= DupKey;
      KeyNrEdit.Text:= DezStr(idx+1);
    end;
  end;
  if Idx < Listbox2.Items.Count - 1 then IdxDwnBttn.Enabled:= True
  else IdxDwnBttn.Enabled:= False;
  if Idx > 0 then IdxUpBttn.Enabled:= True
  else IdxUpBttn.Enabled:= False;
  CheckButtons;
  Clicked:= False;
end;

procedure TITabDefDlg.KeyNamEditExit(Sender: TObject);
begin
  if KeyNamEdit.Modified then CheckIndex;
end;

Procedure TITabDefDlg.CheckIndex;
var idx,i: Integer;
    Txt  : ShortString;
begin
  if (KeyNamEdit.Text <> '') and (iPos > -1) then begin
    idx:= Lbox2Select;
    Listbox2.ItemIndex:= idx;
    if idx > -1 then begin
      Listbox2.Items[idx]:= KeyNamEdit.Text;
      Txt:= KeyNamEdit.Text+'=';
      For i:= 0 to FldIdxListe.Count-1 do Txt:= Txt + FldIdxListe[i] + ';';
      if DupKeyCheck.Checked then Txt:= Txt +'(1)'
      else Txt:= Txt + '(0)';
      xListe[iPos]:= Txt;
    end;
  end
  else Errorwindow('No KeyName',KeyNamEdit.Text + '/'+DezStr(ipos));
end;

procedure TITabDefDlg.KeyLenEditExit(Sender: TObject);
begin
  if KeyLenEdit.Modified then CheckIndex;
end;

procedure TITabDefDlg.DupKeyCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckIndex;
end;

Procedure TITabDefDlg.CheckFormStr(C: Char; A: Boolean);
var x: Integer;
    MStr,NeuStr,FormStr: String;
begin
  x:= KeyFldList.ItemIndex;
  if (x >= 0) and (x < FldIdxListe.Count) then begin
    MStr:= FldIdxListe[x];
    NeuStr:= '';
    if Pos(',',MStr) > 0 then begin
      NeuStr:= NeuStr + Copy(MStr,1,Pos(',',MStr));
      Delete(MStr,1,Pos(',',MStr));
    end;
    if Pos(',',MStr) > 0 then begin
      NeuStr:= NeuStr + Copy(MStr,1,Pos(',',MStr));
      Delete(MStr,1,Pos(',',MStr));
    end;
    FormStr:= '';
    if Pos(',',MStr) > 0 then FormStr:= Copy(MStr,1,Pos(',',MStr)-1)
    else FormStr:= MStr;
    if Pos(';',FormStr) > 0 then FormStr:= Copy(FormStr,1,Pos(';',FormStr)-1);
    if (Pos(C,FormStr) > 0) then begin
      if A = False then Delete(FormStr,Pos(C,FormStr),1);
    end
    else if A then FormStr:= FormStr + C;
    NeuStr:= NeuStr + FormStr;
    FldIdxListe[x]:= NeuStr;
    CheckIndex;
  end
  else Errorwindow('falscher Index',DezStr(x));
end;

procedure TITabDefDlg.VisCheckClick(Sender: TObject);
begin
  if Clicked = False then NewDefinition;
end;

procedure TITabDefDlg.SpeedButton1Click(Sender: TObject);
begin
  ModalResult:= mrCancel;
end;

procedure TITabDefDlg.FCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckFormStr('F',FCheck.Checked);
end;

procedure TITabDefDlg.RCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckFormStr('R',RCheck.Checked);
end;

procedure TITabDefDlg.DCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckFormStr('D',DCheck.Checked);
end;

procedure TITabDefDlg.SCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckFormStr('S',SCheck.Checked);
end;

procedure TITabDefDlg.UCheckClick(Sender: TObject);
begin
  if Clicked = False then CheckFormStr('U',UCheck.Checked);
end;

procedure TITabDefDlg.KeyFldListClick(Sender: TObject);
var x,Len: Integer;
    MStr : ShortString;
    FormStr: ShortString;
begin
  Clicked:= True;
  x:= KeyFldList.ItemIndex;
  if (x >= 0) and (x < FldIdxListe.Count) then begin
    MStr:= FldIdxListe[x];
    if Pos(',',MStr) > 0 then Delete(MStr,1,Pos(',',MStr));
    Len:= StrInt(MStr);
    if Pos(',',MStr) > 0 then Delete(MStr,1,Pos(',',MStr));
    FldLenEdit.Text:= DezStr(Len);
    FormStr:= '';
    if Pos(',',MStr) > 0 then FormStr:= Copy(MStr,1,Pos(',',MStr)-1)
    else FormStr:= MStr;
    If Pos(';',FormStr) > 0 then FormStr:= Copy(FormStr,1,Pos(';',FormStr)-1);
    FCheck.Checked:= (Pos('F',FormStr) > 0);
    UCheck.Checked:= (Pos('U',FormStr) > 0);
    RCheck.Checked:= (Pos('R',FormStr) > 0);
    SCheck.Checked:= (Pos('S',FormStr) > 0);
    DCheck.Checked:= (Pos('D',FormStr) > 0);
  end;
  Clicked:= False;
end;

Procedure TITabDefDlg.CheckLenStr;
var x,f,l,Ges: Integer;
    MStr,NeuStr,FormStr: ShortString;
begin
  x:= KeyFldList.ItemIndex;
  if (x >= 0) and (x < FldIdxListe.Count) then begin
    MStr:= FldIdxListe[x];
    NeuStr:= '';
    if Pos(',',MStr) > 0 then begin
      NeuStr:= NeuStr + Copy(MStr,1,Pos(',',MStr));
      Delete(MStr,1,Pos(',',MStr));
    end;
    if Pos(',',MStr) > 0 then begin
      NeuStr:= NeuStr + FldLenEdit.Text + ',';
      Delete(MStr,1,Pos(',',MStr));
    end;
    FormStr:= '';
    if Pos(',',MStr) > 0 then FormStr:= Copy(MStr,1,Pos(',',MStr)-1)
    else FormStr:= MStr;
    if Pos(';',FormStr) > 0 then FormStr:= Copy(FormStr,1,Pos(';',FormStr)-1);
    NeuStr:= NeuStr + FormStr;
    FldIdxListe[x]:= NeuStr;
    CheckIndex;
    Ges:= 0;
    For x:= 0 to FldIdxListe.Count-1 do begin
      GetKeyPart(FldIdxListe,X,F,L,FormStr);
      Ges:= Ges + L;
    end;
    KeyLenEdit.Text:= DezStr(Ges);
    Listbox2.ItemIndex:= LBox2Select;
  end
  else Errorwindow('falscher Index',DezStr(x));
end;

procedure TITabDefDlg.FldLenEditExit(Sender: TObject);
begin
  if FldLenEdit.Modified then CheckLenStr;
end;

procedure TITabDefDlg.AddFldBttnClick(Sender: TObject);
var TypText,FldNam,Typ,VisStr,AligStr: ShortString;
    Units1,i: Integer;
    Gefunden: Boolean;
begin
  if xListe.Count = 0 then begin
    xListe.Add('[STRUCTURE]');
    xListe.Add('Dummy=L;0;8;2;Dummy');
    xListe.Add('[KEYS]');
  end;
  i:= 0;
  Repeat
    Inc(i);
    FldNam:= 'Unknown' + DezStr(i);
  Until Listbox1.Items.IndexOf(FldNam) < 0;
  VisStr:= '1';
  VisCheck.Checked:= True;
  Units1:= 30;
  AligStr:= '0';
  Typ:= 'S30';
  TypText:= FldNam+'='+Typ+';'+VisStr+';'+DezStr(Units1)+';'+AligStr+';'+FldNam;
  xPos:= 0;
  Gefunden:= False;
  While (xPos < xListe.Count) and (Gefunden = False) do begin
    if Pos('[KEYS]',xListe[xPos]) > 0 then Gefunden:= True
    else Inc(xPos);
  end;
  xListe.Insert(xPos,TypText);
  Inc(IPos);
  Listbox1.Items.Add(FldNam);
  Listbox1.ItemIndex:= Listbox1.Items.Count-1;
  CheckButtons;
  Listbox1.SetFocus;
  Listbox1Click(Sender);
end;

procedure TITabDefDlg.DelFldBttnClick(Sender: TObject);
var idx: Integer;
begin
  idx:= Listbox1.ItemIndex;
  if (idx >= 0) and (xPos >= 0) then begin
    if Uppercase(Listbox1.Items[idx]) = 'DUMMY' then Errorwindow(GetMess(125),'')
    else begin
      Listbox1.Items.Delete(idx);
      xListe.Delete(xPos);
      if xPos > 0 then Dec(xPos);
      if xListe.Count = 0 then xPos:= -1;
      if Idx > 0 then Listbox1.ItemIndex:= idx-1
      else if Listbox1.Items.Count = 0 then Listbox1.ItemIndex:= -1
      else Listbox1.ItemIndex:= idx;
      if IPos > -1 then Dec(IPos);
    end;
  end;
  CheckButtons;
end;

procedure TITabDefDlg.AddIdxBttnClick(Sender: TObject);
var i: Integer;
    TypText,IdxNam: ShortString;
begin
    i:= 0;
    Repeat
      Inc(i);
      IdxNam:= 'Unknown' + DezStr(i);
    Until Listbox2.Items.IndexOf(IdxNam) < 0;
    KeyFldList.Clear;
    TypText:= IdxNam+'=1,0,F;(1)';
    xListe.Add(TypText);
    Inc(IPos);
    Listbox2.Items.Add(IdxNam);
    Listbox2.ItemIndex:= Listbox2.Items.Count-1;
    Listbox2.SetFocus;
    Listbox2Click(Sender);
    IdxCountEdit.Text:= DezStr(Listbox2.Items.Count);
    CheckButtons;
end;

procedure TITabDefDlg.DelIdxBttnClick(Sender: TObject);
var idx: Integer;
begin
  idx:= Listbox2.ItemIndEx;
  if (idx >= 0) and (iPos >= 0) then begin
    Listbox2.Items.Delete(idx);
    xListe.Delete(iPos);
    if iPos > 0 then Dec(iPos);
    if xListe.Count = 0 then iPos:= -1;
    if Idx > 0 then Listbox2.ItemIndex:= idx-1
    else if Listbox2.Items.Count = 0 then Listbox2.ItemIndex:= -1
    else begin
      Listbox2.ItemIndex:= idx;
      Listbox2Click(Sender);
      Listbox2.SetFocus;
    end;
    if Idx < Listbox2.Items.Count - 1 then IdxDwnBttn.Enabled:= True
    else IdxDwnBttn.Enabled:= False;
    if Idx > 0 then IdxUpBttn.Enabled:= True
    else IdxUpBttn.Enabled:= False;
  end;
  CheckButtons;
end;

procedure TITabDefDlg.AddIdxFldBttnClick(Sender: TObject);
var x: Integer;
begin
  if Listbox1.Items.Count > 0 then begin
    if Listbox2.Items.Count > 0 then begin
      AddFldDialog:= TAddFldDialog.Create(Self);
      Try
        AddFldDialog.Listbox1.Items.Assign(Listbox1.Items);
        if AddFldDialog.ShowModal = mrOk then begin
          x:= AddFldDialog.Listbox1.ItemIndex;
          if x > -1 then begin
            KeyFldList.Items.Add(Listbox1.Items[x]);
            FldIdxListe.Add(DezStr(x+1)+',0,F');
            CheckIndex;
          end;
        end;
      Finally
        AddFldDialog.Free;
      end;
    end;
  end;
  CheckButtons;
end;

procedure TITabDefDlg.DelIdxFldBttnClick(Sender: TObject);
var Idx: Integer;
begin
  idx:= KeyFldList.ItemIndex;
  if Idx >= 0 then begin
    FldIdxListe.Delete(Idx);
    KeyFldList.Items.Delete(Idx);
    CheckIndex;
    CheckButtons;
    Listbox2.ItemIndex:= Lbox2Select;
    Listbox2Click(Sender);
    {if FldIdxListe.Count > 0 then begin
      if Idx > 0 then Dec(idx);
      KeyFldList.ItemIndex:= idx;
      KeyFldListClick(Sender);
    end;}
  end;
end;

procedure TITabDefDlg.TabbedNotebook1Change(Sender: TObject;
  NewTab: Integer; var AllowChange: Boolean);
begin
  CheckButtons;
end;

procedure TITabDefDlg.IdxUpBttnClick(Sender: TObject);
var idx: Integer;
begin
  idx:= Listbox2.ItemIndex;
  if (idx >= 0) and (iPos >= 0) then begin
    Listbox2.Items.Move(Idx,Idx-1);
    Listbox2.ItemIndex:= Idx - 1;
    xListe.Move(IPos,IPos-1);
    Dec(IPos);
    if Idx-1 < 1 then IdxUpBttn.Enabled:= False
    else IdxUpBttn.Enabled:= True;
    IdxDwnBttn.Enabled:= True;
  end;
end;

procedure TITabDefDlg.IdxDwnBttnClick(Sender: TObject);
var Idx: Integer;
begin
  idx:= Listbox2.ItemIndex;
  if (Idx < Listbox2.Items.Count-1) and (IPos < xListe.Count-1) then begin
    Listbox2.Items.Move(Idx,Idx+1);
    Listbox2.ItemIndex:= Idx + 1;
    xListe.Move(IPos,IPos+1);
    Inc(IPos);
    if Idx+1 >= Listbox2.Items.Count - 1 then IdxDwnBttn.Enabled:= False
    else IdxDwnBttn.Enabled:= True;
    IdxUpBttn.Enabled:= True;
  end;
end;

procedure TITabDefDlg.FormShow(Sender: TObject);
begin
  if xListe.Count = 0 then begin
    xListe.Add('[STRUCTURE]');
    xListe.Add('Dummy=L;0;8;2;Dummy');
    xListe.Add('[KEYS]');
    Listbox1.Items.Add('Dummy');
    Listbox1.ItemIndex:= 0;
    Listbox1Click(Sender);
  end;
end;

end.
