unit Itedbrow;

interface
Uses Classes, ITable, Graphics, Forms;

Function Erzeuge_BrowserForm(const FormIdent: Shortstring;
                             SrcTable: TITable;
                             ReorgBttn, CreatBttn, ExcelBttn,
                             DBasBttn, PrtBttn, Mit_EditDialog,
                             Browser_Editierbar: Boolean;
                             Fnt: TFont;
                             aCol: TColor): TForm;

implementation

Uses SysUtils,
     {$IFDEF VER90}
     Windows,
     {$ELSE}
     Wintypes, WinProcs,
     {$ENDIF}
     Controls, ExtCtrls, Buttons,
     Proxies, ITexBase, Dialogs,
     ITblCtrl, ItabBrow, ITabExcl,
     ITabDBas, StdCtrls, ITblCons;

function Erzeuge_BrowserForm(const FormIdent: Shortstring;
                             SrcTable: TITable;
                             ReorgBttn, CreatBttn, ExcelBttn,
                             DBasBttn, PrtBttn, Mit_EditDialog,
                             Browser_Editierbar: Boolean;
                             Fnt: TFont;
                             aCol: TColor): TForm;
var
  BtnPos         : TPoint;
  EdMethod,Method: TMethod;
  MP,UP          : TPanel;
  TN1            : TItabNavigator;
  Tbl            : TITable;
  DS             : TIsamDataSource;
  Grd            : TItabBrowser;
  i              : Integer;
  SP             : TSpeedButton;
  KC             : TIsamkeyCtrl;
  EX             : ExcelExportCtrl;
  DX             : DBaseExportCtrl;
  IT             : TIsamText;
  IH             : TIsamHeader;
  SName, SNam    : ShortString;
begin
  SName:= SrcTable.TableName;
  SNam:= SName;
  While Pos('\',SNam) > 0 do Delete(SNam,1,Pos('\',SNam));
  if Pos('.',SNam) > 0 then SNam:= Copy(SNam,1,Pos('.',SNam)-1);
  {$IFDEF VER90}
  Result := TForm.Create(nil);
  Proxies.CreateSubClass(Result, 'T' + FormIdent, TForm);
  {$ELSE}
  Result := TProxyForm.CreateAs('T' + FormIdent);
  {$ENDIF}
  with Result do begin
    BorderStyle := bsSizeable;
    AutoScroll  := True;
    Left  := 92;
    Top   := 116;
    Width := 568;
    Height:= 302;
    Position := poScreenCenter;
    Name := FormIdent;
    Caption := 'Browser';
   {$IFDEF VER90}
    Method.Code:= CreateSubClassMethod(Result,'FormCreate');
   {$ELSE}
    Method.Code := TProxyForm(Result).CreateMethod('FormCreate');
   {$ENDIF}
    Method.Data := Result;
    OnCreate    := TNotifyEvent(Method);
   {$IFDEF VER90}
    Method.Code:= CreateSubClassMethod(Result,'FormDestroy');
   {$ELSE}
    Method.Code := TProxyForm(Result).CreateMethod('FormDestroy');
   {$ENDIF}
    Method.Data := Result;
    OnDestroy   := TNotifyEvent(Method);

    with Font do begin
      Color := clBlack;
      Height:= -11;
      Name := 'Arial';
      Size := 8;
      Style:= [fsBold];
    end;

    MP:= TPanel.Create(Result);
    with MP do begin
      Parent := Result;
      Name   := 'Panel1';
      Left   := 0;
      Top    := 0;
      Width  := 560;
      Height := 41;
      Align  := alTop;
      ParentShowHint:= False;
      ShowHint := True;
      TabOrder := 1;
      Caption:= '';
    end;

    Tbl:= TITable.Create(Result);
    with Tbl do begin
      Name:= 'ITABLE1';
      SName:= SrcTable.TableName;
      TablePath:= ExtractFilePath(SName);
      TableName:= ExtractFileName(SName);
      AutoEdit:= True;
    end;

    DS:= TIsamDataSource.Create(Result);
    With DS do begin
      Name:= 'ISAMDATASOURCE1';
      DataSet:= Tbl;
    end;

    TN1:= TItabNavigator.Create(Result);
    with TN1 do begin
      Parent:= MP;
      Name:= 'ISAMNAVIGATOR1';
      VisibleButtons:= [nbTop, nbPrev, nbNext, nbBttm, nbNew,
                        nbEdit, nbDelete, nbFind, nbDat];
      DataSource:= DS;
      Top:= 7;
      Left:= 5;
      Height:= 22{24};
      Width:= 190;
    end;

    KC:= TIsamkeyCtrl.Create(Result);
    with KC do begin
      Parent:= MP;
      Name:= 'ISAMKEYCTRL1';
      Left:= 200;
      Top:= 7;
      Height:= 22{24};
      Width:= 145;
      Style:= csDropDownList;
      Hint:= GetMess(87);
      DataSource:= DS;
    end;

    Sp:= TSpeedButton.Create(Result);
    with SP do begin
      Parent:= MP;
      Left:= 520;
      Top := 8;
      Width := 25;
      Height := 25;
      Hint := 'Ende';
      Name := 'EndeBttn';
      Glyph.Handle:= LoadBitmap(HInstance,'IT_ENDE');
     {$IFDEF VER90}
      Method.Code:= CreateSubClassMethod(Result,'EndeBttnClick');
     {$ELSE}
      Method.Code := TProxyForm(Result).CreateMethod('EndeBttnClick');
     {$ENDIF}
      Method.Data := Result;
      Sp.OnClick := TNotifyEvent(Method);
    end;

    if ReorgBttn then begin
      Sp:= TSpeedButton.Create(Result);
      with SP do begin
        Parent:= MP;
        Left:= 391;
        Top := 7;
        Width := 25;
        Height := 25;
        Hint := 'Reorg Tabelle';
        Name := 'ReorgButton';
        NumGlyphs:= 1;
        Glyph.Handle:= LoadBitmap(HInstance,'IT_REORG');
       {$IFDEF VER90}
        Method.Code:= CreateSubClassMethod(Result,'ReorgButtonClick');
       {$ELSE}
        Method.Code := TProxyForm(Result).CreateMethod('ReorgButtonClick');
       {$ENDIF}
        Method.Data := Result;
        Sp.OnClick := TNotifyEvent(Method);
      end;
    end;

    if CreatBttn then begin
      Sp:= TSpeedButton.Create(Result);
      with SP do begin
        Parent:= MP;
        Left:= 417;
        Top := 7;
        Width := 25;
        Height := 25;
        Hint := 'Create Tabelle';
        Name := 'CreateButton';
        NumGlyphs:= 2;
        Glyph.Handle:= LoadBitmap(HInstance,'IT_CREATE');
       {$IFDEF VER90}
        Method.Code:= CreateSubClassMethod(Result,'CreateButtonClick');
       {$ELSE}
        Method.Code := TProxyForm(Result).CreateMethod('CreateButtonClick');
       {$ENDIF}
        Method.Data := Result;
        Sp.OnClick := TNotifyEvent(Method);
      end;
    end;

    if ExcelBttn then begin
      Sp:= TSpeedButton.Create(Result);
      with SP do begin
        Parent:= MP;
        Left:= 443;
        Top := 7;
        Width := 25;
        Height := 25;
        Hint := 'Excel Export';
        Name := 'ExcelExportBttn';
        NumGlyphs:= 1;
        Glyph.Handle:= LoadBitmap(HInstance,'IT_EXCEL');
       {$IFDEF VER90}
        Method.Code:= CreateSubClassMethod(Result,'ExcelExportBttnClick');
       {$ELSE}
        Method.Code := TProxyForm(Result).CreateMethod('ExcelExportBttnClick');
       {$ENDIF}
        Method.Data := Result;
        Sp.OnClick := TNotifyEvent(Method);
      end;

      EX:= ExcelExportCtrl.Create(Result);
      with EX do begin
        Name:= 'ExcelExportCtrl1';
        Datasource:= DS;
      end;
    end;

    if DBasBttn then begin
      Sp:= TSpeedButton.Create(Result);
      with SP do begin
        Parent:= MP;
        Left:= 469;
        Top := 7;
        Width := 25;
        Height := 25;
        Hint := 'DBase Export';
        Name := 'DBaseExportBttn';
        NumGlyphs:= 1;
        Glyph.Handle:= LoadBitmap(HInstance,'IT_DBASE');
       {$IFDEF VER90}
        Method.Code:= CreateSubClassMethod(Result,'DBaseExportBttnClick');
       {$ELSE}
        Method.Code := TProxyForm(Result).CreateMethod('DBaseExportBttnClick');
       {$ENDIF}
        Method.Data := Result;
        Sp.OnClick := TNotifyEvent(Method);
      end;
    end;

    if PrtBttn then begin
      Sp:= TSpeedButton.Create(Result);
      with SP do begin
        Parent:= MP;
        Left:= 495;
        Top := 7;
        Width := 25;
        Height := 25;
        Hint := 'Print';
        Name := 'PrintBttn';
        NumGlyphs:= 2;
        Glyph.Handle:= LoadBitmap(HInstance,'IT_PRINT');
       {$IFDEF VER90}
        Method.Code:= CreateSubClassMethod(Result,'PrintBttnClick');
       {$ELSE}
        Method.Code := TProxyForm(Result).CreateMethod('PrintBttnClick');
       {$ENDIF}
        Method.Data := Result;
        Sp.OnClick := TNotifyEvent(Method);
      end;
    end;

    if (DBasBttn) or (PrtBttn) then begin
      DX:= DBaseExportCtrl.Create(Result);
      with DX do begin
        Name:= 'DBaseExportCtrl1';
        DataSource:= DS;
      end;
    end;

    UP:= TPanel.Create(Result);
    with UP do begin
      Parent := Result;
      Name := 'Panel2';
      Align := alBottom;
      BevelInner:= bvLowered;
      Left:= 0;
      Height:= 33;
      Top:= 242;
      Width:= 560;
      ShowHint:= False;
      Caption:= '';
    end;

    IT:= TIsamText.Create(Result);
    with IT do begin
      Parent:= UP;
      Name:= 'ISAMTEXT1';
      Left:= 5;
      Top:= 8;
      Height:= 17;
      Width:= 500;
      IsamShowDetails:= True;
      DataSource:= DS;
      IsamField:= 'DUMMY';
    end;

    IH:= TIsamHeader.Create(Result);
    with IH do begin
      Parent:= Result;
      Name:= 'ISAMHEADER1';
      Left:= 0;
      Top:= 41;
      Height:= 25;
      Width:= 560;
    end;

    Grd:= TItabBrowser.Create(Result);
    with Grd do begin
      Parent          := Result;
      Name            := SNam+'ITABBROWSER';
      Color           := aCol;
      Left            := 0;
      Top             := 66;
      Width           := 560;
      Height          := 176;
      Align           := alNone;
      DataSource      := DS;
      Font.Color      := Fnt.Color;
      Font.Height     := Fnt.Height;
      Font.Name       := Fnt.Name;
      Font.Style      := Fnt.Style;
      ParentFont      := False;
      TabOrder        := 2;
      Header:= IH;
      {$IFDEF VER90}
      EdMethod.Code:= CreateSubClassMethod(Result,SNam+'ItabBrowserDblClick');
      {$ELSE}
      EdMethod.Code := TProxyForm(Result).CreateMethod(SNam+'ITabBrowserDblClick');
      {$ENDIF}
      EdMethod.Data := Result;
      if Mit_EditDialog then begin
        Grd.OnDblClick  := TNotifyEvent(EdMethod);
      end;
    end;
  end;
end;

end.
