unit Itededit;


interface
Uses Classes, ITable, Graphics, Forms;

Function Erzeuge_EditorForm(const FormIdent: Shortstring;
                            SrcTable: TITable;
                            Label_Neben_Input: Boolean;
                            InputLen_Fest: Boolean;
                            LFont,EFont: TFont;
                            NormInputs: Boolean): TForm;

implementation

Uses SysUtils, Controls,
     {$IFDEF VER90}
     Windows,
     {$ELSE}
     Wintypes, WinProcs,
     {$ENDIF} 
     StdCtrls, ExtCtrls, Buttons, Proxies,
     ITabEdit, ITblCtrl, ITexBase, ITblCons,
     ITabTool;

function Erzeuge_EditorForm(const FormIdent: Shortstring;
                            SrcTable: TITable;
                            Label_Neben_Input: Boolean;
                            InputLen_Fest: Boolean;
                            LFont, EFont: TFont;
                            NormInputs: Boolean): TForm;
var
  BtnPos   : TPoint;
  Method,KeyMethod   : TMethod;
  MP,UP,UP1,UP2,UP3: TPanel;
  SP       : TSpeedButton;
  TN1      : TItabNavigator;
  Tbl,Tbl2 : TITable;
  DS       : TIsamDataSource;
  KC       : TIsamkeyCtrl;
  dx,W,i,Ty,G,Decimals : Integer;
  F        : TIsamField;
  SLab     : TLabel;
  MInp     : TMemo;
  IDbInp   : TITabCheckBox;
  Tm       : TTimer;
  DBE      : TIsamEdit;
  DBDE     : TIsamDateEdit;
  DBNE     : TIsamNumEdit;
  SName,MStr: ShortString;
begin
  {$IFDEF VER90}
  Result := TForm.Create(nil);
  Proxies.CreateSubClass(Result, 'T' + FormIdent, TForm);
  {$ELSE}
  Result := TProxyForm.CreateAs('T' + FormIdent);
  {$ENDIF}
  with Result do begin
    BorderStyle := bsDialog;
    AutoScroll  := True;
    Left:= 100;
    Top:= 101;
    Width := 460;
    Height := 282;
    Position := poScreenCenter;
    Name := FormIdent;
    Caption := LCase(FormIdent);
    KeyPreview:= True;
    (*
   {$IFDEF VER90}
    Method.Code:= CreateSubClassMethod(Result,'FormCreate');
   {$ELSE}
    Method.Code := TProxyForm(Result).CreateMethod('FormCreate');
   {$ENDIF}
    Method.Data := Result;
    OnCreate    := TNotifyEvent(Method);
   {$IFDEF VER90}
    KeyMethod.Code:= CreateSubClassMethod(Result,'FormKeyPress');
   {$ELSE}
    KeyMethod.Code:= TProxyForm(Result).CreateMethod('FormKeyPress');
   {$ENDIF}
    KeyMethod.Data:= Result;
    OnKeyPress:= TKeyPressEvent(KeyMethod);
    *)
    with Font do begin
      Color := clBlack;
      Height:= -11;
      Name := 'Arial';
      Size := 8;
      Style:= [fsBold];
    end;

    MP:= TPanel.Create(Result);
    with MP do begin
      Parent := Result;
      Name := 'Panel1';
      Left:= 0;
      Top:= 0;
      Height:= 36;
      Width:= 449;
      Align := alTop;
      ShowHint:= True;
      Caption:= '';
    end;

    Sp:= TSpeedButton.Create(Result);
    with SP do begin
      Parent:= MP;
      Left:= 415;
      Top := 5;
      Width := 25;
      Height := 25;
      Hint := 'Ende';
      Name := 'EndeBttn';
      Glyph.Handle:= LoadBitmap(HInstance,'IT_ENDE');
     {$IFDEF VER90}
      Method.Code:= CreateSubClassMethod(Result,'EndeBttnClick');
     {$ELSE}
      Method.Code := TProxyForm(Result).CreateMethod('EndeBttnClick');
     {$ENDIF}
      Method.Data := Result;
      Sp.OnClick := TNotifyEvent(Method);
    end;

    UP:= TPanel.Create(Result);
    with UP do begin
      Parent := Result;
      Name := 'Panel2';
      Align := alBottom;
      BevelInner:= bvLowered;
      Left:= 0;
      Top:= 245;
      Width:= 449;
      Height:= 28;
      ShowHint:= False;
      Caption:= '';
    end;

    UP1:= TPanel.Create(Result);
    With UP1 do begin
      Parent:= UP;
      Left  := 1;
      Top   := 1;
      Width := 135;
      Height:= 26;
      Align := alLeft;
      BevelOuter := bvLowered;
      Font.Color := clBlack;
      Font.Height := -11;
      Font.Name := 'Arial';
      Font.Style := [];
      Name:= 'Panel3';
      Caption:= '';
    end;

    UP3:= TPanel.Create(Result);
    with UP3 do begin
      Parent:= UP;
      Left  := 140;
      Top   := 1;
      Width := 171;
      Height:= 26;
      Align := alLeft;
      ShowHint:= True;
      BevelINner := bvLowered;
      BevelOuter := bvNone;
      Font.Color := clBlack;
      Font.Height := -11;
      Font.Name   := 'Arial';
      Font.Style  := [];
      Name:= 'Panel4';
      Caption:= '';
    end;

    Tbl:= TITable.Create(Result);
    with Tbl do begin
      Name:= 'ITABLE2';
      SName:= SrcTable.TableName;
      TablePath:= ExtractFilePath(SName);
      TableName:= ExtractFileName(SName);
      AutoEdit:= True;
    end;

    DS:= TIsamDataSource.Create(Result);
    with DS do begin
      Name:= 'ISAMDATASOURCE2';
      DataSet:= Tbl;
    end;

    TN1:= TItabNavigator.Create(Result);
    with TN1 do begin
      Parent:= MP;
      Name:= 'ISAMNAVIGATOR1';
      DataSource:= DS;
      Left:= 5;
      Top:= 5;
      Height:= 22{24};
      Width:= 221;
    end;

    KC:= TIsamKeyCtrl.Create(Result);
    with KC do begin
      Parent:= MP;
      Left:= 230;
      Top:= 5;
      Height:= {24}22;
      Width:= 145;
      Style:= csDropDownList;
      Name:= 'ISAMKEYCTRL1';
      Hint:= GetMess(87);
      DataSource:= DS;
    end;

    if SrcTable.FieldCount > 0 then begin
      Ty:= 52;
      For i:= 0 to SrcTable.FieldCount - 1 do begin
        if (I > 0) then begin
          F:= SrcTable.Felder[i];
          G:= GetFieldTypEditor(F);
          if Label_Neben_Input = False then Inc(Ty,18);
          if InputLen_Fest then W:= 130 else W:= 8 * (F.Size - 1);
          if W < 30 then W:= 30;
          Case G of
            3: begin
              {MDBInp:= TDBMemo.Create(Result);
              with MDBInp do begin
                Name:= F.FieldName + 'Input';
                Parent:= Result;
                if Label_Neben_Input then Left:= 100 else Left:= 20;
                Top   := Ty;
                Width := 130;
                Height := 89;
                Font.Color := EFont.Color;
                Font.Height := EFont.Height;
                Font.Name := Efont.Name;
                Font.Style := EFont.Style;
                ParentColor := False;
                Scrollbars:= ssBoth;
                TabStop := True;
                Datasource:= DS;
                DataField:= F.FieldName;
              end;}
               end;
            1: begin
                 DBDE:= TIsamDateEdit.Create(Result);
                 With DBDE do begin
                   Name:= F.Name + 'Input';
                   Parent:= Result;
                   if Label_Neben_Input then Left:= 100 else Left:= 20;
                   Top   := Ty;
                   Width := 80{W + 10};
                   Height := 21;
                   Font.Color := EFont.Color;
                   Font.Height := EFont.Height;
                   Font.Name := EFont.Name;
                   Font.Style := EFont.Style;
                   ParentColor := False;
                   TabStop := True;
                   Datasource:= DS;
                   IsamField:= F.Name;
                 end;
               end;
            2: begin
                 DBNE:= TIsamNumEdit.Create(Result);
                 With DBNE do begin
                   Name:= F.Name + 'Input';
                   Parent:= Result;
                   if Label_Neben_Input then Left:= 100 else Left:= 20;
                   Top   := Ty;
                   Width := W;
                   Height := 21;
                   Font.Color := EFont.Color;
                   Font.Height := EFont.Height;
                   Font.Name := EFont.Name;
                   Font.Style := EFont.Style;
                   ParentColor := False;
                   TabStop := True;
                   Datasource:= DS;
                   IsamField:= F.Name;
                   NumericType:= ItabEdit.ntGeneral;
                   Case F.Typ of
                     ftInteger,
                     ftByte    : begin
                                   Decimals:= 0;
                                   Masks.PositiveMask:= '#0';
                                 end;
                     ftWord    : begin
                                   Decimals:= 0;
                                   Masks.PositiveMask:= '#0';
                                 end;
                     else begin
                       Decimals:= GetDecimals(SrcTable,i);
                       if Decimals < 2 then MStr:= '0.0'
                       else begin
                         MStr:= '0.#';
                         For dx:= 2 to Decimals do MStr:= MStr + '0';
                       end;
                       Masks.PositiveMask:= MStr;
                     end;
                   end;
                 end;
               end;
            4: begin
                 IDBInp:= TITabCheckBox.Create(Result);
                 with IDBInp do begin
                   Name:= F.Name+'Input';
                   Parent:= Result;
                   if Label_Neben_Input then Left:= 100 else Left:= 20;
                   Top   := Ty;
                   Width := 21;
                   Height := 21;
                   Font.Color := EFont.Color;
                   Font.Height := EFont.Height;
                   Font.Name := Efont.Name;
                   Font.Style := EFont.Style;
                   ParentColor := False;
                   TabStop := True;
                   Caption:= '';
                   Datasource:= DS;
                   IsamField:= F.Name;
                 end;
               end;
            else begin
                DBE:= TIsamEdit.Create(Result);
                With DBE do begin
                  Name:= F.Name + 'Input';
                  Parent:= Result;
                  if Label_Neben_Input then Left:= 100 else Left:= 20;
                  Top   := Ty;
                  Width := W;
                  Height := 21;
                  Font.Color := EFont.Color;
                  Font.Height := EFont.Height;
                  Font.Name := EFont.Name;
                  Font.Style := EFont.Style;
                  ParentColor := False;
                  TabStop := True;
                  Datasource:= DS;
                  IsamField:= F.Name;
                end;
              end;
          end;
          if Label_Neben_Input = False then Dec(Ty,18);
          SLab:= TLabel.Create(Result);
          With SLab do begin
            Name:= F.Name+'Label';
            Parent:= Result;
            Caption:= LCase(F.Name);
            Left:= 20;
            Top:= Ty + 2;
            Font.Color := LFont.Color;
            Font.Height := LFont.Height;
            Font.Name := LFont.Name;
            Font.Style := LFont.Style;
          end;
          Ty:= Ty+24;
          if Label_Neben_Input = False then Inc(Ty,20);
          if G = 3 then Ty:= Ty + 68;
        end;
      end;
    end;
  end;
end;

end.
