unit Itesedit;

interface

Uses Classes, DB, DbTables, Graphics, Forms, ITable;

function Erzeuge_EditorSource(Parent: TForm;
                              const UnitIdent, FormIdent, 
                              ProtoName: Shortstring;
                              SrcTable : TITable;
                              AltCodeTable: TTable;
                              alsMainform,
                              NormInputs: Boolean;
                              OrigPas: ShortString): TMemoryStream;

implementation

Uses SysUtils, ITabTool, ITexBase, Dialogs, ITexCode, ITabExpt,
     ITblCons;

const CRLF = #13#10;

function Erzeuge_EditorSource(Parent: TForm;
                              const UnitIdent, FormIdent,
                              ProtoName: Shortstring;
                              SrcTable : TITable;
                              AltCodeTable: TTable;
                              alsMainform,
                              NormInputs: Boolean;
                              OrigPas: ShortString): TMemoryStream;
Var Exp: TItabExptMainForm;
    I: integer;
    F: TIsamField;
    G: Byte;
    TName: ShortString;
    DBExt, DBExt2: String[10];
    NStr : ShortString;
    DbFeldList: TStringList;
    DbFldNam  : ShortString;
    SrcCode   : TStringList;
    TempSrc   : TStringList;
    Zeile,idx : Integer;
    SStr,GStr : ShortString;
    Ignorieren, Impl: Boolean;
    PS: Array[0..255] of Char;

  Procedure Einfuegen(var S: ShortString; CodeNr,x1Pos: Integer);
  var i,NavNr: Integer;
  begin
    Delete(S,x1Pos,4);
    Case CodeNr of
      1 : Insert(UnitIdent, S, x1Pos);
      2 : Insert(FormIdent, S, x1Pos);
      10: if SrcTable.FieldCount > 0 then begin
            For i:= 0 to SrcTable.FieldCount-1 do begin
              if (I > 0) then begin
                F:= SrcTable.Felder[i];
                G:= GetFieldTypEditor(F);
                Case G of
                    1: begin
                         TempSrc.Add('    '+F.Name+'Input: TIsamDateEdit;');
                         TempSrc.Add('    '+F.Name+'Label: TLabel;');
                       end;
                    2: begin
                         TempSrc.Add('    '+F.Name+'Input: TIsamNumEdit;');
                         TempSrc.Add('    '+F.Name+'Label: TLabel;');
                       end;
                    3: begin
                         TempSrc.Add('    '+F.Name+'Input: TMemo;');
                         TempSrc.Add('    '+F.Name+'Label: TLabel;');
                       end;
                    4: begin
                         TempSrc.Add('    '+F.Name+'Input: TITabCheckBox;');
                         TempSrc.Add('    '+F.Name+'Label: TLabel;');
                       end;
                    else begin
                         TempSrc.Add('    '+F.Name+'Input: TIsamEdit;');
                         TempSrc.Add('    '+F.Name+'Label: TLabel;');
                       end;
                end;
              end;
            end;
            S:= '*';
          end;
    end;
  end;

  Procedure Auswerten(S: ShortString);
  var xStr: ShortString;
      x1Pos, x2Pos, CodeNr, Code: Integer;
      PS  : Array[0..255] of Char;
  begin
    xStr:= S;
    CodeNr:= 0;
    x1Pos:= Pos('%',xStr);
    if x1Pos > 0 then begin
      While x1Pos > 0 do begin
        Delete(xStr,1,x1Pos);
        x2Pos:= Pos('%',xStr);
        if x2Pos > 0 then begin
          xStr:= Copy(xStr,1,x2Pos-1);
          Val(xStr,CodeNr,Code);
        end;
        if CodeNr > 0 then Einfuegen(S,CodeNr,x1Pos);
        xStr:= S;
        CodeNr:= 0;
        x1Pos:= Pos('%',xStr);
      end;
    end;
    if S <> '*' then begin
      TempSrc.Add(S);
    end;
  end;

begin
  Exp:= TITabExptMainForm(Parent);
  TName:= SrcTable.TableName;
  DBExt:= UpperCase(ExtractFileExt(TName));
  DBExt:= '_DBF';
  While Pos('\',TName) > 0 do Delete(TName,1,Pos('\',TName));
  if Pos('.',TName) > 0 then TName:= Copy(TName,1,Pos('.',TName)-1);
  TempSrc:= TStringList.Create;
  SrcCode:= TStringList.Create;
  SrcCode.LoadFromFile(ProtoName);
  if SrcCode.Count = 0 then MessageDlg(ProtoName+' konnte nicht geladen werden', mtError, [mbOk], 0)
  else begin
    Zeile:= 0;
    Ignorieren:= False;
    Impl:= False;
    Repeat
      SStr:= SrcCode[Zeile];
      GStr:= UpperCase(SStr);
      if Pos('IMPLEMENTATION',GStr) > 0 then Impl:= True;
      if ((Pos('FUNCTION',GStr) > 0) or (Pos('PROCEDURE',GStr) > 0)
      or (Pos('END.',GStr) > 0)) then begin
        if NormInputs = False then begin
          if ((Pos('.RESETMODIFIED',GStr) > 0) or (Pos('.GETDATA',GStr) > 0)
          or (Pos('.SETDATA',GStr) > 0) or (Pos('.LEERDATA',GStr) > 0)
          or (Pos('.ISMODIFIED',GStr) > 0)) then Ignorieren:= True
          else Ignorieren:= False;
        end
        else Ignorieren:= False;
      end;
      if Ignorieren = False then Auswerten(SStr);
      if Impl = False then Ignorieren:= False;
      if Pos('END.',GStr) > 0 then Impl:= False;
      Inc(Zeile);
    Until Zeile = SrcCode.Count;
    if OrigPas <> '' then begin
      if Exp.EdiProcUpdcheck.Checked then Proc_Update(TempSrc,OrigPas,Exp.ListBox4)
      else AltSource_Verwerten(TempSrc,OrigPas,AltCodeTable);
    end;
    SourceBuffer := StrAlloc(SourceBufferSize);
    try
      Result := TMemoryStream.Create;
      try
        if TempSrc.Count > 0 then begin
          For i:= 0 to TempSrc.Count-1 do begin
            SStr:= TempSrc[i];
            Strpcopy(Ps,SStr+CRLF);
            FmtWrite(Result,PS,[NIL]);
          end;
        end;
        Result.Position := 0;
      except
        Result.Free;
        raise;
      end;
    finally
    StrDispose(SourceBuffer);
    end;
  end;
  TempSrc.Free;
  SrcCode.Free;
end;

end.
