unit Itexcode;

interface

Uses Classes, DBTables, StdCtrls;
{$IFDEF VER90}
{$H-}
{$ELSE}
Type
Shortstring = String;
{$ENDIF}

Procedure Altsource_Verwerten(NeuSrc: TStringList;
                              Origpas: Shortstring;
                              CodeTbl: TTable);
Procedure AltForm_Verwerten(NeuStream: TMemoryStream;
                            OrigForm : Shortstring;
                            FrmTbl   : TTable);
Function GetProcName(S: Shortstring): Shortstring;
Procedure Proc_Update(NewSrc: TStringList; OrigPas: Shortstring; LBox: TListBox);

implementation

Uses ITexBase, SysUtils, Dialogs;

var MerkBereich: Byte;
    AktInt, AktImp, AktZahl,AktGlob,AktPriv,AktProt,AktPub: Integer;

Function GetProcName(S: Shortstring): Shortstring;
begin
  if Pos('PROCEDURE',S) > 0 then Delete(S,1,Pos('PROCEDURE',S) + 9);
  if Pos('FUNCTION',S) > 0 then Delete(S,1,Pos('FUNCTION',S) + 8);
  While Pos('%',S) > 0 do Delete(S,1,Pos('%',S));
  if Pos('.',S) > 0 then Delete(S,1,Pos('.',S));
  if Pos('(',S) > 0 then S:= Copy(S,1,Pos('(',S) -1);
  if Pos(':',S) > 0 then S:= Copy(S,1,Pos(':',S) -1);
  if Pos(';',S) > 0 then S:= Copy(S,1,Pos(';',S) -1);
  Result:= S;
end;

Procedure FrmSpeichern(Src: TStringList; Tbl: TTable);
var Par,Memx,Dest: TStringList;
    S, G, NStr, ParStr, MerkName: Shortstring;
    NeuReihe, i, Reihe, EndIndex, MerkIndex: Integer;
    Ignorieren   : Boolean;
begin
  Par:= TStringList.Create;
  Memx:= TStringList.Create;
  ParStr:= '1ROOT';
  MerkName:= '';
  MerkIndex:= 0;
  Par.Add(ParStr);
  ENDINDEX:= 0;
  Reihe:= 1;
  if Src.Count > 0 then begin
    For i:= 0 to Src.Count-1 do begin
      S:= Src[i];
      G:= Uppercase(S);
      if (Pos('OBJECT',G) > 0) and (Pos(':',G) > 0)
      or (i = Src.Count-1) then begin
        if i = Src.Count-1 then begin
          NStr:= 'ENDE';
        end
        else begin
          NStr:= G;
          Strip(NStr);
          Delete(NStr,Pos('OBJECT',NStr),6);
          ParStr:= Par[EndIndex];
          NStr:= ParStr+'~'+Copy(NStr,1,Pos(':',NStr)-1);
        end;
        if Memx.Count > 0 then begin
          Tbl.IndexName:= 'BNAME';
          Tbl.SetKey;
          Tbl.FieldByName('NAME').AsString:= MerkName;
          if Tbl.GotoKey = False then begin
            Tbl.Insert;
            Tbl.FieldByName('REIHE').AsInteger:= MerkIndex;
            Tbl.FieldByName('NAME').AsString:= MerkName;
            TMemoField(Tbl.FieldByName('SOURCE')).Assign(Memx);
            Tbl.Post;
          end;
          Memx.Clear;
          Tbl.IndexName:= 'BNAME';
        end;
        Reihe:= Reihe + 1;
        Inc(ENDINDEX);
        MerkIndex:= EndIndex;
        Par.Add(NStr);
        MerkName:= NStr;
      end;
      Ignorieren:= False;
      if (Pos('END',G) > 0) then begin
        Strip(G);
        if Length(G) = 3 then begin
          Par.Delete(EndIndex);
          Dec(EndIndex);
          ParStr:= Par[EndIndex];
          Ignorieren:= True;
        end;
      end;
      if (Ignorieren = False) and (Pos('TABORDER',G) = 0) then Memx.Add(S);
    end;
  end;
  Tbl.First;
  MerkIndex:= 0;
  Dest:= TStringList.Create;
  While not(Tbl.Eof) do begin
    Memx.Clear;
    Memx.Assign(TMemoField(Tbl.FieldByName('SOURCE')));
    NeuReihe:= Tbl.FieldByName('REIHE').AsInteger;
    if MerkIndex >= NeuReihe then Dest.Add(Space(2*(MerkIndex-1))+'end');
    if MerkIndex > NeuReihe then Dest.Add(Space(2*(MerkIndex-2))+'end');
    MerkIndex:= NeuReihe;
    if Memx.Count > 0 then begin
      for i:= 0 to Memx.Count-1 do Dest.Add(Memx[i]);
    end;
    Tbl.Next;
  end;
  For i:= 1 to MerkIndex do Dest.Add(Space(2*(MerkIndex-i))+'end');
  Dest.SaveToFile('GESFORM.TXT');
  Memx.Free;
  Par.Free;
  Dest.Free;
end;

Procedure AltForm_Verwerten(NeuStream: TMemoryStream;
                            OrigForm : Shortstring;
                            FrmTbl   : TTable);
var BackupDfm,Dir          : Shortstring;
    Inp,Outp,NeuInp,NeuOutp: TFileStream;
    AltFrm,NeuFrm          : TStringList;
begin
  Dir:= ExtractFilePath(OrigForm);
  While Copy(Dir,Length(Dir),1) = '\' do Dir:= Copy(Dir,1,Length(Dir)-1);
  BackupDfm:= OrigForm;
  if Pos('.',BackupDfm) > 0 then begin
    BackupDfm:= Copy(BackupDfm,1,Pos('.',BackupDfm)-1);
  end;
  While (Pos('\',BackupDfm) > 0) do Delete(BackupDfm,1,Pos('\',BackupDfm));
  BackupDfm:= Dir+'\'+BackupDfm+'.1FM';
  NeuStream.SaveToFile(Dir+'\NeuForm.stm');
  NeuInp := TFileStream.Create(Dir+'\NeuForm.stm',fmOpenRead);
  NeuOutp:= TFileStream.Create(Dir+'\NEUFORM.TXT',fmOpenReadWrite or fmCreate);
  ObjectResourceToText(NeuInp,NeuOutp);
  NeuOutp.Free;
  NeuInp.Free;
  Inp:= TFileStream.Create(OrigForm,fmOpenRead);
  Outp:= TFileStream.Create(Dir+'\ALTFORM.TXT',fmOpenReadWrite or fmCreate);
  ObjectResourceToText(Inp, Outp);
  inp.Free;
  Outp.Free;
  NeuFrm:= TStringList.Create;
  NeuFrm.LoadFromFile(Dir+'\NEUFORM.TXT');
  AltFrm:= TStringList.Create;
  AltFrm.LoadFromFile(Dir+'\ALTFORM.TXT');
  if AltFrm.Count > 0 then begin
    AltFrm.SaveToFile(BackupDfm);
    if FrmTbl.Active then FrmTbl.Close;
    FrmTbl.EmptyTable;
    FrmTbl.Open;
    if NeuFrm.Count > 0 then FrmSpeichern(NeuFrm,FrmTbl);
    FrmSpeichern(AltFrm,FrmTbl);
    Inp:= TFileStream.Create(Dir+'\GESFORM.TXT',fmOpenRead);
    OutP:= TFileStream.Create(Dir+'\NeuForm.stm',fmOpenReadWrite or fmCreate);
    ObjectTextToResource(Inp, OutP);
    OutP.Free;
    inp.Free;
    NeuStream.Clear;
    NeuStream.LoadFromFile(Dir+'\NeuForm.stm');
  end;
  AltFrm.Free;
  NeuFrm.Free;
end;

Function Bereich_Auswerten(S: Shortstring): Byte;
var Bereich: Byte;
begin
  Bereich:= MerkBereich;
  if Pos('INTERFACE',S) > 0 then begin
    Bereich:= 1;
    AktZahl:= AktInt;
  end;
  if Pos('IMPLEMENTATION',S) > 0 then begin
    Bereich:= 2;
    AktZahl:= AktImp;
  end;
  Result:= Bereich;
end;

Function Hole_BereichName(G: Shortstring; var BCount: Integer): Shortstring;
var S: Shortstring;
begin
  if (Pos('PROCEDURE',G) > 0) or (Pos('FUNCTION',G) > 0) then begin
    if Pos('PROCEDURE',G) > 0 then begin
      Delete(G,1,Pos('PROCEDURE',G)+8);
    end;
    if Pos('FUNCTION',G) > 0 then begin
      Delete(G,1,Pos('FUNCTION',G)+7);
    end;
    if Pos('.',G) > 0 then begin
      Delete(G,1,Pos('.',G));
    end;
    if Pos('(',G) > 0 then begin
      G:= Copy(G,1,Pos('(',G)-1);
    end;
    if Pos(':',G) > 0 then begin
      G:= Copy(G,1,Pos(':',G)-1);
    end;
    if Pos(';',G) > 0 then begin
      G:= Copy(G,1,Pos(';',G)-1);
    end;
    Strip(G);
    if Length(G) > 0 then S:= G;
  end
  else begin
    Inc(BCount);
    S:= 'BEREICH'+IntToStr(BCount);
  end;
  if Pos('INTERFACE',G) > 0 then S:= 'INTBEREICH';
  if Pos('IMPLEMENTATION',G) > 0 then S:= 'IMPBEREICH';
  if Pos('CLASS(',G) > 0 then S:= 'CLASSBEREICH';
  if Pos('END.',G) > 0 then S:= 'ENDEBEREICH';
  Result:= S;
end;

Procedure CheckAktZahl(x: Integer);
begin
  Case x of
    1: Inc(AktInt);
    2: Inc(AktGlob);
    3: Inc(AktPriv);
    4: Inc(AktProt);
    5: Inc(AktPub);
    6: Inc(AktImp);
  end;
  Inc(AktZahl);
end;

Function Check_Vars(ML1,ML2: TStringList): Boolean;
var Added, Suchen, Gefunden: Boolean;
    M1Str,M2Str,SuchStr    : Shortstring;
    M1,M2                  : Integer;
begin
  Added:= False;
  Suchen:= False;
  if (ML1.Count > 0) and (ML2.Count > 0) then begin
    M1:= 0;
    Repeat
      M1Str:= Uppercase(ML1[M1]);
      if Pos('VAR',M1Str) > 0 then begin
        Suchen:= True;
        Delete(M1Str,Pos('VAR',M1Str),3);
      end;
      if (Suchen) and (Pos(';',M1Str) > 0) then begin
        SuchStr:= UpperCase(M1Str);
        Strip(SuchStr);
        M2:= 0;
        Gefunden:= False;
        Repeat
          M2Str:= UpperCase(ML2[M2]);
          Strip(M2Str);
          if SuchStr = M2Str then Gefunden:= True
          else Inc(M2);
        Until (M2 = ML2.Count) or (Gefunden = True);
        if Gefunden = False then begin
          ML2.Add(M1Str);
          Added:= True;
        end;
      end;
      Inc(M1);
    Until (M1 = ML1.Count);
  end;
  Result:= Added;
end;

Function Check_Uses(ML1,ML2: TStringList): Boolean;
var Gefunden,Added,Suchen: Boolean;
    M1,M2,kPos: Integer;
    M1Str,M2Str,UStr,AddStr: Shortstring;
begin
  Added:= False;
  Suchen:= False;
  Gefunden:= False;
  AddStr:= '';
  if (ML1.Count > 0) and (ML2.Count > 0) then begin
    M1:= 0;
    Repeat
      M1Str:= Uppercase(ML1[M1]);
      if Pos('USES',M1Str) > 0 then begin
        Suchen:= True;
        Delete(M1Str,Pos('USES',M1Str),4);
      end;
      if Suchen then begin
        Strip(M1Str);
        kPos:= Pos(',',M1Str);
        if KPos = 0 then kPos:= Pos(';',M1Str);
        While (KPos > 0) do begin
          UStr:= Copy(M1Str,1,kPos-1);
          if UStr <> '' then begin
            M2:= 0;
            Gefunden:= False;
            Repeat
              M2Str:= UpperCase(ML2[M2]);
              Strip(M2Str);
              if (Pos(UStr+',',M2Str) > 0) or (Pos(UStr+';',M2Str) > 0)
              then Gefunden:= True
              else Inc(M2);
            Until (M2 = ML2.Count) or (Gefunden = True);
            if Gefunden = False then begin
              AddStr:= AddStr + ','+ UStr;
              Added:= True;
            end;
          end;
          Delete(M1Str,1,KPos);
          kPos:= Pos(',',M1Str);
          if KPos = 0 then kPos:= Pos(';',M1Str);
        end;
      end;
      if (Suchen) and (Pos(';',M1Str) > 0) then Suchen:= False;
      Inc(M1);
    Until (M1 = ML1.Count);
    if Added then begin
      M2:= 0;
      Suchen:= False;
      Repeat
        M2Str:= ML2[M2];
        if Pos('USES',UpperCase(M2Str)) > 0 then Suchen:= True;
        if (Suchen) and (Pos(';',M2Str) > 0) then begin
          Suchen:= False;
          Insert(AddStr,M2Str,Pos(';',M2Str));
          ML2[M2]:= M2Str;
          AddStr:= '';
        end
        else Inc(M2);
      Until (AddStr = '') or (M2 = ML2.Count);
    end;
  end;
  Result:= Added;
end;

Procedure CodeSpeichern(Src: TStringList; Table1: TTable);
var Memx,Memx2                 : TStringList;
    BName,S,G,M,MG,M2,M2G      : Shortstring;
    BCount,i,R1,R2             : Integer;
    Bereich                    : Byte;
    ClassOffen,Added,Gefunden  : Boolean;
    UpdateSperre               : Boolean;
begin
  BName:= 'BEREICH0';
  ClassOffen:= False;
  MerkBereich:= 0;
  UpdateSperre:= False;
  if Src.Count = 0 then MessageDlg('Datei ist leer', mtError, [mbOk], 0)
  else begin
    Memx:= TStringList.Create;
    BCount:= 0;
    For i:= 0 to Src.Count-1 do begin
      S:= Src[i];
      G:= UpperCase(S);
      Bereich:= Bereich_Auswerten(G);
      if (Pos('PROCEDURE',G) > 0) or (Pos('FUNCTION',G) > 0)
      or (Pos('CLASS(',G) > 0) or (Bereich <> MerkBereich)
      or (Pos('PRIVATE',G) > 0) or (Pos('PUBLIC',G) > 0)
      or (Pos('PROTECTED',G) > 0) or ((ClassOffen) and (Pos('END;',G) > 0))
      or (Pos('END.',G) > 0) or (i = Src.Count-1) then begin
        if Memx.Count > 0 then begin
          Table1.IndexName:= 'BNAME';
          Table1.SetKey;
          Table1.FieldByName('BEREICH').AsInteger:= MerkBereich;
          Table1.FieldByName('NAME').AsString:= BName;
          if Table1.GotoKey = False then begin
            CheckAktZahl(AktZahl Div 1000);
            Table1.Insert;
            Table1.FieldByName('BEREICH').AsInteger:= MerkBereich;
            Table1.FieldByName('REIHE').AsInteger:= AktZahl;
            Table1.FieldByName('NAME').AsString:= BName;
            TMemoField(Table1.FieldByName('SOURCE')).Assign(Memx);
            Table1.Post;
          end
          else if (UpdateSperre) then begin
            {zuerst wird ja der neue Code gespeichert.
             Wenn dann der alte Code ein NOUPDATE hat,
             muss der neue Code mit dem alten berschrieben werden}
            Table1.Edit;
            TMemoField(Table1.FieldByName('SOURCE')).Assign(Memx);
            Table1.Post;
          end
          else if Table1.FieldByName('NAME').AsString = 'CLASSBEREICH' then begin
            Memx2:= TStringList.Create;
            Memx2.Assign(TMemoField(Table1.FieldByName('SOURCE')));
            Added:= False;
            if Memx2.Count > 0 then begin
              For R1:= 0 to Memx.Count-1 do begin
                M:= Memx[R1];
                if Pos(':',M) > 0 then begin
                  Gefunden:= False;
                  MG:= Uppercase(M);
                  Strip(MG);
                  MG:= Copy(MG,1,Pos(':',MG)-1);
                  R2:= 0;
                  Repeat
                    M2:= Memx2[R2];
                    M2G:= UpperCase(M2);
                    Strip(M2G);
                    M2G:= Copy(M2G,1,Pos(':',M2G)-1);
                    if MG = M2G then Gefunden:= True
                    else Inc(R2);
                  Until (R2 = Memx2.Count) or (Gefunden = True);
                  if Gefunden = False then begin
                    Memx2.Add(M);
                    Added:= True;
                  end;
                end;
              end;
            end;
            if Added then begin
              Table1.Edit;
              TMemoField(Table1.FieldByName('SOURCE')).Assign(Memx2);
              Table1.Post;
            end;
            Memx2.Free;
          end
          else if (Table1.FieldByName('NAME').AsString = 'INTBEREICH')
               or (Table1.FieldByName('NAME').AsString = 'IMPBEREICH')
          then begin
            Memx2:= TStringList.Create;
            Memx2.Assign(TMemoField(Table1.FieldByName('SOURCE')));
            if Check_Uses(Memx,Memx2) then begin
              Table1.Edit;
              TMemoField(Table1.FieldByName('SOURCE')).Assign(Memx2);
              Table1.Post;
            end;
            Memx2.Free;
          end
          else if (Table1.FieldByName('NAME').AsString = 'VARBEREICH') then begin
            Memx2:= TStringList.Create;
            Memx2.Assign(TMemoField(Table1.FieldByName('SOURCE')));
            if Check_Vars(Memx,Memx2) then begin
              Table1.Edit;
              TMemoField(Table1.FieldByName('SOURCE')).Assign(Memx2);
              Table1.Post;
            end;
            Memx2.Free;
          end;
          Memx.Clear;
          BName:= Hole_BereichName(G,BCount);
          Table1.IndexName:= 'BREIHE';
        end;
        if Pos('CLASS',G) > 0 then begin
          AktZahl:= AktGlob;
          ClassOffen:= True;
        end;
        if Pos('PRIVATE',G) > 0 then AktZahl:= AktPriv;
        if Pos('PUBLIC',G) > 0 then AktZahl:= AktPub;
        if Pos('PROTECTED',G) > 0 then AktZahl:= AktProt;
        if (ClassOffen) and (Pos('END;',G) > 0) then begin
          BName:= 'VARBEREICH';
          ClassOffen:= False;
        end;
        MerkBereich:= Bereich;
        UpdateSperre:= False;
      end;
      if (Pos('NOUPDATE',G) > 0)
      or ((Pos('END.',G) > 0) and (i < Src.Count-1))
      or (Pos('{-}',G) > 0) then UpdateSperre:= True;
      Memx.Add(S);
    end;
    Memx.Free;
  end;
end;

Procedure Altsource_Verwerten(NeuSrc: TStringList;
                              OrigPas: ShortString;
                              CodeTbl: TTable);
var M,AltSrc: TStringList;
    Dir,S,G,BackupPas: Shortstring;
    i: Integer;
    EndeEingetragen: Boolean;
begin
  Dir:= ExtractFilePath(OrigPas);
  While Copy(Dir,Length(Dir),1) = '\' do Dir:= Copy(Dir,1,Length(Dir)-1);
  BackupPas:= OrigPas;
  if Pos('.',BackupPas) > 0 then begin
    BackupPas:= Copy(BackupPas,1,Pos('.',BackupPas)-1);
  end;
  While (Pos('\',BackupPas) > 0) do Delete(BackupPas,1,Pos('\',BackupPas));
  BackupPas:= Dir +'\'+BackupPas+'.1AS';
  AltSrc:= TStringList.Create;
  AltSrc.LoadFromFile(OrigPas);
  if AltSrc.Count > 0 then begin
    AltSrc.SaveToFile(BackupPas);
    if CodeTbl.Active then CodeTbl.Close;
    CodeTbl.EmptyTable;
    CodeTbl.Open;
    MerkBereich:= 0;
    AktZahl:= 0;
    AktInt := 1000;
    AktGlob:= 2000;
    AktPriv:= 3000;
    AktProt:= 4000;
    AktPub := 5000;
    AktImp := 6000;
    if NeuSrc.Count > 0 then CodeSpeichern(NeuSrc,CodeTbl);
    CodeSpeichern(AltSrc,CodeTbl);
  end;
  AltSrc.Free;
  CodeTbl.First;
  NeuSrc.Clear;
  EndeEingetragen:= False;
  M:= TStringList.Create;
  While not(CodeTbl.Eof) do begin
    M.Assign(TMemoField(CodeTbl.FieldByName('SOURCE')));
    if M.Count > 0 then begin
      For i:= 0 to M.Count-1 do begin
        S:= M[i];
        G:= UpperCase(S);
        if Pos('END.',G) > 0 then EndeEingetragen:= True;
        NeuSrc.Add(S);
      end;
    end;
    CodeTbl.Next;
  end;
  if EndeEingetragen = False then NeuSrc.Add('end.');
  M.Free;
  if CodeTbl.Active then CodeTbl.Close;
end;

Procedure NeuIntSuche(NeuSrc: TStringList;LStr: Shortstring; IntfProc: TStringList; var IntfPos: Shortstring);
var n: Integer;
    NStr: Shortstring;
    Gefunden,Gef1: Boolean;
begin
  IntFProc.Clear;
  n:= 0;
  Gefunden:= False;
  Gef1:= False;
  if NeuSrc.Count > 0 then begin
    Repeat
      NStr:= UpperCase(NeuSrc[n]);
      if (Pos('PROCEDURE',NStr) > 0) or (Pos('FUNCTION',NStr) > 0)
      or (Pos('PRIVATE',NStr) > 0) or (Pos('PUBLIC',NStr) > 0)
      or ((IntfPos = 'IMPLEMENTATION') and (Pos('END;',NStr) > 0)) then begin
        if Gef1 then begin
          Gefunden:= True;
          Gef1:= False;
        end
        else if Pos(LStr,NStr) > 0 then Gef1:= True;
      end;
      if Gef1 then IntfProc.Add(NeuSrc[n])
      else if Gefunden = False then begin
        if Pos('PRIVATE',NStr) > 0 then IntfPos:= 'PUBLIC';
        if Pos('PUBLIC',NStr) > 0 then IntfPos:= 'END;';
        if (Pos('END;',NStr) > 0) and (IntfPos = 'END;') then IntfPos:= 'IMPLEMENTATION';
      end;
      Inc(N);
    Until (Pos('IMPLEMENTATION',NStr) > 0) or (Gefunden) or (N > NeuSrc.Count - 1);
  end;
end;

Procedure NeuImplSuche(NewSrc: TStringList; LStr: Shortstring; ImpProc: TStringList);
var n: Integer;
    NStr: Shortstring;
    Gefunden,Gef1: Boolean;
begin
  ImpProc.Clear;
  if NewSrc.Count > 0 then begin
    n:= 0;
    Repeat
      NStr:= Uppercase(NewSrc[N]);
      Inc(N);
    Until (Pos('IMPLEMENTATION',NStr) > 0) or (N = NewSrc.Count - 2);
    Gefunden:= False;
    Gef1:= False;
    Repeat
      NStr:= Uppercase(NewSrc[N]);
      if ((Pos('PROCEDURE',NStr) > 0) or (Pos('FUNCTION',NStr) > 0)) then begin
        if Gef1 then begin
          Gefunden:= True;
          Gef1:= False;
        end
        else if (Pos(LStr,NStr) > 0) then Gef1:= True;
      end;
      if Gef1 then ImpProc.Add(NewSrc[N]);
      Inc(N);
    Until (Gefunden) or (N = NewSrc.Count -1);
  end;
end;

Procedure Proc_Update(NewSrc: TStringList; OrigPas: Shortstring; LBox: TListBox);
var AltSrc          : TStringList;
    a,n,L,i         : Integer;
    AStr,NStr,LStr  : Shortstring;
    AltGefunden     : Boolean;
    IntfPos         : Shortstring;
    IntProc,ImpProc : TStringList;
begin
  AltSrc:= TStringList.Create;
  AltSrc.LoadFromFile(OrigPas);
  IntProc:= TStringList.Create;
  ImpProc:= TStringList.Create;
  if Lbox.Items.Count > 0 then begin
    {erst INTERFACE}
    L:= 0;
    Repeat
      if LBox.Selected[L] then begin
        LStr:= UpperCase(LBox.Items[L]);
        IntfPos:= 'PRIVATE';
        NeuIntSuche(NewSrc,LStr,IntProc,IntfPos);
        if AltSrc.Count > 0 then begin
          a:= 0;
          AltGefunden:= False;
          Repeat
            AStr:= UpperCase(AltSrc[a]);
            if (Pos('PROCEDURE',AStr) > 0) or (Pos('FUNCTION',AStr) > 0) then begin
              if Pos(LSTR,AStr) > 0 then begin
                AltGefunden:= True;
                if IntProc.Count > 0 then begin
                  Repeat
                    AltSrc.Delete(a);
                    AStr:= UpperCase(AltSrc[a]);
                  Until (Pos('PROCEDURE',AStr) > 0) or (Pos('FUNCTION',AStr) > 0)
                     or (Pos('PUBLIC',AStr) > 0) or (Pos('PRIVATE',AStr) > 0)
                     or (Pos ('IMPLEMENTATION',AStr) > 0) or (a = AltSrc.Count - 1);
                  for i:= 0 to IntProc.Count - 1 do begin
                    AltSrc.Insert(a,IntProc[i]);
                    Inc(a);
                  end;
                end;
              end;
            end;
            Inc(a);
          Until (Pos('IMPLEMENTATION',AStr) > 0)
             or (A = AltSrc.Count-1) or (AltGefunden);
          if AltGefunden = False then begin
            a:= 0;
            Repeat
              AStr:= UpperCase(AltSrc[a]);
              Inc(a);
            Until (Pos('CLASS(',AStr) > 0) or (a = AltSrc.Count - 2);
            Repeat
              AStr:= UpperCase(AltSrc[a]);
              if Pos(IntfPos,AStr) > 0 then begin
                AltGefunden:= True;
                if IntProc.Count > 0 then begin
                  for i:= 0 to IntProc.Count - 1 do begin
                    AltSrc.Insert(a,IntProc[i]);
                    Inc(a);
                  end;
                end;
              end;
              Inc(a);
            Until (A = AltSrc.Count - 1) or (AltGefunden);
          end;
        end;
      end;
      Inc(L);
    Until (L = LBox.Items.Count - 1);

  {dann IMPLEMENTATION}

    L:= 0;
    Repeat
      if LBox.Selected[L] then begin
        LStr:= UpperCase(LBox.Items[L]);
        NeuImplSuche(NewSrc,LStr,ImpProc);
        if AltSrc.Count > 0 then begin
          a:= 0;
          Repeat
            AStr:= UpperCase(AltSrc[a]);
            inc(a);
          Until (Pos('IMPLEMENTATION',AStr) > 0) or (A = AltSrc.Count-2);

          AltGefunden:= False;
          Repeat
            AStr:= UpperCase(AltSrc[a]);
            if (Pos('PROCEDURE',AStr) > 0) or (Pos('FUNCTION',AStr) > 0) then begin
              if Pos(LSTR,AStr) > 0 then begin
                AltGefunden:= True;
                Repeat
                  AltSrc.Delete(a);
                  AStr:= UpperCase(AltSrc[a]);
                Until (Pos('PROCEDURE',AStr) > 0) or (Pos('FUNCTION',AStr) > 0)
                   or (Pos ('END.',AStr) > 0) or (a = AltSrc.Count - 1);
                if ImpProc.Count > 0 then begin
                  for i:= 0 to ImpProc.Count - 1 do begin
                    AltSrc.Insert(a,ImpProc[i]);
                    inc(a);
                  end;
                end;
              end;
            end;
            Inc(a);
          Until (Pos('END.',AStr) > 0)
             or (A = AltSrc.Count-1) or (AltGefunden);
          if AltGefunden = False then begin
            a:= 0;
            Repeat
              AStr:= UpperCase(AltSrc[a]);
              Inc(a);
            Until (Pos('END.',AStr) > 0) or (a = AltSrc.Count - 2);
            if ImpProc.Count > 0 then begin
              AltSrc.Insert(a,' ');
              Inc(a);
              for i:= 0 to ImpProc.Count - 1 do begin
                AltSrc.Insert(a,ImpProc[i]);
                inc(a);
              end;
            end;
          end;
        end;
      end;
      Inc(L);
    Until (L = LBox.Items.Count - 1);

  end;
  ImpProc.Free;
  IntProc.Free;
  NewSrc.Clear;
  NewSrc.Assign(AltSrc);
  AltSrc.Free;
end;

end.
