unit Upd_stru;

interface

uses
  DBITypes;

Procedure UPD_Struktur(FNummer: Integer;
                      var Fld: FldDesc;
                      var Idx: IdxDesc;
                      var FldCount: Byte;
                      var IdxCount: Byte);
Procedure WNT_FORM_PDXStruktur(FNummer: Integer;
                      var Fld: FldDesc;
                      var Idx: IdxDesc;
                      var FldCount: Byte;
                      var IdxCount: Byte);

implementation

Uses SysUtils;

Function UPD_PDXfldDes(f: Integer): FLDDesc;
var Fld: FldDesc;
begin
  FillChar(Fld,Sizeof(FldDesc),#0);
  With Fld do begin
    Case f of
      1: begin
           iFldNum    := 1;            { Feld Nummer }
           StrPCopy(szName,'RecNo');      { Feld Name }
           iFldType   := fldINT32;    {Feld Typ}
           iSubType   := fldstAUTOINC;   { Feld Subtype }
           iUnits1    := 1;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 0;   { Offset in record }
           iLen       := 4;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      2: begin
           iFldNum    := 2;            { Feld Nummer }
           StrPCopy(szName,'Bereich');      { Feld Name }
           iFldType   := fldFLOAT;    {Feld Typ}
           iSubType   := fldUNKNOWN;   { Feld Subtype }
           iUnits1    := 1;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 4;   { Offset in record }
           iLen       := 8;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      3: begin
           iFldNum    := 3;            { Feld Nummer }
           StrPCopy(szName,'Reihe');      { Feld Name }
           iFldType   := fldFLOAT;    {Feld Typ}
           iSubType   := fldUNKNOWN;   { Feld Subtype }
           iUnits1    := 1;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 12;   { Offset in record }
           iLen       := 8;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      4: begin
           iFldNum    := 4;            { Feld Nummer }
           StrPCopy(szName,'Name');      { Feld Name }
           iFldType   := fldZSTRING;    {Feld Typ}
           iSubType   := fldUNKNOWN;   { Feld Subtype }
           iUnits1    := 30;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 20;   { Offset in record }
           iLen       := 31;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      5: begin
           iFldNum    := 5;            { Feld Nummer }
           StrPCopy(szName,'Source');      { Feld Name }
           iFldType   := fldBLOB;    {Feld Typ}
           iSubType   := fldstMEMO;   { Feld Subtype }
           iUnits1    := 100;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 51;   { Offset in record }
           iLen       := 101;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
    end;
  end;
  Result:= FLD;
end;

Function UPD_PDXidxDes(f: Integer): IDXDesc;
var ix: IdxDesc;
    i: Integer;
begin
  FillChar(Ix,sizeof(idxDesc),#0);
  with Ix do begin
    Case f of
      1: begin
           StrPCopy(szName,'');
           iIndexId   := 0;
           StrPCopy(szTagName,'');
           StrPCopy(szFormat,'');
           bPrimary   := TRUE;
           bUnique    := TRUE;
           bDescending:= FALSE;
           bMaintained:= TRUE;
           bSubset    := FALSE;
           bExpIdx    := FALSE;
           iCost      := 0;
           iFldsInKey := 1;
           iKeyLen    := 4;
           bOutofDate := FALSE;
           iKeyExpType:= 0;
           For i:= 0 to 15 do aiKeyFld[i]:= 0;
           aiKeyFld[0]:= 1;
           StrPCopy(szKeyExp,'');
           StrPCopy(szKeyCond,'');
           bCaseInsensitive:= FALSE;
           iBlockSize:= 2048;
           iRestrNum := 1;
           For i:= 0 to 15 do iUnUsed[i]:= 0;
         end;
      2: begin
           StrPCopy(szName,'BReihe');
           iIndexId   := 257;
           StrPCopy(szTagName,'');
           StrPCopy(szFormat,'');
           bPrimary   := FALSE;
           bUnique    := FALSE;
           bDescending:= FALSE;
           bMaintained:= TRUE;
           bSubset    := FALSE;
           bExpIdx    := FALSE;
           iCost      := 0;
           iFldsInKey := 1;
           iKeyLen    := 8;
           bOutofDate := FALSE;
           iKeyExpType:= 0;
           For i:= 0 to 15 do aiKeyFld[i]:= 0;
           aiKeyFld[0]:= 3;
           StrPCopy(szKeyExp,'');
           StrPCopy(szKeyCond,'');
           bCaseInsensitive:= TRUE;
           iBlockSize:= 2048;
           iRestrNum := 2;
           For i:= 0 to 15 do iUnUsed[i]:= 0;
         end;
      3: begin
           StrPCopy(szName,'BName');
           iIndexId   := 256;
           StrPCopy(szTagName,'');
           StrPCopy(szFormat,'');
           bPrimary   := FALSE;
           bUnique    := FALSE;
           bDescending:= FALSE;
           bMaintained:= TRUE;
           bSubset    := FALSE;
           bExpIdx    := FALSE;
           iCost      := 0;
           iFldsInKey := 2;
           iKeyLen    := 38;
           bOutofDate := FALSE;
           iKeyExpType:= 0;
           For i:= 0 to 15 do aiKeyFld[i]:= 0;
           aiKeyFld[0]:= 2;
           aiKeyFld[1]:= 4;
           StrPCopy(szKeyExp,'');
           StrPCopy(szKeyCond,'');
           bCaseInsensitive:= TRUE;
           iBlockSize:= 2048;
           iRestrNum := 3;
           For i:= 0 to 15 do iUnUsed[i]:= 0;
         end;
    end;
  end;
  Result:= ix;
end;

Procedure UPD_Struktur(FNummer: Integer;
                      var Fld: FldDesc;
                      var Idx: IdxDesc;
                      var FldCount: Byte;
                      var IdxCount: Byte);
var i: Integer;
begin
  FldCount:= 5; {FeldAnzahl}
  IdxCount:= 3; {IndexAnzahl}
  if FNummer < 0 then begin
    i:= abs(FNummer);
    FillChar(idx,Sizeof(IdxDesc),#0);
    if i <= 3 then idx:= UPD_PDXidxDes(i);
  end
  else if FNummer > 0 then begin
    FillChar(Fld,Sizeof(FldDesc),#0);
    if FNummer <= 5 then Fld:= UPD_PDXFldDes(FNummer);
  end;
end;

Function WNT_FORM_PDXfldDes(f: Integer): FLDDesc;
var Fld: FldDesc;
begin
  FillChar(Fld,Sizeof(FldDesc),#0);
  With Fld do begin
    Case f of
      1: begin
           iFldNum    := 1;            { Feld Nummer }
           StrPCopy(szName,'RecNo');      { Feld Name }
           iFldType   := fldINT32;    {Feld Typ}
           iSubType   := fldstAUTOINC;   { Feld Subtype }
           iUnits1    := 1;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 0;   { Offset in record }
           iLen       := 4;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      2: begin
           iFldNum    := 2;            { Feld Nummer }
           StrPCopy(szName,'Reihe');      { Feld Name }
           iFldType   := fldFLOAT;    {Feld Typ}
           iSubType   := fldUNKNOWN;   { Feld Subtype }
           iUnits1    := 1;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 4;   { Offset in record }
           iLen       := 8;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      3: begin
           iFldNum    := 3;            { Feld Nummer }
           StrPCopy(szName,'Name');      { Feld Name }
           iFldType   := fldZSTRING;    {Feld Typ}
           iSubType   := fldUNKNOWN;   { Feld Subtype }
           iUnits1    := 255;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 12;   { Offset in record }
           iLen       := 256;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
      4: begin
           iFldNum    := 4;            { Feld Nummer }
           StrPCopy(szName,'Source');      { Feld Name }
           iFldType   := fldBLOB;    {Feld Typ}
           iSubType   := fldstMEMO;   { Feld Subtype }
           iUnits1    := 100;   { Feld Groesse }
           iUnits2    := 0;   { Dezimalstellen }
           iOffset    := 268;   { Offset in record }
           iLen       := 101;   { Laenge in Bytes (0) }
           iNullOffset:=     0;    { For Null Bits }
           efldvVchk  := fldvNOCHECKS; { Validiy checks   ( 0 ) }
           efldrRights:= fldrREADWRITE { Rights }
         end;
    end;
  end;
  Result:= FLD;
end;

Function WNT_FORM_PDXidxDes(F: Integer): IDXDesc;
var ix: IdxDesc;
    i: Integer;
begin
  FillChar(Ix,sizeof(idxDesc),#0);
  with Ix do begin
    Case f of
      1: begin
           StrPCopy(szName,'');
           iIndexId   := 0;
           StrPCopy(szTagName,'');
           StrPCopy(szFormat,'');
           bPrimary   := TRUE;
           bUnique    := TRUE;
           bDescending:= FALSE;
           bMaintained:= TRUE;
           bSubset    := FALSE;
           bExpIdx    := FALSE;
           iCost      := 0;
           iFldsInKey := 1;
           iKeyLen    := 4;
           bOutofDate := FALSE;
           iKeyExpType:= 0;
           For i:= 0 to 15 do aiKeyFld[i]:= 0;
           aiKeyFld[0]:= 1;
           StrPCopy(szKeyExp,'');
           StrPCopy(szKeyCond,'');
           bCaseInsensitive:= FALSE;
           iBlockSize:= 2048;
           iRestrNum := 1;
           For i:= 0 to 15 do iUnUsed[i]:= 0;
         end;
      2: begin
           StrPCopy(szName,'BName');
           iIndexId   := 256;
           StrPCopy(szTagName,'');
           StrPCopy(szFormat,'');
           bPrimary   := FALSE;
           bUnique    := FALSE;
           bDescending:= FALSE;
           bMaintained:= TRUE;
           bSubset    := FALSE;
           bExpIdx    := FALSE;
           iCost      := 0;
           iFldsInKey := 1;
           iKeyLen    := 255;
           bOutofDate := FALSE;
           iKeyExpType:= 0;
           For i:= 0 to 15 do aiKeyFld[i]:= 0;
           aiKeyFld[0]:= 3;
           StrPCopy(szKeyExp,'');
           StrPCopy(szKeyCond,'');
           bCaseInsensitive:= TRUE;
           iBlockSize:= 2048;
           iRestrNum := 2;
           For i:= 0 to 15 do iUnUsed[i]:= 0;
         end;
      3: begin
           StrPCopy(szName,'BReihe');
           iIndexId   := 257;
           StrPCopy(szTagName,'');
           StrPCopy(szFormat,'');
           bPrimary   := FALSE;
           bUnique    := FALSE;
           bDescending:= FALSE;
           bMaintained:= TRUE;
           bSubset    := FALSE;
           bExpIdx    := FALSE;
           iCost      := 0;
           iFldsInKey := 1;
           iKeyLen    := 8;
           bOutofDate := FALSE;
           iKeyExpType:= 0;
           For i:= 0 to 15 do aiKeyFld[i]:= 0;
           aiKeyFld[0]:= 2;
           StrPCopy(szKeyExp,'');
           StrPCopy(szKeyCond,'');
           bCaseInsensitive:= TRUE;
           iBlockSize:= 2048;
           iRestrNum := 3;
           For i:= 0 to 15 do iUnUsed[i]:= 0;
         end;
    end;
  end;
  Result:= ix;
end;

Procedure WNT_FORM_PDXStruktur(FNummer: Integer;
                      var Fld: FldDesc;
                      var Idx: IdxDesc;
                      var FldCount: Byte;
                      var IdxCount: Byte);
var i: Integer;
begin
  FldCount:= 4; {FeldAnzahl}
  IdxCount:= 3; {IndexAnzahl}
  if FNummer < 0 then begin
    i:= abs(FNummer);
    FillChar(idx,Sizeof(IdxDesc),#0);
    if i <= 3 then Idx:= WNT_FORM_PDXidxDes(i);
  end
  else if FNummer > 0 then begin
    FillChar(Fld,Sizeof(FldDesc),#0);
    if FNummer <= 4 then Fld:= WNT_FORM_PDXFldDes(FNummer);
  end;
end;

end.
